Package: annmap
Type: Package
Title: Genome annotation and visualisation package pertaining to
        Affymetrix arrays and NGS analysis.
Description: annmap provides annotation mappings for Affymetrix exon
        arrays and coordinate based queries to support deep sequencing
        data analysis. Database access is hidden behind the API which
        provides a set of functions such as genesInRange(),
        geneToExon(), exonDetails(), etc. Functions to plot gene
        architecture and BAM file data are also provided. Underlying
        data are from Ensembl. The annmap database can be downloaded
        from:
        https://figshare.manchester.ac.uk/account/articles/16685071
Version: 1.53.0
Date: 2011-09-14
Author: Tim Yates <Tim.Yates@cruk.manchester.ac.uk>
Maintainer: Chris Wirth <Christopher.Wirth@cruk.manchester.ac.uk>
Depends: R (>= 2.15.0), methods, GenomicRanges
Imports: DBI, RMySQL (>= 0.6-0), digest, Biobase, grid, lattice,
        Rsamtools, genefilter, IRanges, BiocGenerics
Suggests: RUnit, rjson, Gviz
License: GPL-2
URL: https://github.com/cruk-mi/annmap
Collate: zzz.R db.R utils.R cache.R statements.R filtering.R utr.R
        coords.R ws.R plot.genomic.R plot.ngs.R si.R
biocViews: Annotation, Microarray, OneChannel, ReportWriting,
        Transcription, Visualization
Config/pak/sysreqs: libbz2-dev liblzma-dev libmysqlclient-dev
        libpng-dev libxml2-dev libssl-dev xz-utils zlib1g-dev
Repository: https://bioc.r-universe.dev
Date/Publication: 2025-10-29 14:11:14 UTC
RemoteUrl: https://github.com/bioc/annmap
RemoteRef: HEAD
RemoteSha: d64521eaa0fa6ab3681914f1e46494aa623aa92f
NeedsCompilation: no
Packaged: 2026-03-07 03:39:27 UTC; root
Built: R 4.6.0; ; 2026-03-07 03:52:08 UTC; unix

import( methods )
import( BiocGenerics )
import( IRanges )
import( GenomicRanges )
import( grid )
importFrom( genefilter, rowttests )
importFrom( lattice, draw.colorkey, panel.levelplot, level.colors, panel.grid, panel.fill )
importFrom( Rsamtools, ScanBamParam, scanBamFlag, scanBam )
importFrom( RMySQL, MySQL, dbEscapeStrings, dbMoreResults, dbNextResult )
importFrom( DBI, dbClearResult, dbConnect, dbDisconnect, dbHasCompleted, dbListResults, dbSendQuery, fetch )
importFrom( digest, digest )
importFrom( Biobase, exprs, pData )
exportPattern("^[^\\.]")

 8888b.  88888b.  88888b.  88888b.d88b.  8888b.   88888b. 
    "88b 888 "88b 888 "88b 888 "888 "88b    "88b  888 "88b
.d888888 888  888 888  888 888  888  888 .d888888 888  888
888  888 888  888 888  888 888  888  888 888  888 888 d88P
"Y888888 888  888 888  888 888  888  888 "Y888888 88888P"
                                                  888
                                                  888
                                                  888

  This is the annmap BioConductor package for use with the annmap database
available from: https://figshare.manchester.ac.uk/articles/dataset/ANNMAP_Database/16685071 

  For instructions on how to install that database, please see the README.TXT
file inside the downloads found on that page.

QUICKSTART:

  After installing this package, you will need to create a databases.txt file
inside a folder called .annmap in your home directory.

  An example of this file can be found in the root of this source package.

  This example file shows 2 databases installed on a MySQL server on the local
machine, with the 'username' dbuser and 'password' dbpwd

  The 'port' field can be left blank if you are using the standard MySQL port

  The 'password' can be left blank if you are not using a password

  All elements should be tab separated (tabs are still required, even if the
element is being left blank)

  The 'name' field is simply a user defined name for this database, which can be
passed to annmapConnect() as a parameter, or will be displayed to the user in a
menu if annmapConnect() is called with no parameters

Please let me know of any issues at marek.dynowski(at)cruk.manchester.ac.uk

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
    annmapDisconnect()
}

test.huisun.ANNMAP48 = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    checkTrue( length( proteinCoordsToGenome(protein.ids="ENSP00000369050", position=1, as.vector=TRUE, check.bounds=TRUE, truncate=TRUE) ) == 1, "Should return a single position" )
  }
}

test.ANNMAP112 = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    checkTrue( length( transcriptCoordsToGenome( transcriptDetails( 'ENST00000280979' ) ) ) == 1, "Transcript coords failing to convert to GRanges" )
    checkTrue( length( proteinCoordsToGenome( protein.ids="ENSP00000369050", position=1, as.vector=FALSE, check.bounds=TRUE, truncate=TRUE) ) == 1, "Should return a single GRanges position" )
  }
}

# Testing all of the statements (to make sure none of them crash)
# Testing for acutal responses is more tricky, as the responses may change from one
# release to the next...

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## Utility methods
##
.get.functions = function( func.type, func.pattern, min.len, name.build.function ) {
  .functions = ls( envir=annmap:::.xmap.queries )
  .queries = strsplit( .functions[ grep( func.pattern, .functions ) ], '\\.' )
  checkTrue( length( .queries ) >= min.len, paste( "Should have at least ", min.len, " '", func.type, "' functions", sep="" ) )
  r = lapply( .queries, function(i) {
    name = name.build.function( i )
    c( name, getFunction( name ) )
  } )
  r
}

.run.full.test.suite = function() {
  1 == length( grep( 'picr.man.ac.uk', Sys.info()[ 'nodename' ] ) )
}

.run.functions = function( functions, executor ) {
  lapply( c( 'hs-test' ), function( db ) {
    data = tryCatch( annmapConnect( db ), error=function(e) { FALSE } )
    if( length( data ) == 1 ) {
      print( paste( "Cannot find datasource '", db, "', so skipping these tests.", sep="" ) )
    }
    else {
      # Set this to true if this species has no arrays
      no.arrays = is.null( allArrays( as.vector=F ) )
      lapply( functions, function( func ) {
        if( no.arrays && length( grep( "rray|robe|hit|Hit|Est|est|rediction", func[[1]] ) ) == 1 ) {
          print( paste( "Skipping", func[[1]], "on", annmap:::.xmap.internals$db.name ) )
        }
        else {
          print( paste( "Running", func[[1]], "on", annmap:::.xmap.internals$db.name ) )
          tryCatch( executor( func[[1]], func[[2]] ), error=function(e) {
            traceback()
            print( e )
          } )
        }
      } )
    }
  } )
}

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
  annmapDisconnect()
}


test.gotsomefunctions = function() {
  checkTrue( length( ls( envir=annmap:::.xmap.queries ) ) >= 96, "Should have at least 96 functions" )
}

capitalise = function( name, initial=TRUE ) {
  name = sapply( name, function( s ) {
    s = strsplit( s, "_" )[[1]]
    s = paste( toupper( substring( s, 1, 1 ) ), substring( s, 2 ), sep="", collapse="" )
    if( !initial ) {
      s = paste( tolower( substring( s, 1, 1 ) ), substring( s, 2 ), sep="", collapse="" )
    }
    s
  } )
  name
}

test.all.queries = function() {
  if( .run.full.test.suite() ) {
    # Get all 'all' functions (of which there should be at least 14)
    .functions = .get.functions( 'all', '\\.all$', 14, function(i) { paste( 'all', capitalise( i[ 1 ] ), 's', sep="" ) } )
    # And run them, checking that we get at least one result from each
    .run.functions( .functions, function( name, f ) { r = f() ; checkTrue( length( r ) > 0, "Got no results!!" ) } )
  }
  else {
    print( '\nSkipping allXXX tests, as not on a PICR machine' )
  }
}

# Testing all of the statements (to make sure none of them crash)
# Testing for acutal responses is more tricky, as the responses may change from one
# release to the next...

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## Utility methods
##
.get.functions = function( func.type, func.pattern, min.len, name.build.function ) {
  .functions = ls( envir=annmap:::.xmap.queries )
  .queries = strsplit( .functions[ grep( func.pattern, .functions ) ], '\\.' )
  checkTrue( length( .queries ) >= min.len, paste( "Should have at least ", min.len, " '", func.type, "' functions", sep="" ) )
  r = lapply( .queries, function(i) {
    name = name.build.function( i )
    c( name, getFunction( name ) )
  } )
  r
}

.run.full.test.suite = function() {
  1 == length( grep( 'picr.man.ac.uk', Sys.info()[ 'nodename' ] ) )
}

.run.functions = function( functions, executor ) {
  lapply( c( 'hs-test', 'mm-test', 'rn-test', 'pb-test' ), function( db ) {
    data = tryCatch( annmapConnect( db ), error=function(e) { FALSE } )
    if( length( data ) == 1 ) {
      print( paste( "Cannot find datasource '", db, "', so skipping these tests.", sep="" ) )
    }
    else {
      # Set this to true if this species has no arrays
      no.arrays = is.null( allArrays( as.vector=F ) )
      lapply( functions, function( func ) {
        if( no.arrays && length( grep( "rray|robe|hit|Hit|Est|est|rediction", func[[1]] ) ) == 1 ) {
          print( paste( "Skipping", func[[1]], "on", annmap:::.xmap.internals$db.name ) )
        }
        else {
          print( paste( "Running", func[[1]], "on", annmap:::.xmap.internals$db.name ) )
          tryCatch( executor( func[[1]], func[[2]] ), error=function(e) {
            traceback()
            print( e )
          } )
        }
      } )
    }
  } )
}

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
  annmapDisconnect()
}

capitalise = function( name, initial=TRUE ) {
  name = sapply( name, function( s ) {
    s = strsplit( s, "_" )[[1]]
    s = paste( toupper( substring( s, 1, 1 ) ), substring( s, 2 ), sep="", collapse="" )
    if( !initial ) {
      s = paste( tolower( substring( s, 1, 1 ) ), substring( s, 2 ), sep="", collapse="" )
    }
    s
  } )
  name
}

test.gotsomefunctions = function() {
  checkTrue( length( ls( envir=annmap:::.xmap.queries ) ) >= 96, "Should have at least 96 functions" )
}

test.range.queries = function() {
  # Get all 'range' functions (of which there should be at least 9)
  .functions = .get.functions( 'range', '\\.range$', 9, function(i) { paste( capitalise( i[1], F ), 'InRange', sep="" ) } )

  # And run them (searching chromosome 1 for 1000 bases on the forward strand)
    .run.functions( .functions, function( name, f ) { f( '1', 1000, 2000, 1 ) } )
}

test.multi.queries = function() {
  data = tryCatch( annmapConnect( 'hs-test' ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    tp53 = geneDetails( symbolToGene( 'tp53' ) )
    shh  = geneDetails( symbolToGene( 'shh' ) )

    .chrf = if( annmap:::.usegranges() ) seqnames else space

    loc = data.frame( chr   = c( as.character( annmapGetParam( 'spacefn' )( tp53 ) ), as.character( annmapGetParam( 'spacefn' )( shh ) ) ),
                      start = c( as.integer(   start( tp53 ) ), as.integer(   start( shh ) ) ),
                      end   = c( as.integer(     end( tp53 ) ), as.integer(     end( shh ) ) ),
                      strand= c( strandAsInteger(     tp53   ), strandAsInteger(     shh   ) ) )

    # ok, try with vectors for params
    checkTrue( length( geneInRange( loc$chr, loc$start, loc$end, loc$strand ) ) >= 2,      'Should be at least 2 genes returned for vector range query' )
    checkTrue( annmap:::.attr( tp53, 'stable_id' ) %in% geneInRange( loc$chr, loc$start, loc$end, loc$strand, as.vector=T ), 'TP53 should be in range of itself and others' )
    checkTrue( annmap:::.attr( tp53, 'stable_id' ) %in% geneInRange( loc$chr, loc$start, loc$end, loc$strand, as.vector=T ),  'SHH should be in range of itself and others' )

    # Test return types
    checkTrue( is.vector( geneInRange( loc$chr, loc$start, loc$end, loc$strand, as.vector=T ) ),                'as.vector=T should return vector' )
    checkTrue( class( geneInRange( loc$chr, loc$start, loc$end, loc$strand, as.vector=F ) )[1] == annmapGetParam( 'defaultclass' ),  paste( 'as.vector=F should return', annmapGetParam( 'defaultclass' ) ) )
    checkTrue( is.data.frame( geneInRange( loc$chr, loc$start, loc$end, loc$strand, as.vector='data.frame' ) ), 'as.vector="data.frame" should return data.frame' )

    # Try with a data.frame as the x param
    checkTrue( length( geneInRange( loc, as.vector=T ) ) >= 2,      'Should be at least 2 genes returned for data.frame range query' )
    checkTrue( annmap:::.attr( tp53, 'stable_id' ) %in% geneInRange( loc, as.vector=T ), 'TP53 should be in range of itself and others with data.frame' )
    checkTrue( annmap:::.attr( shh,  'stable_id' ) %in% geneInRange( loc, as.vector=T ),  'SHH should be in range of itself and others with data.frame' )

    # Try with a RangedData object as the x param
    colnames(loc)[colnames(loc) == 'chr'] = 'space'
    rd.loc = as( loc, 'RangedData' )
    checkTrue( length( geneInRange( rd.loc, as.vector=T ) ) >= 2,      'Should be at least 2 genes returned for RangedData range query' )
    checkTrue( annmap:::.attr( tp53, 'stable_id' ) %in% geneInRange( rd.loc, as.vector=T ), 'TP53 should be in range of itself and others with RangedData' )
    checkTrue( annmap:::.attr( shh,  'stable_id' ) %in% geneInRange( rd.loc, as.vector=T ),  'SHH should be in range of itself and others with RangedData' )
  }
}

# Testing for the utility functions of the package

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
    annmapDisconnect()
}

.run.full.test.suite = function() {
  1 == length( grep( 'picr.man.ac.uk', Sys.info()[ 'nodename' ] ) )
}

test.ANNMAP33 = function() {
  if( !capabilities()["http/ftp"] ) {
    print( '\nSkipping webservice tests, no http/ftp capabilities' )
    return()
  }
  a = tryCatch( url( 'http://annmap.cruk.manchester.ac.uk', 'r' ), warning=function( w ) NULL, error=function( e ) NULL )
  if( is.null( a ) ) {
    print( '\nSkipping webservice tests, no route to annmap website' )
    return()
  }
  close( a )
  if( require( 'rjson', quietly=T ) ) {
    db = paste( 'homo_sapiens', fromJSON( file='http://annmap.cruk.manchester.ac.uk/data/init.js' )$items$homo_sapiens$currentVersion, sep='.' )
    annmapConnect( db, use.webservice=T )
    annmapSetParam( debug=T )
    exons = geneToExon( symbolToGene( 'tp53' ), as.vector=TRUE )
    checkTrue( length( exons ) > 1, 'Expected more than one exon from geneToExon via webservice' )
    annmapDisconnect()
  }
}

test.connection = function() {
  if( !capabilities()["http/ftp"] ) {
    print( '\nSkipping webservice tests, no http/ftp capabilities' )
    return()
  }

  a = tryCatch( url( 'http://annmap.cruk.manchester.ac.uk', 'r' ), warning=function( w ) NULL, error=function( e ) NULL )
  if( is.null( a ) ) {
    print( '\nSkipping webservice tests, no route to annmap website' )
    return()
  }
  close( a )

  if( require( 'rjson', quietly=T ) ) {
    db = paste( 'homo_sapiens', fromJSON( file='http://annmap.cruk.manchester.ac.uk/data/init.js' )$items$homo_sapiens$currentVersion, sep='.' )
    annmapConnect( db, use.webservice=T )

    chrs = chromosomeDetails( allChromosomes() )
    checkTrue( length( chrs ) == 25, 'Should have got 25 rows via chromosomeDetails via WS' )

    annmapDisconnect()
  }
}

# This script builds the cookbook if the correct DB name is set up
# Or else does nothing, and leaves the PDF where it is...
#
# http://bit.ly/delia_smith

library( "annmap" )

data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
if( length( data ) == 1 ) {
	# The here's one I prepared earlier shortcut
	message( "Cannot find datasource 'hs-test', I'm not going to build the cookbook." )
} else {
	message( "Generating cookbook..." )
	# First, we'll disconnect, so the Rnw gets a fresh start
	annmapDisconnect()
	
	current.path = getwd()
	path <- file.path( getwd(), "..", "inst/cookbook" )
	setwd( path )
	# Parse the Rnw
	library(tools)
	utils::Sweave( 'cookbook.Rnw' )

	# Generate the PDF
	texi2dvi( 'cookbook.tex', pdf=T, clean=T )

	# Copy it to the docs
	file.copy( 'cookbook.pdf', file.path( path, '../..', 'vignettes' ), overwrite=T )

	# cleanup
	unlink( 'cookbook.pdf' )
	unlink( 'cookbook.tex' )
	unlink( 'bridge1.png' )
	unlink( 'bridge2.png' )
	unlink( 'bridge3.png' )
	unlink( 'bridge4.png' )
	unlink( 'bridge5.png' )
	unlink( 'gviz1.png' )
	unlink( 'fig1.pdf' )
	unlink( 'fig2.pdf' )
	unlink( 'fig3.pdf' )
	unlink( 'fig4.pdf' )
	unlink( 'fig5.pdf' )
	unlink( 'fig6.pdf' )
	unlink( 'fig7.pdf' )
	unlink( 'fig8.pdf' )
	unlink( 'fig9.pdf' )
	unlink( 'fig10.pdf' )

	setwd( current.path )
}

library( grid )
library(annmap)

annmapConnect( 'pb-test' )

files  = list( 'Asyn_0mm', 'Syn0_0mm',     list( 'Asyn_0mm', 'Syn0_0mm' ) )
total.reads = c( 690174, 1880786,       690174 + 1880786 )
.labels = list( bquote( sigma * "value   "), '2nd Sample   ', bquote( Delta * "value   ") ) 

.genes = data.frame( stable_id=c( 'SPAC8E11.03c','SPAC3C7.03c','SPBC32H8.06' ),
                     symbol   =c( 'dmc1',        'rhp55',      'mug93'       ),
                     chr      =c( 'I',           'I',          'II'          ),
                     start    =c( 3380288,       2063075,      1460675       ),
                     end      =c( 3386088,       2068875,      1466475       ) )

.regions = list(
  data.frame( start    =c( 3381288, 3381288, 3385000 ),
              end      =c( 3381388, 3381488, 3386000 ),
              strand   =c( 1,       1,       -1 ),
              name     =c( 'danny1', 'danny2', 'antidanny' ) ),
  data.frame(),
  data.frame()
)

danny.normalisation = function( rle.object, sample.read.count, width ) {
  .val = log2( ( 1e10 * ( runValue( rle.object ) / ( sample.read.count * width ) ) ) + 0.00001 )
  # Clamp to zero (can end up with negatives from normalisation)
  runValue( rle.object ) = ifelse( .val < 0, 0, .val )
  rle.object
}

grid.newpage()

ngenes = length( as.character( .genes$stable_id ) )
pushViewport(viewport(layout=grid.layout(1, ngenes, widths=unit( 1.0 / ngenes, "npc"), heights=unit(1, "npc"), just=c('left','bottom'))))

invisible( lapply( seq_along( .genes$stable_id ), function( idx ) {
  pushViewport( viewport(layout.pos.col=idx, layout.pos.row=1) )
  row = .genes[ idx, ]
  data = lapply( seq_along( files ), function( fidx ) {
    f = files[[ fidx ]]
    .fn = paste( '/groups/acbb/to.keep/tyates/acbbutil_example_files/', f, '.bam', sep='' )
    .rle = convertBamToRle( .fn, as.character(row$chr), row$start, row$end, chr.name.mapping=function(n) { paste( 'EG:', n, sep='' ) } )
    .read.count = total.reads[ idx ]
    list( rle=list( '+'=danny.normalisation( .rle$'+', .read.count, row$end - row$start ), '-'=danny.normalisation( .rle$'-', .read.count, row$end - row$start ) ),
          col=rainbow(length( as.character( .genes$stable_id ) ), v=0.5, s=0.5)[ fidx ],
          name=.labels[[ fidx ]] )
  } )
  .sym = as.character( row$symbol )
  .chr = as.character( row$chr )
  ngsBridgePlot( as( data.frame( space=.chr, start=row$start, end=row$end ), 'RangedData' ),
                  data=data,
                  highlights=.regions[[idx]],
                  main=bquote( italic( .(.sym) ) * ' (chr' * .(.chr) * ')' ),
                  probe.plot=NULL,
                  trace.label.properties=NULL,
                  gene.area.height=3,
                  drop.partial=T )
  popViewport()
} ) )
popViewport()

# Testing all of the statements (to make sure none of them crash)
# Testing for acutal responses is more tricky, as the responses may change from one
# release to the next...

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## Utility methods
##
.get.functions = function( func.type, func.pattern, min.len, name.build.function ) {
  .functions = ls( envir=annmap:::.xmap.queries )
  .queries = strsplit( .functions[ grep( func.pattern, .functions ) ], '\\.' )
  checkTrue( length( .queries ) >= min.len, paste( "Should have at least ", min.len, " '", func.type, "' functions", sep="" ) )
  r = lapply( .queries, function(i) {
    name = name.build.function( i )
    c( name, getFunction( name ) )
  } )
  r
}

.run.full.test.suite = function() {
  1 == length( grep( 'picr.man.ac.uk', Sys.info()[ 'nodename' ] ) )
}

.run.functions = function( functions, executor ) {
  lapply( c( 'hs-test', 'mm-test', 'rn-test', 'pb-test' ), function( db ) {
    data = tryCatch( annmapConnect( db ), error=function(e) { FALSE } )
    if( length( data ) == 1 ) {
      print( paste( "Cannot find datasource '", db, "', so skipping these tests.", sep="" ) )
    }
    else {
      # Set this to true if this species has no arrays
      no.arrays = is.null( allArrays( as.vector=F ) )
      lapply( functions, function( func ) {
        if( no.arrays && length( grep( "rray|robe|hit|Hit|Est|est|rediction", func[[1]] ) ) == 1 ) {
          print( paste( "Skipping", func[[1]], "on", annmap:::.xmap.internals$db.name ) )
        }
        else {
          print( paste( "Running", func[[1]], "on", annmap:::.xmap.internals$db.name ) )
          tryCatch( executor( func[[1]], func[[2]] ), error=function(e) {
            traceback()
            print( e )
          } )
        }
      } )
    }
  } )
}

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
  annmapDisconnect()
}

capitalise = function( name, initial=TRUE ) {
  name = sapply( name, function( s ) {
    s = strsplit( s, "_" )[[1]]
    s = paste( toupper( substring( s, 1, 1 ) ), substring( s, 2 ), sep="", collapse="" )
    if( !initial ) {
      s = paste( tolower( substring( s, 1, 1 ) ), substring( s, 2 ), sep="", collapse="" )
    }
    s
  } )
  name
}

test.gotsomefunctions = function() {
  checkTrue( length( ls( envir=annmap:::.xmap.queries ) ) >= 96, "Should have at least 96 functions" )
}

test.transcript.to.translatedprobes = function() {
  data = tryCatch( annmapConnect( 'hs-test' ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( paste( "Cannot find datasource 'hs-test', so skipping these tests.", sep="" ) )
  }
  else {
    transcripts = geneToTranscript( symbolToGene( 'TP53' ), as.vector=TRUE )
    checkTrue( length( transcriptToTranslatedprobes( transcripts ) ) == length( transcripts ), "vector transcriptToTranslatedprobes lengths differ" )
    transcripts = geneToTranscript( symbolToGene( 'TP53' ) )
    if( annmap:::.usegranges() ) {
      checkTrue( length( transcriptToTranslatedprobes( transcripts ) ) == length( transcripts ), "GRanges transcriptToTranslatedprobes lengths differ" )
    }
    else {
      checkTrue( length( transcriptToTranslatedprobes( transcripts )[[1]] ) == length( transcripts ), "RangedData transcriptToTranslatedprobes lengths differ" )
    }

    # Check that bad transcript names doesn't crash
    bad = transcriptToTranslatedprobes( 'bad' )
    checkTrue( length( bad ) == 1,         "Should still return a single item" )
    checkTrue( names( bad ) == c( 'bad' ), "Should have the original name" )
    checkTrue( is.null( bad$bad ),         "And it should be null" )

    # Check that bad transcript names doesn't crash
    transcripts = c( 'ENST00000455263', 'bad', 'ENST00000414315' )
    bad = transcriptToTranslatedprobes( transcripts )
    checkTrue( length( bad ) == length( transcripts ), "Should return same number of objects" )
    checkTrue( all( names( bad ) == transcripts ),     "Names should remain the same, in the same order" )
    checkTrue( is.null( bad$bad ),                     "And the middle one should be null" )
  }
}

test.to.queries = function() {
  # Get all 'to' functions (of which there should be at least 58)
  .functions = .get.functions( 'to', '\\.to\\.', 58, function(i) { paste( capitalise( i[1], F ), 'To', capitalise( i[3] ), sep="" ) } )

  # And run them, searching for the thing called 'InvalidId' which should return no results, but not crash)
    .run.functions( .functions,  function( name, f ) {
    if( !.run.full.test.suite() && name == "arrayToProbeset" ) {
      print( '\nSkipping array.to.probeset test, as not on a PICR machine' )
    }
    else {
      r = f( 'InvalidId' )
      if( name == "arrayToProbeset" ) {
        checkTrue( length( r ) > 0, "should have some probesets for an array" )
      }
      else {
        checkTrue( is.null( r ), "should return null" )
      }
    }
  } )
}

test.expr.query = function() {
  data = tryCatch( annmapConnect( 'hs-test' ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( paste( "Cannot find datasource 'hs-test', so skipping these tests.", sep="" ) )
  }
  else {
    if( Sys.getenv( "RCMDCHECK" ) == "FALSE" ) {
      path = file.path( getwd(), "..", "inst", "rdata" )
    }
    else {
      path = system.file( package=pkg, "rdata" )
    }
    lapply( allArrays( as.vector=TRUE ), function( arr ) {
      arrayType( arr )
      file.name = file.path( path, paste( arr, 'tp53.expr.RData', sep='.' ) )
      if( file.exists( file.name ) ) {
        env = new.env()
        print( paste( 'Loading', file.name ) )
        load( file.name, env )
        o.name = ls( env )[ 1 ]
        print( paste( 'Using variable', o.name ) )
        rslt = geneToExonProbesetExpr( get( o.name, envir=env ), symbolToGene( 'tp53' ) )
        rslt.dim = dim( rslt )
        checkTrue( rslt.dim[ 1 ] > 0, 'Should have rows in out exprs result data' )
        checkTrue( rslt.dim[ 2 ] > 0, 'Should have columns in out exprs result data' )
      }
      else {
        print( paste( '***WARN*** Cannot find file', file.name, 'to test gene.to.exon.probeset.expr for', arr ) )
      }
    } )
  }
}

.make.hash = function() {
  new.env( hash=TRUE, parent=emptyenv() )
}

# A global holding our internal state (as a hash, as hashes are mutable in R)
.xmap.internals = .make.hash()

annmapAddConnection = function( dsname, species, version,
                                host='localhost',
                                username=as.character( Sys.info()[ 'user' ] ),
                                password='',
                                port='',
                                overwrite=FALSE,
                                testConnect=TRUE ) {
  if( missing( dsname ) || missing( species ) || missing( version ) ) {
    stop( "Must specify a dsname, species and version" )
  }
  if( is.null( .xmap.internals$initialised ) ) {
    .initialise()
  }
  dsname = as.character( dsname )
  species = as.character( species )
  version = as.character( version )
  host = as.character( host )
  username = as.character( username )
  password = as.character( password )
  port = as.character( port )
  if( testConnect == TRUE ) {
    con = .get.connection( species, version, username, password, host, port )
    if( is.null( con$con ) ) {
      cat( message( con$err ) )
      cat( '\n' )
      stop( paste( 'Could not connect to database, tried', paste( c( 'annmap_', 'xmapcore_' ), species, '_', version, sep='', collapse=', ' ), 'on server', host ) )
    }
    dbDisconnect( con$con )
  }
  .files = c( .xmap.internals$conf.dir, file.path( .xmap.internals$conf.dir, "databases.txt" ) )
  .exists = file.exists( .files )
  .access = file.access( .files, mode=2 )
  if( .exists[ 1 ] == FALSE ) {
    stop( paste( "Cannot locate configuration directory", .files[ 1 ] ) )
  }
  if( .access[ 1 ] != 0 ) {
    stop( paste( "No write access to configuration directory", .files[ 1 ] ) )
  }
  if( .exists[ 2 ] == TRUE && .access[ 2 ] != 0 ) {
    stop( paste( "No write access to configuration file", .files[ 2 ] ) )
  }
  .method = 'added.'
  .db = if( .exists[ 2 ] == FALSE ) {
    # Make a new data.frame
    data.frame( name=dsname, host=host, species=species, version=version, port=port, username=username, password=password )
  }
  else {
    # Load existing and append
    db = .read.databases( .files[ 2 ], stringsAsFactors=FALSE )
    if( dsname %in% db[,'name'] ) {
      if( overwrite == FALSE ) {
        stop( paste( "A connection with the name", dsname, "already exists" ) )
      }
      .method = 'updated.'
      db[ db$name == dsname, ] = list( name=dsname, host=host, species=species, version=version, port=port, username=username, password=password )
    }
    else {
      db = rbind( db, list( name=dsname, host=host, species=species, version=version, port=port, username=username, password=password ) )
    }
    db
  }
  cat( paste( 'Connection', dsname, .method, '\n' ) )
  # Then write this back out...
  write.table( .db, .files[ 2 ], quote=FALSE, sep=',', row.names=FALSE )
  invisible( list( host=host, species=species, version=version, port=port, username=username, password=password ) )
}

# Exported functions
annmapConnect = function( name, use.webservice=FALSE, quiet.webservice=FALSE ) {
  if( ( use.webservice  &&  is.null( .xmap.internals$webservice ) ) ||
      ( !use.webservice && !is.null( .xmap.internals$webservice ) ) ||
      ( is.null( .xmap.internals$initialised ) ) ) {
    .initialise()
  }
  if( use.webservice ) {
    if( !capabilities()["http/ftp"] ) {
      stop( 'The version of R you are using is not built with http capability.' )
    }
    wshost = annmapGetParam( "wshost" )
    if( is.null( wshost ) ) {
      wshost = 'http://annmap.cruk.manchester.ac.uk'
    }
    a = tryCatch( url( wshost ), warning=function( w ) NULL, error=function( e ) NULL )
    if( is.null( a ) ) {
      if ( wshost == 'http://annmap.cruk.manchester.ac.uk' ) {
        stop( 'http://annmap.cruk.manchester.ac.uk is no longer available' )
      } else {
        stop( paste( 'Cannot connect to ', wshost, '. Are you sure you have an internet connection?', sep='' ) )
      }
    }
    close( a )
    if( !require( 'rjson', quietly=T ) ) { 
      message( 'Package rjson is required for webservice connection.' )
      if( interactive() ) {
        message( 'Attempting to install' )
        install.packages( 'rjson' )
        message( 'Ok, trying to load rjson again.' )
        require( 'rjson' )
      }
      else {
        stop( 'Please install rjson and try again.' )
      }
    }
    .param.cache = annmapGetParam( "procs" )
    .procs = .make.hash()
    .procs$all = .xmcws.all
    .procs$details = .xmcws.details
    .procs$to = .xmcws.to
    .procs$range = .xmcws.range
    .procs$params = .ws.make.params
    .procs$connect = .xmcws.connect
    .procs$disconnect = .xmcws.disconnect
    annmapSetParam( procs=.procs )
    annmapSetParam( webservice=TRUE )
    annmapSetParam( quiet.webservice=quiet.webservice )
    annmapGetParam( "debugFn" )( "Using WebService for data access.\n" )
  }
  else {
    annmapSetParam( webservice=NULL )
  }
  .xmap.internals$procs$connect( name )
}

annmapDisconnect = function() {
  .xmap.internals$procs$disconnect()
}

.read.databases = function( f, ... ) {
  a = tryCatch( read.table( f, sep="\t", strip.white=TRUE, header=TRUE, fill=TRUE, colClasses='character', ... ), error=function(e) { data.frame( bad=TRUE ) } )
  if( !all( colnames( a ) == c( "name", "host", "species", "version", "port", "username", "password" ) ) ) {
    a = read.table( f, sep=",", strip.white=TRUE, header=TRUE, fill=TRUE, colClasses='character', ... )
  }
  if( !all( colnames( a ) == c( "name", "host", "species", "version", "port", "username", "password" ) ) ) {
    stop( paste( "Unexpected column names in", 
            f,
            " - should be 'name', 'host', 'species', 'version', 'port', 'username' and 'password'" ) )
  }
  a
}

.get.connection = function( species, version, un, pw, host, port, db.prefixes=c( 'annmap_', 'xmapcore_' ) ) {
  for( i in 1:length( db.prefixes ) ) {
    db.name = paste( db.prefixes[ i ], species, "_", version, sep="" )
    if( is.na( port ) || is.null( port ) || port == '' ) {
      con = tryCatch( dbConnect( MySQL(), user=un, password=pw, dbname=db.name, host=host, client.flag=131072 ), error=function(e) e )
    }
    else {
      con = tryCatch( dbConnect( MySQL(), user=un, password=pw, dbname=db.name, host=host, port=as.numeric( port ), client.flag=131072 ), error=function(e) e )
    }
    if( !is.null( con ) && all( class( con ) != 'simpleError' ) ) {
      return( list( con=con, db.name=db.name, err=NULL ) )
    }
  }
  list( con=NULL, db.name=NULL, err=con )
}

# Internal functions
.xmc.connect = function( name ) {
  f = .xmap.internals$conf.dir
  f = file.path( f, "databases.txt" )
  if( !file.exists( f ) ) {
    stop( paste( "Can't find database config file '",
            f,
            "'. See package installation instructions for help setting this up.",
            sep="" ) )
  }
  a = .read.databases( f )
  if( missing( name ) ) {
    r = 1
    if( dim( a )[1] > 1 ) {
      choices = paste( as.character( a[,1] ), " -- ", as.character( a[,3] ), " v", as.character( a[,4] ), " (", as.character( a[,2] ), ")", sep="" )
      r = menu( choices, title="Select a database to connect to:" )
    }
    if( r == 0 ) {
      return( invisible() )
    }
    else {
      name = a[,1][r]
    }
  }
  dbs = a[ ( as.character( a$name ) == name ), , drop=FALSE ]
  if( dim( dbs )[1] == 0 ) {
    stop( paste( "Invalid db name:", name ) )
  }
  un = .get.user.string( as.character( dbs[,"username"] ), "username" )
  if( is.na( dbs[,"password"] ) ) {
    pw = ""
  }
  else {
    pw = .get.user.string( as.character( dbs[,"password"] ), "password" )
  }
  annmapDisconnect()
  species = as.character( dbs[,"species"] )
  version = as.character( dbs[,"version"] )
  host = as.character( dbs[,"host"] )
  port = as.character( dbs[,"port"] )
  con = .get.connection( species, version, un, pw, host, port )
  if( is.null( con$con ) ) {
    cat( message( con$err ) )
    cat( '\n' )
    stop( paste( 'Could not connect to database, tried', paste( c( 'annmap_', 'xmapcore_' ), species, '_', version, sep='', collapse=', ' ), 'on server', host ) )
  }
  .xmap.internals$con       = con$con
  .xmap.internals$species   = species
  .xmap.internals$version   = version
  .xmap.internals$host      = host
  .xmap.internals$port      = port
  .xmap.internals$db.name   = con$db.name
  .xmap.internals$connected = TRUE

  cat( paste( 'Connected to ', .xmap.internals$db.name, ' (', .xmap.internals$host, ')\n', sep='' ) )

  arrayType( NULL, pick.default=TRUE )

  invisible( list( host=host, species=species, version=version, port=port, username=un, password=pw ) )
}

.xmc.disconnect = function() {
  if( !is.null( .xmap.internals$con ) ) {
    cat( paste( 'Disconnecting from ', .xmap.internals$db.name, ' (', .xmap.internals$host, ')\n', sep='' ) )
    dbDisconnect( .xmap.internals$con )
    tryCatch( rm( 'con',       envir=.xmap.internals ), warning=function(a){invisible()} )
    tryCatch( rm( 'species',   envir=.xmap.internals ), warning=function(a){invisible()} )
    tryCatch( rm( 'array',     envir=.xmap.internals ), warning=function(a){invisible()} )
    tryCatch( rm( 'db.name',   envir=.xmap.internals ), warning=function(a){invisible()} )
  }
  .xmap.internals$connected = FALSE
}

.xmc.db.cleanup = function( conn ) {
  res = dbListResults( conn )
  for( i in res )  {
    if( !dbHasCompleted( i ) ) {
      fetch( i, -1 )
      dbClearResult( i )
    }
  }
  while( dbMoreResults( conn ) ) {
    res = dbNextResult( conn )
    if( !dbHasCompleted( res ) ) {
      fetch( res, -1 )
      dbClearResult( res )
    }
  }
}

.xmc.db.call = function( sql, conn ) {
  .xmap.internals$debugFn( sql )
  on.exit( .xmc.db.cleanup( conn ) )
  res  = dbSendQuery( conn, sql )
  d    = fetch( res, -1 )
  if( length( d ) == 0 ) {
    d = NULL
  }
  d
}

.build.sql2 = function( stmt, hash ) {
  if( !is.null( hash ) ) {
    vars = ls( envir=hash )
    for( var in vars ) {
      val = get( var, envir=hash )
      patt = paste( "\\$\\{", var, "\\}", sep="" )
      stmt = gsub( patt, val, stmt )
    }
  }
  stmt
}

# This is a blank template for an RUnit test file

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
    annmapDisconnect()
}

# An example test
test.template = function() {
  checkTrue( TRUE,        "True should be TRUE" )
  checkEquals( TRUE, TRUE, "And this should be ok too" )
}

# Testing for the utility functions of the package

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
    annmapDisconnect()
}

# Crash if no genes in genome.plot
test.bug.ACBBUTIL33 = function() {
  data = tryCatch( annmapConnect( "mm-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'mm-test', so skipping this test." )
  }
  else {
    # Plot to the null device, we're just looking for a crash
    pdf( file = NULL )
    region_interest = RangedData( space='7', strand=-1, ranges=IRanges(start=3192050-5000, end=3202400+5000 ) )
    ngsBridgePlot( region_interest, genome.layout.weight=0.4, trace.clip=T, trace.pad=c(0.5,0), trace.bor = 'black', smoothing.function=NULL, probe.plot=NULL )
    dev.off()
    annmapDisconnect()
  }
}

test.bug.ANNMAP40 = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping this test." )
  }
  else {
    # Plot to the null device, we're just looking for a crash
    pdf( file = NULL )

    probe.data = "
probe_id                      name probe_hit_count   hit_id probe_id chromosome_id chromosome_name     start       end strand
1   878986 GTCCGCTTCTCGCCCAACAGCAGCA               1  3511083   878986         27527               5 180666528 180666552     -1
2  3447395 TTGTGTCCGCTTCTCGCCCAACAGC               1 16527596  3447395         27527               5 180666532 180666556     -1
3  1610367 TGTCTTGTGTCCGCTTCTCGCCCAA               1  7005397  1610367         27527               5 180666536 180666560     -1
4  1984140 GGTGTCTTGTGTCCGCTTCTCGCCC               1  8616662  1984140         27527               5 180666538 180666562     -1
"
    # Load the data in
    pcon = textConnection( probe.data )
    probes = read.table( pcon, header=TRUE )
    close( pcon )

    genomicPlot( RangedData( ranges=IRanges( 180666487, 180666582 ), space='5', strand=-1 ), highlights=probes )

    # Try with col added
    genomicPlot( RangedData( ranges=IRanges( 180666487, 180666582 ), space='5', strand=-1 ), highlights=cbind( probes, col='#000000' ) )

    # Try with important column missing
    ret = tryCatch( { genomicPlot( RangedData( ranges=IRanges( 180666487, 180666582 ), space='5', strand=-1 ), highlights=probes[ , colnames( probes ) != 'name' ] ) ; FALSE }, 
                    warning=function( w ) { TRUE } )
    print( ret )
    checkEquals( ret, TRUE, 'Should throw a warning with missing highlight fields' )

    dev.off()
    annmapDisconnect()
  }
}

test.bug.ANNMAP44 = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping this test." )
  }
  else {
    # Plot to the null device, we're just looking for a crash
    pdf( file = NULL )

    # This shouldn't crash, but did for ANNMAP44
    genomicPlot( exonDetails( 'ENSE00000919490' ) )
    dev.off()
    annmapDisconnect()
  }
}

# Testing for the db functions of the package

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## Create a test environment
##
.test.env = new.env( hash=TRUE, parent=emptyenv() )
.conf.dir = ''
###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
  # Call initialise
  annmap:::.initialise()
  .test.env$.conf.dir = annmapGetParam( 'conf.dir' )
  print( paste( 'Got conf.dir', .test.env$.conf.dir ) )
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
  print( paste( 'Resetting conf.dir to', .test.env$.conf.dir ) )
  annmapSetParam( conf.dir=.test.env$.conf.dir )
  annmapDisconnect()
}

test.databases.txt = function() {
  if( Sys.getenv( "RCMDCHECK" ) == "FALSE" ) {
    path = file.path( getwd(), "..", "inst", "unitTests" )
  }
  else {
    path = system.file( package=pkg, "unitTests" )
  }
  .procs = annmapGetParam( 'procs' )
  print( 'Mocking annmapConnect()' )
  .procs$connect = function( name ) {
    f = annmapGetParam( 'conf.dir' )
    f = file.path( f, "databases.txt" )
    if( !file.exists( f ) ) {
      stop( paste( "Can't find database config file '", f, "'. See package installation instructions for help setting this up.", sep="" ) )
    }
    a = read.table( f, sep="\t", strip.white=TRUE, header=TRUE )
    if( !all( colnames( a ) == c( "name", "host", "species", "version", "port", "username", "password" ) ) ) {
      a = read.table( f, sep=",", strip.white=TRUE, header=TRUE )
    }
    if( !all( colnames( a ) == c( "name", "host", "species", "version", "port", "username", "password" ) ) ) {
      stop( paste( "Unexpected column names in",  f, " - should be 'name', 'host', 'species', 'version', 'port', 'username' and 'password'" ) )
    }
    dbs = a[ ( as.character( a$name ) == name ), , drop=FALSE ]
    if( dim( dbs )[1] == 0 ) { stop( paste( "Invalid db name:", name ) ) }
    as.character( dbs[,"host"] )
  }
  annmapSetParam( procs=.procs )
  print( paste( 'setting conf.dir to', file.path( path, 'tabConfig' ) ) )
  annmapSetParam( conf.dir = file.path( path, 'tabConfig' ) )
  checkEquals( annmapConnect( 'testdb' ), 'localhost', 'Should connect to localhost with tab separated config' )
  print( paste( 'setting conf.dir to', file.path( path, 'commaConfig' ) ) )
  annmapSetParam( conf.dir = file.path( path, 'commaConfig' ) )
  checkEquals( annmapConnect( 'testdb' ), 'localhost', 'Should connect to localhost with comma separated config' )

  print( 'restoring connect method' )
  .procs$connect = annmap:::.xmc.connect
  annmapSetParam( procs=.procs )
}

test.connection = function() {
  checkEquals( annmapGetParam( "connected" ), FALSE, "Start not connected to anything" )
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    checkTrue( annmapGetParam( "connected" ), "Should now be connected" )
    annmapDisconnect()
    checkTrue( !annmapGetParam( "connected" ), "And connected status should be FALSE" )
  }
}

test.buildsql = function() {
  test.hash = new.env( hash=TRUE )
  test.hash$a = "p1"
  test.hash$b = "p2"
  test.hash$c = "p3"
  sql = annmap:::.build.sql2( "Parameter replacement for ${a}, ${b} and ${c} should be ok", test.hash )
  checkEquals( sql, paste( "Parameter replacement for ", test.hash$a, ", ", test.hash$b, " and ", test.hash$c, " should be ok", sep="" ) )
}

test.addConnection = function() {
  # Check if hs-test exists (set returned values into a DB var)
  db = tryCatch( annmapConnect( "hs-test" ), error=function(e) { NULL } )
  # disconnect
  annmapDisconnect()

  tmp = '/tmp'
  if( file.exists( tmp ) ) {
    # Set ANNMAP_HOME to /tmp
    annmapSetParam( conf.dir=tmp )

    # remove databases.txt if it exists
    databases.txt = file.path( annmapGetParam( 'conf.dir' ), 'databases.txt' ) 
    unlink( databases.txt )

    checkValues = function( test, name, species, version, username='', password='', host='localhost', port='' ) {
      get.row = function() {
        tab = annmap:::.read.databases( databases.txt, stringsAsFactors=FALSE )
        tab[ tab$name == name, ]
      }
      .row = get.row()
      for( field in tail( names( formals() ), n=-1 ) ) {
        a = .row[[ field ]]
        b = get( field )
        checkTrue( all.equal( a, b ),
                   paste( field, "differs -- Test", test, "|", a, class( a ), "!=", b, class( b ) ) )
      }
    }

    # add a new connection (testConnect=FALSE, as there is no db)
    annmapAddConnection( 'a', 'fish', '64', username='testing', testConnect=FALSE )
    # load databases.txt and check all fields are there
    checkValues( 'test1', 'a', 'fish', '64', username='testing' )

    # add a new connection (testConnect=FALSE, as there is no db)
    annmapAddConnection( 'b', 'fash', '64', username='testing', testConnect=FALSE )
    # Check again
    checkValues( 'test2', 'a', 'fish', '64', username='testing' )
    checkValues( 'test2', 'b', 'fash', '64', username='testing' )

    # update a connection with overwrite=TRUE
    annmapAddConnection( 'a', 'goose', '64', username='testing', testConnect=FALSE, overwrite=TRUE )
    # Check again
    checkValues( 'test3', 'a', 'goose', '64', username='testing' )
    checkValues( 'test3', 'b', 'fash', '64', username='testing' )

    # if !DB var exists GOTO last line
    if( !is.null( db ) ) {
      # add a new connection with the DB var's details (this will test connection)
      annmapAddConnection( 'working', db$species, db$version, host=db$host, username=db$username, password=db$password, port=db$port )
      # Check again
      checkValues( 'test4', 'a', 'goose', '64', username='testing' )
      checkValues( 'test4', 'b', 'fash', '64', username='testing' )
      checkValues( 'test4', 'working', db$species, db$version, username=db$username, password=db$password, host=db$host, port=db$port )
      # Try again with port set to the default
      annmapAddConnection( 'working', db$species, db$version, host=db$host, username=db$username, password=db$password, port='3306', overwrite=TRUE )
      # Check again
      checkValues( 'test4', 'a', 'goose', '64', username='testing' )
      checkValues( 'test4', 'b', 'fash', '64', username='testing' )
      checkValues( 'test4', 'working', db$species, db$version, username=db$username, password=db$password, host=db$host, port='3306' )
      # And make sure we fail when something ropey is added
      checkTrue( tryCatch( annmapAddConnection( 'working', db$species, db$version, host='idontexist', username=db$username, password=db$password, port='3306', overwrite=TRUE ),
                    error=function( e ) { TRUE } ), "Should have failed to add connection to idontexist server" )
      # Make sure our old settings remain..
      checkValues( 'test4', 'a', 'goose', '64', username='testing' )
      checkValues( 'test4', 'b', 'fash', '64', username='testing' )
      checkValues( 'test4', 'working', db$species, db$version, username=db$username, password=db$password, host=db$host, port='3306' )
    }
    # remove databases.txt
    unlink( databases.txt )
  }
}

if( require( "RUnit", quietly=TRUE ) ) {
  pkg <- "annmap"
 
  if( Sys.getenv( "RCMDCHECK" ) == "FALSE" ) {
    path <- file.path( getwd(), "..", "inst", "unitTests" )
  }
  else {
    path <- system.file( package=pkg, "unitTests" )
  }

  cat( "\nRunning unit tests\n" )
  print( list( pkg=pkg, getwd=getwd(), pathToUnitTests=path ) )
  library( package=pkg, character.only=TRUE )

  annmapClearCache()

  # Run the old style RangedData for tim...
  #annmapSetParam( oldstylekey='P0fSpS' )
  annmapSetParam( spacefn=if( annmap:::.usegranges() ) seqnames else space )
  annmapSetParam( defaultclass=if( annmap:::.usegranges() ) 'GRanges' else 'RangedData' )

  #Fail on warnings
  options( warn=2 )

  # Get the pattern (if there is one?)
  patt = Sys.getenv( "RUNITFILEPATTERN" )
  func = Sys.getenv( 'RUNITFUNCPATTERN' )
  if( is.null( patt ) || nchar( patt ) == 0 ) {
    patt = "^runit.+\\.[rR]$"
  }
  else {
    patt = paste( "^runit\\.", patt, "\\.[rR]$", sep="" )
  }
  if( is.null( func ) || nchar( func ) == 0 ) {
    func = "^test.+"
  }
  else {
    func = paste( "^test\\.", func, ".+", sep="" )
  }
  #testSuite <- defineTestSuite( name=paste( pkg, "unit testing" ), testFileRegexp=patt, testFuncRegexp=func, dirs=path )
  testSuite <- defineTestSuite( name=paste( pkg, "unit testing" ), testFileRegexp=patt, testFuncRegexp=func, dirs=path, rngKind="Mersenne-Twister" )
  tests <- runTestSuite( testSuite )
 
  pathReport <- file.path( path, "report" )
 
  cat( "------------------- UNIT TEST SUMMARY ---------------------\n\n" )
  printTextProtocol( tests, showDetails=FALSE )
  printTextProtocol( tests, showDetails=FALSE, fileName=paste( pathReport, "Summary.txt", sep="" ) )
  printTextProtocol( tests, showDetails=TRUE,  fileName=paste( pathReport, ".txt", sep="" ) )
 
  printHTMLProtocol( tests, fileName=paste( pathReport, ".html", sep="" ) )
 
  tmp <- getErrors( tests )
  if( tmp$nFail > 0 | tmp$nErr > 0 ) {
    stop( paste( "\n\nunit testing failed (#test failures: ", tmp$nFail, ", #R errors: ",  tmp$nErr, ")\n\n", sep="" ) )
  }
} else {
  warning( "cannot run unit tests -- package RUnit is not available" )
}

.single.transcript.to.utr.range = function( transcript, end=c( 'both', '5', '3' ), on.translation.error ) {
  end = match.arg( end )
  space = as.character( transcript$chromosome_name )
  strand = as.numeric( transcript$strand )

  ret = data.frame( IN1=NULL, chromosome_name=NULL, start=NULL, end=NULL, strand=NULL, prime=NULL, phase=NULL, translated=NULL )

  if( is.na( transcript$translation_start_exon ) ) {
    if( end == 'both' ) {
      return( data.frame( IN1=c( transcript$stable_id, transcript$stable_id ),
                          chromosome_name=c( space, space ),
                          start=c( transcript$start, transcript$start ),
                          end=c( transcript$end, transcript$end ),
                          strand=c( strand, strand ),
                          prime=c( '5', '3' ),
                          phase=c( NA, NA ),
                          translated=c( FALSE, FALSE ),
                          stringsAsFactors=F ) )
    }
    else {
      return( data.frame( IN1=transcript$stable_id,
                          chromosome_name=space,
                          start=transcript$start,
                          end=transcript$end,
                          strand=strand,
                          prime=end,
                          phase=NA,
                          translated=F,
                          stringsAsFactors=F ) )
    }
  }

  exons = transcriptToExon( transcript$stable_id, as.vector='data.frame' )
  exons[,'sequence'] = NULL

  exons = exons[ order( exons$start, decreasing=strand < 0 ), ]

  sidx = 0
  eidx = 0

  for( idx in seq_along( exons$stable_id ) ) {
    if( exons$exon_id[ idx ] == transcript$translation_start_exon ) {
      sidx = idx
    }
    if( exons$exon_id[ idx ] == transcript$translation_end_exon ) {
      eidx = idx
    }
  }

  if( end %in% c( '5', 'both' ) ) {
    if( sidx == 1 && transcript$translation_start == 1 ) {
      # No 5' UTR
      ret = rbind( ret, data.frame( IN1=transcript$stable_id,
                                    chromosome_name=space,
                                    start=NA,
                                    end=NA,
                                    strand=strand,
                                    prime='5',
                                    phase=exons$phase[ sidx ],
                                    translated=T,
                                    stringsAsFactors=F ) )
    }
    else if( transcript$translation_start == 1 ) {
      if( strand > 0 ) {
        ret = rbind( ret, data.frame( IN1=transcript$stable_id,
                                      chromosome_name=space,
                                      start=transcript$start,
                                      end=exons$start[ sidx ] - 1,
                                      strand=strand,
                                      prime='5',
                                      phase=exons$phase[ sidx ],
                                      translated=T,
                                      stringsAsFactors=F ) )
      }
      else {
        ret = rbind( ret, data.frame( IN1=transcript$stable_id,
                                      chromosome_name=space,
                                      start=exons$end[ sidx ] + 1,
                                      end=transcript$end,
                                      strand=strand,
                                      prime='5',
                                      phase=exons$phase[ sidx ],
                                      translated=T,
                                      stringsAsFactors=F ) )
      }
    }
    else {
      if( strand > 0 ) {
        ret = rbind( ret, data.frame( IN1=transcript$stable_id,
                                      chromosome_name=space,
                                      start=transcript$start,
                                      end=exons$start[ sidx ] + transcript$translation_start - 2,
                                      strand=strand,
                                      prime='5',
                                      phase=exons$phase[ sidx ],
                                      translated=T,
                                      stringsAsFactors=F ) )
      }
      else {
        ret = rbind( ret, data.frame( IN1=transcript$stable_id,
                                      chromosome_name=space,
                                      start=exons$end[ sidx ] - transcript$translation_start + 2,
                                      end=transcript$end,
                                      strand=strand,
                                      prime='5',
                                      phase=exons$phase[ sidx ],
                                      translated=T,
                                      stringsAsFactors=F ) )
      }
    }
  }

  if( end %in% c( '3', 'both' ) ) {
    if( eidx == length( exons$stable_id ) && transcript$translation_end == exons$end[ eidx ] - exons$start[ eidx ] + 1 ) {
      # No 3' UTR
      ret = rbind( ret, data.frame( IN1=transcript$stable_id,
                                    chromosome_name=space,
                                    start=NA,
                                    end=NA,
                                    strand=strand,
                                    prime='3',
                                    phase=exons$end_phase[ eidx ],
                                    translated=T,
                                    stringsAsFactors=F ) )
    }
    else if( transcript$translation_end == exons$end[ eidx ] - exons$start[ eidx ] + 1 ) {
      # Just the last exons
      if( strand > 0 ) {
        ret = rbind( ret, data.frame( IN1=transcript$stable_id,
                                      chromosome_name=space,
                                      start=exons$end[ eidx ] + 1,
                                      end=transcript$end,
                                      strand=strand,
                                      prime='3',
                                      phase=exons$end_phase[ eidx ],
                                      translated=T,
                                      stringsAsFactors=F ) )
      }
      else {
        ret = rbind( ret, data.frame( IN1=transcript$stable_id,
                                      chromosome_name=space,
                                      start=transcript$start,
                                      end=exons$start[ eidx ] - 1,
                                      strand=strand,
                                      prime='3',
                                      phase=exons$end_phase[ eidx ],
                                      translated=T,
                                      stringsAsFactors=F ) )
      }
    }
    else {
      if( strand > 0 ) {
        ret = rbind( ret, data.frame( IN1=transcript$stable_id,
                                      chromosome_name=space,
                                      start=exons$start[ eidx ] + transcript$translation_end,
                                      end=transcript$end,
                                      strand=strand,
                                      prime='3',
                                      phase=exons$phase[ eidx ],
                                      translated=T,
                                      stringsAsFactors=F ) )
      }
      else {
        ret = rbind( ret, data.frame( IN1=transcript$stable_id,
                                      chromosome_name=space,
                                      start=transcript$start,
                                      end=exons$end[ eidx ] - transcript$translation_end,
                                      strand=strand,
                                      prime='3',
                                      phase=exons$phase[ eidx ],
                                      translated=T,
                                      stringsAsFactors=F ) )
      }
    }
  }
  # Check for negative width entries
  clamper = function( index, data, invalidfn ) {
    row = data[ index, ]
    if( ( !is.na( row$start ) && !is.na( row$end ) ) && ( row$end < row$start ) ) {
      invalidfn( paste( 'Translation falls off the ', row$prime, "' end of an exon for ", row$IN1, sep='' ) )
      row$start = NA
      row$end = NA
    }
    row
  }
  ret = do.call( 'rbind', lapply( seq_along( ret$IN1 ), clamper, data=ret, invalidfn=on.translation.error ) )
  return( ret )
}

transcriptToUtrRange = function( ids, end=c( 'both', '5', '3' ), as.data.frame=FALSE, on.translation.error=stop ) {
  ids = .get.correct.column( 'transcript', ids )
  if( any( duplicated( ids ) ) ) {
    warning( 'Duplicate ids detected.  Duplicates will be removed.' )
    ids = unique( ids )
  }
  if( is.null( ids ) ) {
    return( NULL )
  }
  ids = transcriptDetails( ids, as.data.frame=T )
  end = match.arg( end )
  .f = function( idx ) {
    .single.transcript.to.utr.range( ids[ idx, ], end, on.translation.error )
  }
  .data = lapply( seq_along( ids$stable_id ), .f )
  ret = do.call( 'rbind', .data )

  if( as.data.frame == TRUE ) {
    return( ret )
  }

  ret = ret[ !is.na( ret$start ), ]

  if( dim( ret )[1] == 0 ) {
    return( NULL )
  }
  colnames( ret )[ colnames( ret ) == "chromosome_name" ] = "space"

  ret = as( ret, 'RangedData' )
  if( .usegranges() ) {
    ret$strand = as.integer( ret$strand )
    as( ret, 'GRanges' )
  }
  else {
    ret
  }
}

transcriptToUtrExon = function( ids, end=c( 'both', '5', '3' ), as.vector=FALSE, on.translation.error=stop ) {
  ids = .get.correct.column( 'transcript', ids )
  if( any( duplicated( ids ) ) ) {
    warning( 'Duplicate ids detected.  Duplicates will be removed.' )
    ids = unique( ids )
  }
  ranges = transcriptToUtrRange( ids, end, on.translation.error=on.translation.error )
  exons  = transcriptToExon( ids )

  rslt = do.call( c, lapply( unique( exons$IN1 ), function( transcript ) {
    r = ranges[ ranges$IN1 == transcript, ]
    if( length( r ) == 0 ) {
      exons[ exons$IN1 == 'false', ]
    }
    else if( length( r ) == 1 ) {
      restrict( exons[ exons$IN1 == transcript, ], start=start( r ), end=end( r ) )
    }
    else {
      c( restrict( exons[ exons$IN1 == transcript, ], start=start( r[1] ), end=end( r[1] ) ),
         restrict( exons[ exons$IN1 == transcript, ], start=start( r[2] ), end=end( r[2] ) ) )
    }
  } ) )

  rslt$sequence = NULL
  if( length( rslt ) == 0 ) {
    return( NULL )
  }
  if( as.vector == 'data.frame' ) {
    strands = strandAsInteger( rslt )
    rslt = as.data.frame( rslt )
    colnames( rslt )[ colnames( rslt ) == "seqnames" ] = "chromosome_name"
    rslt$width = NULL
    rslt$strand = strands
  }
  else if( as.vector == TRUE ) {
    names = rslt$IN1
    rslt = rslt$stable_id
    names( rslt ) = names
  }
  rslt
}

transcriptToCodingRange = function( ids, end=c( 'both', '5', '3' ), as.data.frame=FALSE, on.translation.error=stop ) {
  ids = .get.correct.column( 'transcript', ids )
  if( any( duplicated( ids ) ) ) {
    warning( 'Duplicate ids detected.  Duplicates will be removed.' )
    ids = unique( ids )
  }
  if( is.null( ids ) ) {
    return( NULL )
  }
  end = match.arg( end )
  transcripts = transcriptDetails( ids, as.data.frame=TRUE )
  utr.transcripts = transcriptToUtrRange( ids, end='both', as.data.frame=TRUE, on.translation.error )
  .fn = function( idx ) {
    row = transcripts[ idx, ]
    utr = utr.transcripts[ utr.transcripts$IN1 == row$stable_id, ]
    phase = utr[ utr$prime == '5', ]$phase
    end.phase = utr[ utr$prime == '3', ]$phase
    if( end == '5' ) {
      utr = utr[ utr$prime == '5', ]
    }
    else if( end == '3' ) {
      utr = utr[ utr$prime == '3', ]
    }
    utr = utr[ !is.na( utr$start ), ]
    new = setdiff( IRanges( row$start, row$end ), IRanges( utr$start, utr$end ) )
    row$phase = phase
    row$end.phase = end.phase
    if( length( new ) == 0 ) {
      row$start = NA
      row$end = NA
    }
    else {
      row$start = start( new )
      row$end = end( new )
    }
    row
  }
  ret = do.call( 'rbind', lapply( seq_along( transcripts$stable_id ), .fn ) )
  if( as.data.frame == TRUE ) {
    return( ret )
  }
  ret = ret[ !is.na( ret$start ), ]
  colnames( ret )[ colnames( ret ) == "chromosome_name" ] = "space"
  ret = as( ret, 'RangedData' )
  if( .usegranges() ) {
    ret$strand = as.integer( ret$strand )
    as( ret, 'GRanges' )
  }
  else {
    ret
  }
}

transcriptToCodingExon = function( ids, end=c( 'both', '5', '3' ), as.vector=FALSE, on.translation.error=stop ) {
  ids = .get.correct.column( 'transcript', ids )
  if( any( duplicated( ids ) ) ) {
    warning( 'Duplicate ids detected.  Duplicates will be removed.' )
    ids = unique( ids )
  }
  ranges = transcriptToCodingRange( ids, end, on.translation.error=on.translation.error )
  exons  = transcriptToExon( ids )
  
  rslt = do.call( c, lapply( unique( exons$IN1 ), function( transcript ) {
    r = ranges[ ranges$IN1 == transcript, ]
    if( length( r ) == 0 ) {
      exons[ exons$IN1 == 'false', ]
    }
    else {
      out = restrict( exons[ exons$IN1 == transcript, ], start=start( r ), end=end( r ) )
    }
  } ) )

  rslt$sequence = NULL
  if( length( rslt ) == 0 ) {
    return( NULL )
  }
  if( as.vector == 'data.frame' ) {
    strands = strandAsInteger( rslt )
    rslt = as.data.frame( rslt )
    colnames( rslt )[ colnames( rslt ) == "seqnames" ] = "chromosome_name"
    rslt$width = NULL
    rslt$strand = strands
  }
  else if( as.vector == TRUE ) {
    names = rslt$IN1
    rslt = rslt$stable_id
    names( rslt ) = names
  }
  rslt
}

.nonIntronicLength = function( exons ) {
  sum( width( reduce( split( exons, exons$IN1 ) ) ) )
}

nonIntronicTranscriptLength = function( ids, end=c( 'none', 'both', '5', '3' ), on.translation.error=stop ) {
  end = match.arg( end )
  exons = if( end == 'none' ) transcriptToExon( ids ) else transcriptToCodingExon( ids, end=end, on.translation.error=on.translation.error )
  .nonIntronicLength( exons )
}

nonIntronicGeneLength = function( ids ) {
  .nonIntronicLength( geneToExon( ids ) )
}

.probeset.filtering = function( probesets, transcripts, end=c( 'both', '5', '3' ), fn, on.translation.error=stop ) {
  if( missing( probesets ) ) probesets = NULL
  if( missing( transcripts ) ) transcripts = NULL
  end = match.arg( end )
  
  probesets = .get.correct.column( 'probeset', probesets )
  transcripts = .get.correct.column( 'transcript', transcripts )
  
  if( is.null( probesets ) && is.null( transcripts ) ) {
    return( NULL )
  }
  else if( is.null( probesets ) ) {
    probesets = transcriptToProbeset( transcripts, as.vector=TRUE )
    if( is.null( probesets ) ) {
      return( NULL )
    }
  }
  else if( is.null( transcripts ) ) {
    transcripts = probesetToTranscript( probesets, as.vector='data.frame' )
    keep = !( is.na( transcripts$"translation_start" ) )
    transcripts = unique( transcripts[keep,]$'stable_id' )
    if( length( transcripts ) == 0 ) {
      return( NULL )
    }
  }
  else {
    tpts = probesetToTranscript( probesets, as.vector='data.frame' )
    keep = !( is.na( tpts$"translation_start" ) )
    tpts = tpts[keep,]
    keep = tpts$"stable_id" %in% transcripts
    tpts = tpts[ keep, ]
    if( dim( tpts )[1] == 0 ) {
      return( NULL )
    }
    transcripts = unique( tpts$'stable_id' )
  }
  probesets = unreliable( probesets, exclude=TRUE )
  ranges = fn( transcripts, end=end, FALSE, on.translation.error )
  if( is.null( ranges ) ) {
    return( NULL )
  }
  psts = annmapRangeApply( ranges, probesetInRange )
  if( is.null( psts ) ) {
    return( NULL )
  }
  psts = .get.correct.column( 'probeset', psts )
  keep = psts %in% probesets
  psts = psts[ keep ]
  if( length( psts ) == 0 ) {
    NULL
  }
  else {
    psts
  }
}

utrProbesets = function( probesets, transcripts, end=c( 'both', '5', '3' ), on.translation.error=stop ) {
  .probeset.filtering( probesets, transcripts, end, transcriptToUtrRange, on.translation.error )
}

codingProbesets = function( probesets, transcripts, end=c( 'both', '5', '3' ), on.translation.error=stop ) {
  .probeset.filtering( probesets, transcripts, end, transcriptToCodingRange, on.translation.error )
}

ngsTracePlotter = function( rle.data, start, end, ylim, trace.label.properties=list(),
                            smoothing.function=function( rle, ... ) { IRanges::runmean( rle, k=1001, endrule='constant' ) }, 
                            trace.clip='inherit', trace.draw.scale=FALSE, trace.bor='transparent', trace.pad=c(0,0), ... ) {
  .y = 0
  local.draw = function( start, rle, col, alpha.mod=1.0, mult=1, local.draw.outline=T, local.draw.fill=T, ... ) {
    .len = runLength( rle )
    .len[ 1 ] = .len[ 1 ] - start
    .last.val = start
    .xpts = c( start )
    for( v in seq_along( .len ) ) {
      .xpts = c( .xpts, c( .last.val, .len[ v ] + .last.val ) )
      .last.val = .len[ v ] + .last.val
    }
    .xpts = c( .xpts, .last.val, end )
    .val = c( .y, unlist( lapply( runValue( rle ), function( v ) { .val = v ; c( .val, .val ) } ) ), .y, .y )
    grid.move.to( start, 0, default.units='native' )
    grid.line.to( end, 0, gp=gpar( col='black', alpha=0.1 ), default.units='native' )
    if( local.draw.fill ) {
      grid.polygon( x=.xpts, y=.val * mult, gp=gpar( fill=col, col=NA, alpha=0.5*alpha.mod ), default.units='native' )
    }
    if( local.draw.outline ) {
      grid.polygon( x=.xpts, y=.val * mult, gp=gpar( fill=NA, col=col, alpha=alpha.mod ), default.units='native' )
    }
  }
  
  lheights = unit( c(    top=trace.pad[1], main=1,      bottom=trace.pad[2] ),
                   c(    top='lines',      main='null', bottom='lines' ),
                   list( top=NULL,         main=NULL,   bottom=NULL ) )
  lwidths  = unit( 1, 'null', NULL )

  my.layout = grid.layout( nrow = 3, ncol = 1, heights = lheights, widths = lwidths )
  pushViewport( viewport( layout=my.layout ) )

  pushViewport( viewport( layout.pos.col=1, layout.pos.row=2 ) )
    pushViewport( viewport( layout=grid.layout( 1, 1 ), xscale=c( start, end ), yscale=ylim, clip=trace.clip ) )
      if( !is.list( rle.data$rle ) && length( rle.data$rle ) > 0 ) {
        if( !is.null( smoothing.function ) ) {
          local.draw( start, rle.data$rle, 'black', alpha.mod=0.3, ... )
          params = as.list( c( rle=rle.data$rle, rle.data[ names( rle.data ) != 'rle' ] ) )
          .smooth = do.call( smoothing.function, params )
          local.draw( start, .smooth, rle.data$col, ... )
          rle.data$rle = .smooth
        }
        else {
          local.draw( start, rle.data$rle, rle.data$col, ... )
        }
      }
      else if( length( rle.data$rle ) == 2 ) {
        if( !is.null( rle.data$rle$'+' ) && length( rle.data$rle$'+' ) > 0 ) {
          if( !is.null( smoothing.function ) ) {
            local.draw( start, rle.data$rle$'+', 'black', alpha.mod=0.3, ... )
            params = as.list( c( rle=rle.data$rle$'+', strand=1, rle.data[ names( rle.data ) != 'rle' ] ) )
            .smooth.fwd = do.call( smoothing.function, params )
            local.draw( start, .smooth.fwd, rle.data$col, ... )
            rle.data$rle$'+' = .smooth.fwd
          }
          else {
            local.draw( start, rle.data$rle$'+', rle.data$col, ... )
          }
        }
        if( !is.null( rle.data$rle$'-' ) && length( rle.data$rle$'-' ) > 0 ) {
          if( !is.null( smoothing.function ) ) {
            local.draw( start, rle.data$rle$'-', 'black', alpha.mod=0.3, mult=-1, ... )
            params = as.list( c( rle=rle.data$rle$'-', strand=-1, rle.data[ names( rle.data ) != 'rle' ] ) )
            .smooth.rev = do.call( smoothing.function, params )
            local.draw( start, .smooth.rev, rle.data$col, mult=-1, ... )
            rle.data$rle$'-' = .smooth.rev
          }
          else {
            local.draw( start, rle.data$rle$'-', rle.data$col, mult=-1, ... )
          }
        }
      }
      else {
        grid.polygon( x=c( start, end ), y=c( .y, .y ), gp=gpar( fill=NA, col=rle.data$col ), default.units='native' )
      }
      .text.defaults = list( rle.data$name, x=unit( 0.1, 'npc' ), y=unit( 0.9, 'npc' ), just=c( 'left', 'top' ), gp=gpar( cex=0.7, col=rle.data$col, alpha=0.8 ) )
      if( class( trace.label.properties ) == 'list' ) {
        .text.defaults = modifyList( .text.defaults, trace.label.properties )
        grid.text( rle.data$name, x=.text.defaults$x, y=.text.defaults$y, just=.text.defaults$just, gp=.text.defaults$gp )
      }

  popViewport( 2 )
  pushViewport( viewport( layout.pos.col=1, layout.pos.row=2, xscale=c( start, end ), yscale=ylim ) )
    if( ( is.vector( trace.draw.scale ) && ( 'x' %in% trace.draw.scale ) ) ||
        ( is.list( trace.draw.scale ) && !is.null( trace.draw.scale$x ) ) ||
        ( is.logical( trace.draw.scale ) && trace.draw.scale ) ) {
      grid.xaxis( gp=gpar( cex=0.6 ), main=if( is.list( trace.draw.scale ) ) trace.draw.scale$x else TRUE )
    }
    if( ( is.vector( trace.draw.scale ) && 'y' %in% trace.draw.scale ) ||
        ( is.list( trace.draw.scale ) && !is.null( trace.draw.scale$y ) ) ||
        ( is.logical( trace.draw.scale ) && trace.draw.scale ) ) {
      grid.yaxis( gp=gpar( cex=0.6 ), main=if( is.list( trace.draw.scale ) ) trace.draw.scale$y else TRUE )
    }
  popViewport( 2 )
  rle.data
}

ngsTraceScale = function( vector.of.xbams.and.ybams ) {
  c( min( unlist( lapply( vector.of.xbams.and.ybams, function( d ) {
      if( length( d$rle ) == 0 ) {
        0
      }
      else if( !is.list( d$rle ) ) { # Just a single strand
        if( length( d$rle ) == 0 ) 0 else min( runValue( d$rle ) )
      }
      else { # Two strands '+' and '-'
        if( length( d$rle$'-' ) == 0 ) 0 else -max( runValue( d$rle$'-' ) )
      }
     } ) ) ),
   max( unlist( lapply( vector.of.xbams.and.ybams, function( d ) {
      if( length( d$rle ) == 0 ) {
        0
      }
      else if( !is.list( d$rle ) ) { # Just a single strand
        if( length( d$rle ) == 0 ) 0 else max( runValue( d$rle ) )
      }
      else { # Two strands '+' and '-'
        if( length( d$rle$'+' ) == 0 ) 0 else max( runValue( d$rle$'+' ) )
      }
   } ) ) ) )
}

ngsTraceLabel = function( rle.data ) {
  grid.text( rle.data$name, x=unit( 0.1, 'npc' ), just=c( 'left', 'center' ), gp=gpar( cex=0.8 ) )
}

convertBamToRle = function( bam.file.name, chr, start, end, chr.name.mapping=function( name ) { name } ) {
  chr = chr.name.mapping( chr )
  if( missing( start ) ) {
    start = 1
  }
  if( missing( end ) ) {
    end = chromosomeDetails( chr )$length
  }
  # Set the chromosome and range of interest (tried using a GRange to specify strand as well, but it doesnt work
  which  = RangedData( space=chr, ranges=IRanges( start=as.integer(start), end=as.integer(end) ) )
  # set parameters as described above for reading bam file
  param  = ScanBamParam( flag=scanBamFlag( isUnmappedQuery=F ), what=c( 'rname', 'strand', 'pos', 'qwidth' ), which=which )
  # read data from current bam file (for a given project, this will have to be applied over each timepoint/sub-project)
  BAM    = do.call( 'rbind', lapply( bam.file.name, function( fn ) { as.data.frame( scanBam( fn, param=param ) ) } ) )
  colnames(BAM) = c( 'space', 'strand', 'start', 'width' )
  BAM = BAM[ with( BAM, order( start ) ), ]
  sapply( c( '+', '-' ), function( str ) {
    d = BAM[ as.character( BAM[,2] ) == str, ]
    ret = coverage( as( cbind( d, end=( d$start + d$width - 1 ) ), 'RangedData' ) )[[ chr ]]
    if( length( ret ) == 0 ) {
      # Create an Rle object the correct length rather than an empty one
      ret = Rle( end, 0 )
    }
    ret
  }, simplify=F )
}

generateBridgeData = function( xrange, bamFiles, colours=NULL, names=NULL ) {
  if( is.null( names ) ) names = paste( "Track", seq_along( bamFiles ) )
  if( is.null( colours ) ) colours = rainbow( length( bamFiles ), v=0.5, s=0.5 )
  apply( cbind( bamFiles, colours, names ), 1, function( r ) {
    list( name=r[ 'names' ], col=r['colours'], rle=convertBamToRle( r['bamFiles'], as.character( seqnames( xrange ) ), start( xrange ), end( xrange ) ) )
  } )
}

ngsBridgePlot = function( xrange, data=list(), 
                          main=NULL,
                          sub=NULL,
                          highlights=NULL,
                          trace.plotter=ngsTracePlotter,
                          genome.layout.weight=4,
                          trace.scale=ngsTraceScale,
                          trace.draw.scale=NULL,
                          trace.match.strand=TRUE,
                          probe.plot=NULL,
                          exon.depth.plot=genomicExonDepthPlot, 
                          .genes=NULL,
                          .exons=NULL,
                          ... ) {
  .lh = c( main = if( !is.null( main ) ) 2 else 0,
           gen  = genome.layout.weight,
           sapply( seq_along( data ), function( f ) { r = 1 ; names( r ) = paste( 'dat', f, sep='' ) ; r } ),
           pad  = 1,
           sub  = if( !is.null( sub ) ) 2 else 0 )
  .lt = c( main = if( !is.null( main ) ) 'strheight' else 'null',
           gen  = 'null',
           sapply( seq_along( data ), function( f ) { r = 'null' ; names( r ) = paste( 'dat', f, sep='' ) ; r } ),
           pad  = 'lines',
           sub  = if( !is.null( sub ) ) 'strheight' else 'null' )
  .ld = c( list( main = if( is.null( main ) ) NULL else 'main',
                 gen  = NULL ),
           sapply( seq_along( data ), function( f ) { a = list( a=NULL ) ; names( a ) = paste( 'dat', f, sep='' ) ; a } ),
           list( pad = NULL,
                 sub = if( is.null( sub ) ) NULL else 'sub' ) )
  lheights = unit( .lh, .lt, .ld )
  lwidths  = unit( c( lpad = 2, gen = 1, rpad = 2 ),
                   c( lpad = 'lines', gen = 'null', rpad = 'lines' ),
                   list( lpad = NULL, gen = NULL, rpad = NULL ) )
  my.layout = grid.layout( nrow = 4 + length( data ), ncol = 3, heights = lheights, widths = lwidths )

  if( is.null( .genes ) ) {
    .genes = .fetch.genes.for.range( xrange, ... )
  }
  else {
    .genes = .get.correct.column( 'gene', .genes )
    .genes = geneDetails( .genes, as.data.frame=T )
  }
  .all.exons = geneToExon( if( !is.null( .genes ) ) .genes$stable_id else NULL )
  if( !is.null( .exons ) ) {
    # Filter .all.exons to just include those in .exons
    .exon.names = .get.correct.column( 'exon', .exons )
    .all.exons = .all.exons[ .attr( .all.exons, 'stable_id' ) %in% .exon.names, ]
  }

  .exons = if( is.null( .all.exons ) ) list() else lapply( split( .attr( .all.exons, 'stable_id' ), factor( .attr( .all.exons, 'IN1' ) ) ), function( .name ) {
    .rows = reduce( ranges( .all.exons[ .attr( .all.exons, 'stable_id' ) %in% .name, ] ) )
  } )

  .skip.probes = identical( probe.plot, genomicProbePlot ) && ( length( allArrays( as.vector=TRUE ) ) == 0 )

  pushViewport( viewport( layout=my.layout ) )
    if( !is.null( main ) ) {
      pushViewport( viewport( layout.pos.row=1, layout.pos.col=1:3 ) )
        grid.text( main )
      popViewport()
    }
    if( !is.null( sub ) ) {
      pushViewport( viewport( layout.pos.row=4 + length( data ), layout.pos.col=1:3 ) )
        grid.text( sub, gp=gpar( cex=0.8 ) )
      popViewport()
    }
    pushViewport( viewport( layout.pos.row=2:(2+length(data)), layout.pos.col=2 ) )
      .strand = if( class( xrange ) == 'GRanges' ) {
        if( as.character( strand( xrange ) ) == '*' ) {
          NULL
        }
        else {
          strandAsInteger( xrange )
        }
      }
      else {
        if( xrange$strand == 0 ) NULL else xrange$strand
      }
      .filtered.gene.names = if( is.null( .strand ) ) .genes$stable_id else .genes[ .genes$strand==.strand, ]$stable_id
      if( !is.null( exon.depth.plot ) ) {
        exon.depth.plot( .exons[ names( .exons ) %in% .filtered.gene.names ], start( xrange ), end( xrange ), ... )
      }
      if( !.skip.probes && !is.null( probe.plot ) ) {
        .chr = if( class( xrange ) == 'GRanges' ) {
          as.character( seqnames( xrange ) )
        }
        else {
          as.character( space( xrange ) )
        }
        .probes = if( is.null( .strand ) ) {
          rbind( probeInRange( .chr, start( xrange ), end( xrange ), 1, as.vector='data.frame' ),
                 probeInRange( .chr, start( xrange ), end( xrange ), -1, as.vector='data.frame' ) )
        }
        else {
          probeInRange( xrange, as.vector='data.frame' )
        }
        .probes = .probes[ .probes$probe_hit_count == 1, ]
        probe.plot( .probes, start( xrange ), end( xrange ), ... )
      }
    popViewport()

    pushViewport( viewport( layout.pos.row=2, layout.pos.col=2 ) )
      genomicPlot( xrange, highlights=highlights, exon.depth.plot=NULL, .genes=.genes, .exons=.exons, ... )
    popViewport()

    if( length( data ) > 0 ) {
      dataStrandFn = function( element ) {
        if( is.list( element$rle ) ) {
          # Single strand data... Just return it as is
          if( trace.match.strand == TRUE ) {
            strand = if( class( xrange ) == 'GRanges' ) {
              as.character( strand( xrange ) )
            }
            else {
              if( xrange$strand == 0 ) '*' else if( xrange$strand > 0 ) '+' else '-'
            }
            if( strand != '*' ) {
              element$rle = element$rle[[ strand ]]
            }
          }
          else if( trace.match.strand == '+' || trace.match.strand == '-' ) {
            element$rle = element$rle[[ trace.match.strand ]]
          }
        }
        element
      }
      data = lapply( data, dataStrandFn )
      local.scale = if( is.vector( trace.scale ) ) trace.scale else trace.scale( data )
      lapply( seq_along( data ), function( rleidx ) {
        pushViewport( viewport( layout.pos.row=2 + rleidx, layout.pos.col=2, xscale=c( start( xrange ), end( xrange ) ), yscale=local.scale ) )
          if( is.null( trace.draw.scale ) )
            trace.draw.scale = if( rleidx==1 ) 'y' else FALSE
          trace.plotter( data[[ rleidx ]], start( xrange ), end( xrange ), local.scale, trace.draw.scale=trace.draw.scale, ... )
        popViewport()
      } )
    }
  popViewport()
}

# --------------------------------WARNING---------------------------------
# This file has be automatically generated when this release of the xmap
# database was generated.  Any changes made to this file will be lost when
# the database is generated for the next version of Ensembl UNLESS the
# changes are fed back and placed in the generation script
# ------------------------------------------------------------------------



##################################################################
#                    GLOBAL UTILITY METHODS
#-----------------------------------------------------------------
#       This block will be posted once at the top of the file
##################################################################

.data.frame.to.rangeddata = function( x ) {
  cn = colnames( x )
  errs = c()
  if( !( 'chr' %in% cn ) && !( 'chromosome_name' %in% cn ) ) {
    errs = c( errs, 'data.frame in "x" needs a column called "chr" or "chromosome_name"' )
  }
  if( !( 'start' %in% cn ) ) {
    errs = c( errs, 'data.frame in "x" needs a column called "start"' )
  }
  if( !( 'end' %in% cn ) ) {
    errs = c( errs, 'data.frame in "x" needs a column called "end"' )
  }
  if( !( 'strand' %in% cn ) ) {
    errs = c( errs, 'data.frame in "x" needs a column called "strand"' )
  }
  if( length( errs ) > 0 ) {
    stop( paste( errs, collapse='\n' ) )
  }
  colnames(x)[colnames(x) == 'chr'] = 'space'
  colnames(x)[colnames(x) == 'chromosome_name'] = 'space'
  as( x, 'RangedData' )
}

.range.call = function( chr, start, end, strand, src, column, as.vector ) {
  .params = annmap:::.make.hash()
  .params$chr = chr
  .params$qstart = start
  .params$qstop = end
  .params$qstrand = strand
  r = .process( "range", src, .params )
  if( !( src %in% c( 'hit', 'prediction_exon' ) ) ) {
    r = .coerce( r, column, as.vector )
  }
  else if( src == 'hit' ) {
    r = .coerce( r, NULL, FALSE )
  }
  r
}

##################################################################
#               LOOKUP DATA AND FUNCTION DEFINITIONS
##################################################################

.xmap.queries = .make.hash()
.xmap.types = .make.hash()
# CDNA Probeset and Transcripts ar just probesets or Transcripts...  Hack this in...
.xmap.types$cdnaprobeset = "stable_id"
.xmap.types$cdnatranscript = "stable_id"
.xmap.types$array = "array_name"
.xmap.types$probeset = "stable_id"
.xmap.types$probe = "sequence"
.xmap.types$protein = "stable_id"
.xmap.types$domain = "stable_id"
.xmap.types$chromosome = "name"
.xmap.types$gene = "stable_id"
.xmap.types$transcript = "stable_id"
.xmap.types$exon = "stable_id"
.xmap.types$est_gene = "stable_id"
.xmap.types$est_transcript = "stable_id"
.xmap.types$est_exon = "stable_id"
.xmap.types$prediction_transcript = "stable_id"
.xmap.types$synonym = "synonym"
.xmap.queries$array.all = "CALL all_arrays(  )"
allArrays = function( as.vector=FALSE ) {
  .coerce( .process( "all", "array" ), .xmap.types$array, as.vector )
}
.xmap.queries$array.details = "CALL array_details( '${ids}' )"
arrayDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "array", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$array.to.probeset = "CALL array_to_probeset( '${array}' )"
arrayToProbeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'array', .params, 'probeset' ), .xmap.types$probeset, as.vector )
}
.xmap.queries$probeset.all = "CALL all_probesets( '${array}' )"
allProbesets = function( as.vector=FALSE ) {
  .coerce( .process( "all", "probeset" ), .xmap.types$probeset, as.vector )
}
.xmap.queries$probeset.details = "CALL probeset_details( '${array}', '${ids}' )"
probesetDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "probeset", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$probeset.range = "CALL probesets_in_range( '${array}', '${chr}', ${qstart}, ${qstop}, ${qstrand} )"

probesetInRange = function( x, ..., as.vector=FALSE ) { standardGeneric( 'probesetInRange' ) }
setGeneric( 'probesetInRange', probesetInRange )
setMethod(  'probesetInRange', signature( x='character' ),  function( x, start, end, strand, ..., as.vector=FALSE ) {
  if( length( x ) > 1 ) {
    if( length( unique( c( length( x ), length( start ), length( end ), length( strand ) ) ) ) != 1 ) {
      stop( 'All parameters "x", "start", "end", and "strand" must be the same length.' )
    }
    probesetInRange( data.frame( chr=x, start=start, end=end, strand=strand ), as.vector=as.vector )
  }
  else {
    if( is.na( strand ) || strand == 0 ) {
      if( as.vector == 'data.frame' || ( as.vector == FALSE && !.usegranges() ) ) {
        rbind( .range.call( x, start, end,  1, 'probeset', .xmap.types$probeset, as.vector=as.vector ),
               .range.call( x, start, end, -1, 'probeset', .xmap.types$probeset, as.vector=as.vector ) )
      }
      else {
        .fwd = .range.call( x, start, end,  1, 'probeset', .xmap.types$probeset, as.vector=as.vector )
        .rev = .range.call( x, start, end, -1, 'probeset', .xmap.types$probeset, as.vector=as.vector )
        if( is.null( .fwd ) ) .rev else if( is.null( .rev ) ) .fwd else c( .fwd, .rev )
      }
    }
    else {
      .range.call( x, start, end, strand, 'probeset', .xmap.types$probeset, as.vector=as.vector )
    }
  }
} )
setMethod(  'probesetInRange', signature( x='factor' ),     function( x, start, end, strand, ..., as.vector=FALSE ) {
  probesetInRange( as.character( x ), as.numeric( start ), as.numeric( end ), as.numeric( strand ), 'probeset', .xmap.types$probeset, as.vector=as.vector )
} )
setMethod(  'probesetInRange', signature( x='data.frame' ), function( x, as.vector=FALSE ) {
  probesetInRange( .data.frame.to.rangeddata( x ), as.vector=as.vector )
} )
setMethod(  'probesetInRange', signature( x='RangedData' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, probesetInRange, as.vector=as.vector ) 
} )
setMethod(  'probesetInRange', signature( x='NULL' ), function( x, as.vector=FALSE ) {
  return( NULL )
} )
setMethod(  'probesetInRange', signature( x='GRanges' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, probesetInRange, as.vector=as.vector )
} )

.xmap.queries$probeset.to.gene = "CALL probeset_to_gene( '${array}', '${ids}' )"
probesetToGene = function( ids, as.vector=FALSE, rm.unreliable=TRUE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  if( rm.unreliable ) {
    ids = unreliable( ids, exclude=TRUE )
    if( is.null( ids ) ) {
      return( NULL )
    }
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'gene' ), .xmap.types$gene, as.vector )
}
.xmap.queries$probeset.to.transcript = "CALL probeset_to_transcript( '${array}', '${ids}' )"
probesetToTranscript = function( ids, as.vector=FALSE, rm.unreliable=TRUE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  if( rm.unreliable ) {
    ids = unreliable( ids, exclude=TRUE )
    if( is.null( ids ) ) {
      return( NULL )
    }
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'transcript' ), .xmap.types$transcript, as.vector )
}
.xmap.queries$probeset.to.cdnatranscript = "CALL probeset_to_cdnatranscript( '${array}', '${ids}' )"
probesetToCdnatranscript = function( ids, as.vector=FALSE, rm.unreliable=TRUE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  if( rm.unreliable ) {
    ids = unreliable( ids, exclude=TRUE )
    if( is.null( ids ) ) {
      return( NULL )
    }
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'cdnatranscript' ), .xmap.types$cdnatranscript, as.vector )
}
.xmap.queries$probeset.to.exon = "CALL probeset_to_exon( '${array}', '${ids}' )"
probesetToExon = function( ids, as.vector=FALSE, rm.unreliable=TRUE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  if( rm.unreliable ) {
    ids = unreliable( ids, exclude=TRUE )
    if( is.null( ids ) ) {
      return( NULL )
    }
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'exon' ), .xmap.types$exon, as.vector )
}
.xmap.queries$probeset.to.est_gene = "CALL probeset_to_est_gene( '${array}', '${ids}' )"
probesetToEstGene = function( ids, as.vector=FALSE, rm.unreliable=TRUE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  if( rm.unreliable ) {
    ids = unreliable( ids, exclude=TRUE )
    if( is.null( ids ) ) {
      return( NULL )
    }
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'est_gene' ), .xmap.types$est_gene, as.vector )
}
.xmap.queries$probeset.to.est_transcript = "CALL probeset_to_est_transcript( '${array}', '${ids}' )"
probesetToEstTranscript = function( ids, as.vector=FALSE, rm.unreliable=TRUE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  if( rm.unreliable ) {
    ids = unreliable( ids, exclude=TRUE )
    if( is.null( ids ) ) {
      return( NULL )
    }
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'est_transcript' ), .xmap.types$est_transcript, as.vector )
}
.xmap.queries$probeset.to.est_exon = "CALL probeset_to_est_exon( '${array}', '${ids}' )"
probesetToEstExon = function( ids, as.vector=FALSE, rm.unreliable=TRUE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  if( rm.unreliable ) {
    ids = unreliable( ids, exclude=TRUE )
    if( is.null( ids ) ) {
      return( NULL )
    }
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'est_exon' ), .xmap.types$est_exon, as.vector )
}
.xmap.queries$probeset.to.probe = "CALL probeset_to_probe( '${array}', '${ids}' )"
probesetToProbe = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'probe' ), .xmap.types$probe, as.vector )
}
.xmap.queries$probeset.to.hit = "CALL probeset_to_hit( '${array}', '${ids}' )"
probesetToHit = function( ids, as.data.frame=FALSE, rm.unreliable=TRUE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  if( rm.unreliable ) {
    ids = unreliable( ids, exclude=TRUE )
    if( is.null( ids ) ) {
      return( NULL )
    }
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'hit' ), 'keep_in1', as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$probeset.to.prediction_transcript = "CALL probeset_to_prediction_transcript( '${array}', '${ids}' )"
probesetToPredictionTranscript = function( ids, as.vector=FALSE, rm.unreliable=TRUE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  if( rm.unreliable ) {
    ids = unreliable( ids, exclude=TRUE )
    if( is.null( ids ) ) {
      return( NULL )
    }
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'prediction_transcript' ), .xmap.types$prediction_transcript, as.vector )
}
.xmap.queries$probeset.to.protein = "CALL probeset_to_protein( '${array}', '${ids}' )"
probesetToProtein = function( ids, as.vector=FALSE, rm.unreliable=TRUE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  if( rm.unreliable ) {
    ids = unreliable( ids, exclude=TRUE )
    if( is.null( ids ) ) {
      return( NULL )
    }
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'protein' ), .xmap.types$protein, as.vector )
}
.xmap.queries$probeset.to.domain = "CALL probeset_to_domain( '${array}', '${ids}' )"
probesetToDomain = function( ids, as.vector=FALSE, rm.unreliable=TRUE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  if( rm.unreliable ) {
    ids = unreliable( ids, exclude=TRUE )
    if( is.null( ids ) ) {
      return( NULL )
    }
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probeset', .params, 'domain' ), .xmap.types$domain, as.vector )
}
.xmap.queries$probe.all = "CALL all_probes( '${array}' )"
allProbes = function( as.vector=FALSE ) {
  .coerce( .process( "all", "probe" ), .xmap.types$probe, as.vector )
}
.xmap.queries$probe.details = "CALL probe_details( '${array}', '${ids}' )"
probeDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "probe", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$probe.range = "CALL probes_in_range_quick( '${array}', '${chr}', ${qstart}, ${qstop}, ${qstrand} )"

probeInRange = function( x, ..., as.vector=FALSE ) { standardGeneric( 'probeInRange' ) }
setGeneric( 'probeInRange', probeInRange )
setMethod(  'probeInRange', signature( x='character' ),  function( x, start, end, strand, ..., as.vector=FALSE ) {
  if( length( x ) > 1 ) {
    if( length( unique( c( length( x ), length( start ), length( end ), length( strand ) ) ) ) != 1 ) {
      stop( 'All parameters "x", "start", "end", and "strand" must be the same length.' )
    }
    probeInRange( data.frame( chr=x, start=start, end=end, strand=strand ), as.vector=as.vector )
  }
  else {
    if( is.na( strand ) || strand == 0 ) {
      if( as.vector == 'data.frame' || ( as.vector == FALSE && !.usegranges() ) ) {
        rbind( .range.call( x, start, end,  1, 'probe', .xmap.types$probe, as.vector=as.vector ),
               .range.call( x, start, end, -1, 'probe', .xmap.types$probe, as.vector=as.vector ) )
      }
      else {
        .fwd = .range.call( x, start, end,  1, 'probe', .xmap.types$probe, as.vector=as.vector )
        .rev = .range.call( x, start, end, -1, 'probe', .xmap.types$probe, as.vector=as.vector )
        if( is.null( .fwd ) ) .rev else if( is.null( .rev ) ) .fwd else c( .fwd, .rev )
      }
    }
    else {
      .range.call( x, start, end, strand, 'probe', .xmap.types$probe, as.vector=as.vector )
    }
  }
} )
setMethod(  'probeInRange', signature( x='factor' ),     function( x, start, end, strand, ..., as.vector=FALSE ) {
  probeInRange( as.character( x ), as.numeric( start ), as.numeric( end ), as.numeric( strand ), 'probe', .xmap.types$probe, as.vector=as.vector )
} )
setMethod(  'probeInRange', signature( x='data.frame' ), function( x, as.vector=FALSE ) {
  probeInRange( .data.frame.to.rangeddata( x ), as.vector=as.vector )
} )
setMethod(  'probeInRange', signature( x='RangedData' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, probeInRange, as.vector=as.vector ) 
} )
setMethod(  'probeInRange', signature( x='NULL' ), function( x, as.vector=FALSE ) {
  return( NULL )
} )
setMethod(  'probeInRange', signature( x='GRanges' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, probeInRange, as.vector=as.vector )
} )

.xmap.queries$probe.to.hit = "CALL probe_to_hit( '${array}', '${ids}' )"
probeToHit = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probe', .params, 'hit' ), 'keep_in1', as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$probe.to.probeset = "CALL probe_to_probeset( '${array}', '${ids}' )"
probeToProbeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'probe', .params, 'probeset' ), .xmap.types$probeset, as.vector )
}
.xmap.queries$protein.all = "CALL all_proteins(  )"
allProteins = function( as.vector=FALSE ) {
  .coerce( .process( "all", "protein" ), .xmap.types$protein, as.vector )
}
.xmap.queries$protein.details = "CALL protein_details( '${ids}' )"
proteinDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "protein", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$protein.range = "CALL proteins_in_range( '${chr}', ${qstart}, ${qstop}, ${qstrand} )"

proteinInRange = function( x, ..., as.vector=FALSE ) { standardGeneric( 'proteinInRange' ) }
setGeneric( 'proteinInRange', proteinInRange )
setMethod(  'proteinInRange', signature( x='character' ),  function( x, start, end, strand, ..., as.vector=FALSE ) {
  if( length( x ) > 1 ) {
    if( length( unique( c( length( x ), length( start ), length( end ), length( strand ) ) ) ) != 1 ) {
      stop( 'All parameters "x", "start", "end", and "strand" must be the same length.' )
    }
    proteinInRange( data.frame( chr=x, start=start, end=end, strand=strand ), as.vector=as.vector )
  }
  else {
    if( is.na( strand ) || strand == 0 ) {
      if( as.vector == 'data.frame' || ( as.vector == FALSE && !.usegranges() ) ) {
        rbind( .range.call( x, start, end,  1, 'protein', .xmap.types$protein, as.vector=as.vector ),
               .range.call( x, start, end, -1, 'protein', .xmap.types$protein, as.vector=as.vector ) )
      }
      else {
        .fwd = .range.call( x, start, end,  1, 'protein', .xmap.types$protein, as.vector=as.vector )
        .rev = .range.call( x, start, end, -1, 'protein', .xmap.types$protein, as.vector=as.vector )
        if( is.null( .fwd ) ) .rev else if( is.null( .rev ) ) .fwd else c( .fwd, .rev )
      }
    }
    else {
      .range.call( x, start, end, strand, 'protein', .xmap.types$protein, as.vector=as.vector )
    }
  }
} )
setMethod(  'proteinInRange', signature( x='factor' ),     function( x, start, end, strand, ..., as.vector=FALSE ) {
  proteinInRange( as.character( x ), as.numeric( start ), as.numeric( end ), as.numeric( strand ), 'protein', .xmap.types$protein, as.vector=as.vector )
} )
setMethod(  'proteinInRange', signature( x='data.frame' ), function( x, as.vector=FALSE ) {
  proteinInRange( .data.frame.to.rangeddata( x ), as.vector=as.vector )
} )
setMethod(  'proteinInRange', signature( x='RangedData' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, proteinInRange, as.vector=as.vector ) 
} )
setMethod(  'proteinInRange', signature( x='NULL' ), function( x, as.vector=FALSE ) {
  return( NULL )
} )
setMethod(  'proteinInRange', signature( x='GRanges' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, proteinInRange, as.vector=as.vector )
} )

.xmap.queries$protein.to.domain = "CALL protein_to_domain( '${ids}' )"
proteinToDomain = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'protein', .params, 'domain' ), .xmap.types$domain, as.vector )
}
.xmap.queries$protein.to.gene = "CALL protein_to_gene( '${ids}' )"
proteinToGene = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'protein', .params, 'gene' ), .xmap.types$gene, as.vector )
}
.xmap.queries$protein.to.transcript = "CALL protein_to_transcript( '${ids}' )"
proteinToTranscript = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'protein', .params, 'transcript' ), .xmap.types$transcript, as.vector )
}
.xmap.queries$protein.to.probeset = "CALL protein_to_probeset( '${array}', '${ids}' )"
proteinToProbeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'protein', .params, 'probeset' ), .xmap.types$probeset, as.vector )
}
.xmap.queries$domain.all = "CALL all_domains(  )"
allDomains = function( as.vector=FALSE ) {
  .coerce( .process( "all", "domain" ), .xmap.types$domain, as.vector )
}
.xmap.queries$domain.details = "CALL domain_details( '${ids}' )"
domainDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "domain", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$domain.range = "CALL domains_in_range( '${chr}', ${qstart}, ${qstop}, ${qstrand} )"

domainInRange = function( x, ..., as.vector=FALSE ) { standardGeneric( 'domainInRange' ) }
setGeneric( 'domainInRange', domainInRange )
setMethod(  'domainInRange', signature( x='character' ),  function( x, start, end, strand, ..., as.vector=FALSE ) {
  if( length( x ) > 1 ) {
    if( length( unique( c( length( x ), length( start ), length( end ), length( strand ) ) ) ) != 1 ) {
      stop( 'All parameters "x", "start", "end", and "strand" must be the same length.' )
    }
    domainInRange( data.frame( chr=x, start=start, end=end, strand=strand ), as.vector=as.vector )
  }
  else {
    if( is.na( strand ) || strand == 0 ) {
      if( as.vector == 'data.frame' || ( as.vector == FALSE && !.usegranges() ) ) {
        rbind( .range.call( x, start, end,  1, 'domain', .xmap.types$domain, as.vector=as.vector ),
               .range.call( x, start, end, -1, 'domain', .xmap.types$domain, as.vector=as.vector ) )
      }
      else {
        .fwd = .range.call( x, start, end,  1, 'domain', .xmap.types$domain, as.vector=as.vector )
        .rev = .range.call( x, start, end, -1, 'domain', .xmap.types$domain, as.vector=as.vector )
        if( is.null( .fwd ) ) .rev else if( is.null( .rev ) ) .fwd else c( .fwd, .rev )
      }
    }
    else {
      .range.call( x, start, end, strand, 'domain', .xmap.types$domain, as.vector=as.vector )
    }
  }
} )
setMethod(  'domainInRange', signature( x='factor' ),     function( x, start, end, strand, ..., as.vector=FALSE ) {
  domainInRange( as.character( x ), as.numeric( start ), as.numeric( end ), as.numeric( strand ), 'domain', .xmap.types$domain, as.vector=as.vector )
} )
setMethod(  'domainInRange', signature( x='data.frame' ), function( x, as.vector=FALSE ) {
  domainInRange( .data.frame.to.rangeddata( x ), as.vector=as.vector )
} )
setMethod(  'domainInRange', signature( x='RangedData' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, domainInRange, as.vector=as.vector ) 
} )
setMethod(  'domainInRange', signature( x='NULL' ), function( x, as.vector=FALSE ) {
  return( NULL )
} )
setMethod(  'domainInRange', signature( x='GRanges' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, domainInRange, as.vector=as.vector )
} )

.xmap.queries$domain.to.protein = "CALL domain_to_protein( '${ids}' )"
domainToProtein = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'domain', .params, 'protein' ), .xmap.types$protein, as.vector )
}
.xmap.queries$domain.to.gene = "CALL domain_to_gene( '${ids}' )"
domainToGene = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'domain', .params, 'gene' ), .xmap.types$gene, as.vector )
}
.xmap.queries$domain.to.transcript = "CALL domain_to_transcript( '${ids}' )"
domainToTranscript = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'domain', .params, 'transcript' ), .xmap.types$transcript, as.vector )
}
.xmap.queries$domain.to.probeset = "CALL domain_to_probeset( '${array}', '${ids}' )"
domainToProbeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'domain', .params, 'probeset' ), .xmap.types$probeset, as.vector )
}
.xmap.queries$chromosome.all = "CALL all_chromosomes(  )"
allChromosomes = function( as.vector=FALSE ) {
  .coerce( .process( "all", "chromosome" ), .xmap.types$chromosome, as.vector )
}
.xmap.queries$chromosome.details = "CALL chromosome_details( '${ids}' )"
chromosomeDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "chromosome", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$gene.all = "CALL all_genes(  )"
allGenes = function( as.vector=FALSE ) {
  .coerce( .process( "all", "gene" ), .xmap.types$gene, as.vector )
}
.xmap.queries$gene.details = "CALL gene_details( '${ids}' )"
geneDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "gene", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$gene.range = "CALL genes_in_range( '${chr}', ${qstart}, ${qstop}, ${qstrand} )"

geneInRange = function( x, ..., as.vector=FALSE ) { standardGeneric( 'geneInRange' ) }
setGeneric( 'geneInRange', geneInRange )
setMethod(  'geneInRange', signature( x='character' ),  function( x, start, end, strand, ..., as.vector=FALSE ) {
  if( length( x ) > 1 ) {
    if( length( unique( c( length( x ), length( start ), length( end ), length( strand ) ) ) ) != 1 ) {
      stop( 'All parameters "x", "start", "end", and "strand" must be the same length.' )
    }
    geneInRange( data.frame( chr=x, start=start, end=end, strand=strand ), as.vector=as.vector )
  }
  else {
    if( is.na( strand ) || strand == 0 ) {
      if( as.vector == 'data.frame' || ( as.vector == FALSE && !.usegranges() ) ) {
        rbind( .range.call( x, start, end,  1, 'gene', .xmap.types$gene, as.vector=as.vector ),
               .range.call( x, start, end, -1, 'gene', .xmap.types$gene, as.vector=as.vector ) )
      }
      else {
        .fwd = .range.call( x, start, end,  1, 'gene', .xmap.types$gene, as.vector=as.vector )
        .rev = .range.call( x, start, end, -1, 'gene', .xmap.types$gene, as.vector=as.vector )
        if( is.null( .fwd ) ) .rev else if( is.null( .rev ) ) .fwd else c( .fwd, .rev )
      }
    }
    else {
      .range.call( x, start, end, strand, 'gene', .xmap.types$gene, as.vector=as.vector )
    }
  }
} )
setMethod(  'geneInRange', signature( x='factor' ),     function( x, start, end, strand, ..., as.vector=FALSE ) {
  geneInRange( as.character( x ), as.numeric( start ), as.numeric( end ), as.numeric( strand ), 'gene', .xmap.types$gene, as.vector=as.vector )
} )
setMethod(  'geneInRange', signature( x='data.frame' ), function( x, as.vector=FALSE ) {
  geneInRange( .data.frame.to.rangeddata( x ), as.vector=as.vector )
} )
setMethod(  'geneInRange', signature( x='RangedData' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, geneInRange, as.vector=as.vector ) 
} )
setMethod(  'geneInRange', signature( x='NULL' ), function( x, as.vector=FALSE ) {
  return( NULL )
} )
setMethod(  'geneInRange', signature( x='GRanges' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, geneInRange, as.vector=as.vector )
} )

.xmap.queries$gene.to.transcript = "CALL gene_to_transcript( '${ids}' )"
geneToTranscript = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'gene', .params, 'transcript' ), .xmap.types$transcript, as.vector )
}
.xmap.queries$gene.to.exon = "CALL gene_to_exon( '${ids}' )"
geneToExon = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'gene', .params, 'exon' ), .xmap.types$exon, as.vector )
}
.xmap.queries$gene.to.exon_probeset = "CALL gene_to_exon_probeset( '${array}', '${ids}' )"
geneToExonProbeset = function( ids, as.vector=FALSE, probes.min=4 ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  r = .process( 'to', 'gene', .params, 'exon_probeset' )
  r[r[,'num_probes'] >= probes.min, , drop = FALSE]
 .coerce( r, 'probeset', as.vector )
}
.xmap.queries$gene.to.probeset = "CALL gene_to_probeset( '${array}', '${ids}' )"
geneToProbeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'gene', .params, 'probeset' ), .xmap.types$probeset, as.vector )
}
.xmap.queries$gene.to.synonym = "CALL gene_to_synonym( '${ids}' )"
geneToSynonym = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'gene', .params, 'synonym' ), .xmap.types$synonym, as.vector )
}
.xmap.queries$gene.to.protein = "CALL gene_to_protein( '${ids}' )"
geneToProtein = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'gene', .params, 'protein' ), .xmap.types$protein, as.vector )
}
.xmap.queries$gene.to.domain = "CALL gene_to_domain( '${ids}' )"
geneToDomain = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'gene', .params, 'domain' ), .xmap.types$domain, as.vector )
}
.xmap.queries$transcript.all = "CALL all_transcripts(  )"
allTranscripts = function( as.vector=FALSE ) {
  .coerce( .process( "all", "transcript" ), .xmap.types$transcript, as.vector )
}
.xmap.queries$transcript.details = "CALL transcript_details( '${ids}' )"
transcriptDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "transcript", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$transcript.range = "CALL transcripts_in_range( '${chr}', ${qstart}, ${qstop}, ${qstrand} )"

transcriptInRange = function( x, ..., as.vector=FALSE ) { standardGeneric( 'transcriptInRange' ) }
setGeneric( 'transcriptInRange', transcriptInRange )
setMethod(  'transcriptInRange', signature( x='character' ),  function( x, start, end, strand, ..., as.vector=FALSE ) {
  if( length( x ) > 1 ) {
    if( length( unique( c( length( x ), length( start ), length( end ), length( strand ) ) ) ) != 1 ) {
      stop( 'All parameters "x", "start", "end", and "strand" must be the same length.' )
    }
    transcriptInRange( data.frame( chr=x, start=start, end=end, strand=strand ), as.vector=as.vector )
  }
  else {
    if( is.na( strand ) || strand == 0 ) {
      if( as.vector == 'data.frame' || ( as.vector == FALSE && !.usegranges() ) ) {
        rbind( .range.call( x, start, end,  1, 'transcript', .xmap.types$transcript, as.vector=as.vector ),
               .range.call( x, start, end, -1, 'transcript', .xmap.types$transcript, as.vector=as.vector ) )
      }
      else {
        .fwd = .range.call( x, start, end,  1, 'transcript', .xmap.types$transcript, as.vector=as.vector )
        .rev = .range.call( x, start, end, -1, 'transcript', .xmap.types$transcript, as.vector=as.vector )
        if( is.null( .fwd ) ) .rev else if( is.null( .rev ) ) .fwd else c( .fwd, .rev )
      }
    }
    else {
      .range.call( x, start, end, strand, 'transcript', .xmap.types$transcript, as.vector=as.vector )
    }
  }
} )
setMethod(  'transcriptInRange', signature( x='factor' ),     function( x, start, end, strand, ..., as.vector=FALSE ) {
  transcriptInRange( as.character( x ), as.numeric( start ), as.numeric( end ), as.numeric( strand ), 'transcript', .xmap.types$transcript, as.vector=as.vector )
} )
setMethod(  'transcriptInRange', signature( x='data.frame' ), function( x, as.vector=FALSE ) {
  transcriptInRange( .data.frame.to.rangeddata( x ), as.vector=as.vector )
} )
setMethod(  'transcriptInRange', signature( x='RangedData' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, transcriptInRange, as.vector=as.vector ) 
} )
setMethod(  'transcriptInRange', signature( x='NULL' ), function( x, as.vector=FALSE ) {
  return( NULL )
} )
setMethod(  'transcriptInRange', signature( x='GRanges' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, transcriptInRange, as.vector=as.vector )
} )

.xmap.queries$transcript.to.gene = "CALL transcript_to_gene( '${ids}' )"
transcriptToGene = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'transcript', .params, 'gene' ), .xmap.types$gene, as.vector )
}
.xmap.queries$transcript.to.exon = "CALL transcript_to_exon( '${ids}' )"
transcriptToExon = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'transcript', .params, 'exon' ), .xmap.types$exon, as.vector )
}
.xmap.queries$transcript.to.exon_probeset = "CALL transcript_to_exon_probeset( '${array}', '${ids}' )"
transcriptToExonProbeset = function( ids, as.vector=FALSE, probes.min=4 ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  r = .process( 'to', 'transcript', .params, 'exon_probeset' )
  r[r[,'num_probes'] >= probes.min, , drop = FALSE]
 .coerce( r, .xmap.types$probeset, as.vector )
}
.xmap.queries$transcript.to.probeset = "CALL transcript_to_probeset( '${array}', '${ids}' )"
transcriptToProbeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'transcript', .params, 'probeset' ), .xmap.types$probeset, as.vector )
}
.xmap.queries$transcript.to.cdnaprobeset = "CALL transcript_to_cdnaprobeset( '${array}', '${ids}' )"
transcriptToCdnaprobeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'transcript', .params, 'cdnaprobeset' ), .xmap.types$cdnaprobeset, as.vector )
}
.xmap.queries$transcript.to.synonym = "CALL transcript_to_synonym( '${ids}' )"
transcriptToSynonym = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'transcript', .params, 'synonym' ), .xmap.types$synonym, as.vector )
}
.xmap.queries$transcript.to.protein = "CALL transcript_to_protein( '${ids}' )"
transcriptToProtein = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'transcript', .params, 'protein' ), .xmap.types$protein, as.vector )
}
.xmap.queries$transcript.to.domain = "CALL transcript_to_domain( '${ids}' )"
transcriptToDomain = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'transcript', .params, 'domain' ), .xmap.types$domain, as.vector )
}
.xmap.queries$exon.all = "CALL all_exons(  )"
allExons = function( as.vector=FALSE ) {
  .coerce( .process( "all", "exon" ), .xmap.types$exon, as.vector )
}
.xmap.queries$exon.details = "CALL exon_details( '${ids}' )"
exonDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "exon", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$exon.range = "CALL exons_in_range( '${chr}', ${qstart}, ${qstop}, ${qstrand} )"

exonInRange = function( x, ..., as.vector=FALSE ) { standardGeneric( 'exonInRange' ) }
setGeneric( 'exonInRange', exonInRange )
setMethod(  'exonInRange', signature( x='character' ),  function( x, start, end, strand, ..., as.vector=FALSE ) {
  if( length( x ) > 1 ) {
    if( length( unique( c( length( x ), length( start ), length( end ), length( strand ) ) ) ) != 1 ) {
      stop( 'All parameters "x", "start", "end", and "strand" must be the same length.' )
    }
    exonInRange( data.frame( chr=x, start=start, end=end, strand=strand ), as.vector=as.vector )
  }
  else {
    if( is.na( strand ) || strand == 0 ) {
      if( as.vector == 'data.frame' || ( as.vector == FALSE && !.usegranges() ) ) {
        rbind( .range.call( x, start, end,  1, 'exon', .xmap.types$exon, as.vector=as.vector ),
               .range.call( x, start, end, -1, 'exon', .xmap.types$exon, as.vector=as.vector ) )
      }
      else {
        .fwd = .range.call( x, start, end,  1, 'exon', .xmap.types$exon, as.vector=as.vector )
        .rev = .range.call( x, start, end, -1, 'exon', .xmap.types$exon, as.vector=as.vector )
        if( is.null( .fwd ) ) .rev else if( is.null( .rev ) ) .fwd else c( .fwd, .rev )
      }
    }
    else {
      .range.call( x, start, end, strand, 'exon', .xmap.types$exon, as.vector=as.vector )
    }
  }
} )
setMethod(  'exonInRange', signature( x='factor' ),     function( x, start, end, strand, ..., as.vector=FALSE ) {
  exonInRange( as.character( x ), as.numeric( start ), as.numeric( end ), as.numeric( strand ), 'exon', .xmap.types$exon, as.vector=as.vector )
} )
setMethod(  'exonInRange', signature( x='data.frame' ), function( x, as.vector=FALSE ) {
  exonInRange( .data.frame.to.rangeddata( x ), as.vector=as.vector )
} )
setMethod(  'exonInRange', signature( x='RangedData' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, exonInRange, as.vector=as.vector ) 
} )
setMethod(  'exonInRange', signature( x='NULL' ), function( x, as.vector=FALSE ) {
  return( NULL )
} )
setMethod(  'exonInRange', signature( x='GRanges' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, exonInRange, as.vector=as.vector )
} )

.xmap.queries$exon.to.gene = "CALL exon_to_gene( '${ids}' )"
exonToGene = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'exon', .params, 'gene' ), .xmap.types$gene, as.vector )
}
.xmap.queries$exon.to.transcript = "CALL exon_to_transcript( '${ids}' )"
exonToTranscript = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'exon', .params, 'transcript' ), .xmap.types$transcript, as.vector )
}
.xmap.queries$exon.to.probeset = "CALL exon_to_probeset( '${array}', '${ids}' )"
exonToProbeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'exon', .params, 'probeset' ), .xmap.types$probeset, as.vector )
}
.xmap.queries$est_gene.all = "CALL all_est_genes(  )"
allEstGenes = function( as.vector=FALSE ) {
  .coerce( .process( "all", "est_gene" ), .xmap.types$est_gene, as.vector )
}
.xmap.queries$est_gene.details = "CALL est_gene_details( '${ids}' )"
estGeneDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "est_gene", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$est_gene.range = "CALL est_genes_in_range( '${chr}', ${qstart}, ${qstop}, ${qstrand} )"

estGeneInRange = function( x, ..., as.vector=FALSE ) { standardGeneric( 'estGeneInRange' ) }
setGeneric( 'estGeneInRange', estGeneInRange )
setMethod(  'estGeneInRange', signature( x='character' ),  function( x, start, end, strand, ..., as.vector=FALSE ) {
  if( length( x ) > 1 ) {
    if( length( unique( c( length( x ), length( start ), length( end ), length( strand ) ) ) ) != 1 ) {
      stop( 'All parameters "x", "start", "end", and "strand" must be the same length.' )
    }
    estGeneInRange( data.frame( chr=x, start=start, end=end, strand=strand ), as.vector=as.vector )
  }
  else {
    if( is.na( strand ) || strand == 0 ) {
      if( as.vector == 'data.frame' || ( as.vector == FALSE && !.usegranges() ) ) {
        rbind( .range.call( x, start, end,  1, 'est_gene', .xmap.types$est_gene, as.vector=as.vector ),
               .range.call( x, start, end, -1, 'est_gene', .xmap.types$est_gene, as.vector=as.vector ) )
      }
      else {
        .fwd = .range.call( x, start, end,  1, 'est_gene', .xmap.types$est_gene, as.vector=as.vector )
        .rev = .range.call( x, start, end, -1, 'est_gene', .xmap.types$est_gene, as.vector=as.vector )
        if( is.null( .fwd ) ) .rev else if( is.null( .rev ) ) .fwd else c( .fwd, .rev )
      }
    }
    else {
      .range.call( x, start, end, strand, 'est_gene', .xmap.types$est_gene, as.vector=as.vector )
    }
  }
} )
setMethod(  'estGeneInRange', signature( x='factor' ),     function( x, start, end, strand, ..., as.vector=FALSE ) {
  estGeneInRange( as.character( x ), as.numeric( start ), as.numeric( end ), as.numeric( strand ), 'est_gene', .xmap.types$est_gene, as.vector=as.vector )
} )
setMethod(  'estGeneInRange', signature( x='data.frame' ), function( x, as.vector=FALSE ) {
  estGeneInRange( .data.frame.to.rangeddata( x ), as.vector=as.vector )
} )
setMethod(  'estGeneInRange', signature( x='RangedData' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, estGeneInRange, as.vector=as.vector ) 
} )
setMethod(  'estGeneInRange', signature( x='NULL' ), function( x, as.vector=FALSE ) {
  return( NULL )
} )
setMethod(  'estGeneInRange', signature( x='GRanges' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, estGeneInRange, as.vector=as.vector )
} )

.xmap.queries$est_gene.to.est_transcript = "CALL est_gene_to_est_transcript( '${ids}' )"
estGeneToEstTranscript = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'est_gene', .params, 'est_transcript' ), .xmap.types$est_transcript, as.vector )
}
.xmap.queries$est_gene.to.est_exon = "CALL est_gene_to_est_exon( '${ids}' )"
estGeneToEstExon = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'est_gene', .params, 'est_exon' ), .xmap.types$est_exon, as.vector )
}
.xmap.queries$est_gene.to.probeset = "CALL est_gene_to_probeset( '${array}', '${ids}' )"
estGeneToProbeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'est_gene', .params, 'probeset' ), .xmap.types$probeset, as.vector )
}
.xmap.queries$est_transcript.all = "CALL all_est_transcripts(  )"
allEstTranscripts = function( as.vector=FALSE ) {
  .coerce( .process( "all", "est_transcript" ), .xmap.types$est_transcript, as.vector )
}
.xmap.queries$est_transcript.details = "CALL est_transcript_details( '${ids}' )"
estTranscriptDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "est_transcript", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$est_transcript.range = "CALL est_transcripts_in_range( '${chr}', ${qstart}, ${qstop}, ${qstrand} )"

estTranscriptInRange = function( x, ..., as.vector=FALSE ) { standardGeneric( 'estTranscriptInRange' ) }
setGeneric( 'estTranscriptInRange', estTranscriptInRange )
setMethod(  'estTranscriptInRange', signature( x='character' ),  function( x, start, end, strand, ..., as.vector=FALSE ) {
  if( length( x ) > 1 ) {
    if( length( unique( c( length( x ), length( start ), length( end ), length( strand ) ) ) ) != 1 ) {
      stop( 'All parameters "x", "start", "end", and "strand" must be the same length.' )
    }
    estTranscriptInRange( data.frame( chr=x, start=start, end=end, strand=strand ), as.vector=as.vector )
  }
  else {
    if( is.na( strand ) || strand == 0 ) {
      if( as.vector == 'data.frame' || ( as.vector == FALSE && !.usegranges() ) ) {
        rbind( .range.call( x, start, end,  1, 'est_transcript', .xmap.types$est_transcript, as.vector=as.vector ),
               .range.call( x, start, end, -1, 'est_transcript', .xmap.types$est_transcript, as.vector=as.vector ) )
      }
      else {
        .fwd = .range.call( x, start, end,  1, 'est_transcript', .xmap.types$est_transcript, as.vector=as.vector )
        .rev = .range.call( x, start, end, -1, 'est_transcript', .xmap.types$est_transcript, as.vector=as.vector )
        if( is.null( .fwd ) ) .rev else if( is.null( .rev ) ) .fwd else c( .fwd, .rev )
      }
    }
    else {
      .range.call( x, start, end, strand, 'est_transcript', .xmap.types$est_transcript, as.vector=as.vector )
    }
  }
} )
setMethod(  'estTranscriptInRange', signature( x='factor' ),     function( x, start, end, strand, ..., as.vector=FALSE ) {
  estTranscriptInRange( as.character( x ), as.numeric( start ), as.numeric( end ), as.numeric( strand ), 'est_transcript', .xmap.types$est_transcript, as.vector=as.vector )
} )
setMethod(  'estTranscriptInRange', signature( x='data.frame' ), function( x, as.vector=FALSE ) {
  estTranscriptInRange( .data.frame.to.rangeddata( x ), as.vector=as.vector )
} )
setMethod(  'estTranscriptInRange', signature( x='RangedData' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, estTranscriptInRange, as.vector=as.vector ) 
} )
setMethod(  'estTranscriptInRange', signature( x='NULL' ), function( x, as.vector=FALSE ) {
  return( NULL )
} )
setMethod(  'estTranscriptInRange', signature( x='GRanges' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, estTranscriptInRange, as.vector=as.vector )
} )

.xmap.queries$est_transcript.to.est_gene = "CALL est_transcript_to_est_gene( '${ids}' )"
estTranscriptToEstGene = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'est_transcript', .params, 'est_gene' ), .xmap.types$est_gene, as.vector )
}
.xmap.queries$est_transcript.to.est_exon = "CALL est_transcript_to_est_exon( '${ids}' )"
estTranscriptToEstExon = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'est_transcript', .params, 'est_exon' ), .xmap.types$est_exon, as.vector )
}
.xmap.queries$est_transcript.to.probeset = "CALL est_transcript_to_probeset( '${array}', '${ids}' )"
estTranscriptToProbeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'est_transcript', .params, 'probeset' ), .xmap.types$probeset, as.vector )
}
.xmap.queries$est_exon.all = "CALL all_est_exons(  )"
allEstExons = function( as.vector=FALSE ) {
  .coerce( .process( "all", "est_exon" ), .xmap.types$est_exon, as.vector )
}
.xmap.queries$est_exon.details = "CALL est_exon_details( '${ids}' )"
estExonDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "est_exon", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$est_exon.range = "CALL est_exons_in_range( '${chr}', ${qstart}, ${qstop}, ${qstrand} )"

estExonInRange = function( x, ..., as.vector=FALSE ) { standardGeneric( 'estExonInRange' ) }
setGeneric( 'estExonInRange', estExonInRange )
setMethod(  'estExonInRange', signature( x='character' ),  function( x, start, end, strand, ..., as.vector=FALSE ) {
  if( length( x ) > 1 ) {
    if( length( unique( c( length( x ), length( start ), length( end ), length( strand ) ) ) ) != 1 ) {
      stop( 'All parameters "x", "start", "end", and "strand" must be the same length.' )
    }
    estExonInRange( data.frame( chr=x, start=start, end=end, strand=strand ), as.vector=as.vector )
  }
  else {
    if( is.na( strand ) || strand == 0 ) {
      if( as.vector == 'data.frame' || ( as.vector == FALSE && !.usegranges() ) ) {
        rbind( .range.call( x, start, end,  1, 'est_exon', .xmap.types$est_exon, as.vector=as.vector ),
               .range.call( x, start, end, -1, 'est_exon', .xmap.types$est_exon, as.vector=as.vector ) )
      }
      else {
        .fwd = .range.call( x, start, end,  1, 'est_exon', .xmap.types$est_exon, as.vector=as.vector )
        .rev = .range.call( x, start, end, -1, 'est_exon', .xmap.types$est_exon, as.vector=as.vector )
        if( is.null( .fwd ) ) .rev else if( is.null( .rev ) ) .fwd else c( .fwd, .rev )
      }
    }
    else {
      .range.call( x, start, end, strand, 'est_exon', .xmap.types$est_exon, as.vector=as.vector )
    }
  }
} )
setMethod(  'estExonInRange', signature( x='factor' ),     function( x, start, end, strand, ..., as.vector=FALSE ) {
  estExonInRange( as.character( x ), as.numeric( start ), as.numeric( end ), as.numeric( strand ), 'est_exon', .xmap.types$est_exon, as.vector=as.vector )
} )
setMethod(  'estExonInRange', signature( x='data.frame' ), function( x, as.vector=FALSE ) {
  estExonInRange( .data.frame.to.rangeddata( x ), as.vector=as.vector )
} )
setMethod(  'estExonInRange', signature( x='RangedData' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, estExonInRange, as.vector=as.vector ) 
} )
setMethod(  'estExonInRange', signature( x='NULL' ), function( x, as.vector=FALSE ) {
  return( NULL )
} )
setMethod(  'estExonInRange', signature( x='GRanges' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, estExonInRange, as.vector=as.vector )
} )

.xmap.queries$est_exon.to.est_gene = "CALL est_exon_to_est_gene( '${ids}' )"
estExonToEstGene = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'est_exon', .params, 'est_gene' ), .xmap.types$est_gene, as.vector )
}
.xmap.queries$est_exon.to.est_transcript = "CALL est_exon_to_est_transcript( '${ids}' )"
estExonToEstTranscript = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'est_exon', .params, 'est_transcript' ), .xmap.types$est_transcript, as.vector )
}
.xmap.queries$est_exon.to.probeset = "CALL est_exon_to_probeset( '${array}', '${ids}' )"
estExonToProbeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'est_exon', .params, 'probeset' ), .xmap.types$probeset, as.vector )
}
.xmap.queries$prediction_transcript.all = "CALL all_prediction_transcripts(  )"
allPredictionTranscripts = function( as.vector=FALSE ) {
  .coerce( .process( "all", "prediction_transcript" ), .xmap.types$prediction_transcript, as.vector )
}
.xmap.queries$prediction_transcript.details = "CALL prediction_transcript_details( '${ids}' )"
predictionTranscriptDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "prediction_transcript", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$prediction_transcript.range = "CALL prediction_transcripts_in_range( '${chr}', ${qstart}, ${qstop}, ${qstrand} )"

predictionTranscriptInRange = function( x, ..., as.vector=FALSE ) { standardGeneric( 'predictionTranscriptInRange' ) }
setGeneric( 'predictionTranscriptInRange', predictionTranscriptInRange )
setMethod(  'predictionTranscriptInRange', signature( x='character' ),  function( x, start, end, strand, ..., as.vector=FALSE ) {
  if( length( x ) > 1 ) {
    if( length( unique( c( length( x ), length( start ), length( end ), length( strand ) ) ) ) != 1 ) {
      stop( 'All parameters "x", "start", "end", and "strand" must be the same length.' )
    }
    predictionTranscriptInRange( data.frame( chr=x, start=start, end=end, strand=strand ), as.vector=as.vector )
  }
  else {
    if( is.na( strand ) || strand == 0 ) {
      if( as.vector == 'data.frame' || ( as.vector == FALSE && !.usegranges() ) ) {
        rbind( .range.call( x, start, end,  1, 'prediction_transcript', .xmap.types$prediction_transcript, as.vector=as.vector ),
               .range.call( x, start, end, -1, 'prediction_transcript', .xmap.types$prediction_transcript, as.vector=as.vector ) )
      }
      else {
        .fwd = .range.call( x, start, end,  1, 'prediction_transcript', .xmap.types$prediction_transcript, as.vector=as.vector )
        .rev = .range.call( x, start, end, -1, 'prediction_transcript', .xmap.types$prediction_transcript, as.vector=as.vector )
        if( is.null( .fwd ) ) .rev else if( is.null( .rev ) ) .fwd else c( .fwd, .rev )
      }
    }
    else {
      .range.call( x, start, end, strand, 'prediction_transcript', .xmap.types$prediction_transcript, as.vector=as.vector )
    }
  }
} )
setMethod(  'predictionTranscriptInRange', signature( x='factor' ),     function( x, start, end, strand, ..., as.vector=FALSE ) {
  predictionTranscriptInRange( as.character( x ), as.numeric( start ), as.numeric( end ), as.numeric( strand ), 'prediction_transcript', .xmap.types$prediction_transcript, as.vector=as.vector )
} )
setMethod(  'predictionTranscriptInRange', signature( x='data.frame' ), function( x, as.vector=FALSE ) {
  predictionTranscriptInRange( .data.frame.to.rangeddata( x ), as.vector=as.vector )
} )
setMethod(  'predictionTranscriptInRange', signature( x='RangedData' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, predictionTranscriptInRange, as.vector=as.vector ) 
} )
setMethod(  'predictionTranscriptInRange', signature( x='NULL' ), function( x, as.vector=FALSE ) {
  return( NULL )
} )
setMethod(  'predictionTranscriptInRange', signature( x='GRanges' ), function( x, as.vector=FALSE ) {
  annmapRangeApply( x, predictionTranscriptInRange, as.vector=as.vector )
} )

.xmap.queries$prediction_transcript.to.prediction_exon = "CALL prediction_transcript_to_prediction_exon( '${ids}' )"
predictionTranscriptToPredictionExon = function( ids ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .process( 'to', 'prediction_transcript', .params, 'prediction_exon' )
}
.xmap.queries$prediction_transcript.to.probeset = "CALL prediction_transcript_to_probeset( '${array}', '${ids}' )"
predictionTranscriptToProbeset = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'prediction_transcript', .params, 'probeset' ), .xmap.types$probeset, as.vector )
}
.xmap.queries$synonym.all = "CALL all_synonyms(  )"
allSynonyms = function( as.vector=FALSE ) {
  .coerce( .process( "all", "synonym" ), .xmap.types$synonym, as.vector )
}
.xmap.queries$synonym.details = "CALL synonym_details( '${ids}' )"
synonymDetails = function( ids, as.data.frame=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( "details", "synonym", .params ), NULL, as.vector=if( as.data.frame == TRUE ) 'data.frame' else as.data.frame )
}
.xmap.queries$synonym.to.gene = "CALL synonym_to_gene( '${ids}' )"
synonymToGene = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'synonym', .params, 'gene' ), .xmap.types$gene, as.vector )
}
.xmap.queries$synonym.to.transcript = "CALL synonym_to_transcript( '${ids}' )"
synonymToTranscript = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'synonym', .params, 'transcript' ), .xmap.types$transcript, as.vector )
}
.xmap.queries$synonym.to.est_gene = "CALL synonym_to_est_gene( '${ids}' )"
synonymToEstGene = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'synonym', .params, 'est_gene' ), .xmap.types$est_gene, as.vector )
}
.xmap.queries$synonym.to.est_transcript = "CALL synonym_to_est_transcript( '${ids}' )"
synonymToEstTranscript = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'synonym', .params, 'est_transcript' ), .xmap.types$est_transcript, as.vector )
}
.xmap.queries$symbol.to.gene = "CALL symbol_to_gene( '${ids}' )"
symbolToGene = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'symbol', .params, 'gene' ), .xmap.types$gene, as.vector )
}
.xmap.queries$symbol.to.transcript = "CALL symbol_to_transcript( '${ids}' )"
symbolToTranscript = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'symbol', .params, 'transcript' ), .xmap.types$transcript, as.vector )
}
.xmap.queries$symbol.to.est_gene = "CALL symbol_to_est_gene( '${ids}' )"
symbolToEstGene = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'symbol', .params, 'est_gene' ), .xmap.types$est_gene, as.vector )
}
.xmap.queries$symbol.to.est_transcript = "CALL symbol_to_est_transcript( '${ids}' )"
symbolToEstTranscript = function( ids, as.vector=FALSE ) {
  if( is.null( ids ) ) {
    return( NULL )
  }
  .params = .make.hash()
  .params$ids = ids
  .coerce( .process( 'to', 'symbol', .params, 'est_transcript' ), .xmap.types$est_transcript, as.vector )
}

# Testing for the utility functions of the package

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
    annmapDisconnect()
}

test.utr = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    gene = symbolToGene( "tp53" )
    probesets.vector = geneToProbeset( gene )
    probesets.frame  = geneToProbeset( gene, as.vector=FALSE )
    
    both.vector = utrProbesets( probesets.vector )
    both.frame  = utrProbesets( probesets.frame )
    checkEquals( length( both.vector ), length( both.frame ), "Should get the same results with Vector and Frame (both UTRs)" )
    
    five.vector = utrProbesets( probesets.vector, end="5" )
    five.frame  = utrProbesets( probesets.frame,  end="5" )
    checkEquals( length( five.vector ), length( five.frame ), "Should get the same results with Vector and Frame (5' end)" )
    
    transcripts = geneToTranscript( gene )
    singletranscript.vector = utrProbesets( probesets.vector, c( transcripts[1] ) )
    singletranscript.frame  = utrProbesets( probesets.frame,  c( transcripts[1] ) )
    checkEquals( length( singletranscript.vector ), length( singletranscript.frame ), "Should get the same results with Vector and Frame on a single Transcript (both UTRs)" )
    
    annmapDisconnect()
  }
}

test.yaoyong.utr.bug = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    # Should not get any intronic probesets back for this transcript
    yy.probesets = utrProbesets( transcriptToProbeset( 'ENST00000378357' ), 'ENST00000378357' )
    checkEquals( length( intronic( yy.probesets ) ), 0 )
  }
}

test.michal.utr.bug = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    # These hit exons inside the UTR exons (not just the exon where translation starts)
    checkEquals( utrProbesets( '3855309', 'ENST00000247005' ), '3855309' )
    checkEquals( utrProbesets( '3855308', 'ENST00000247005' ), '3855308' )
    checkEquals( utrProbesets( '3855297', 'ENST00000247005' ), '3855297' )
    checkEquals( utrProbesets( '3855316', 'ENST00000247005' ), '3855316' )
    # This probeset is inside the translated region
    checkTrue( is.null( utrProbesets( '3855295', 'ENST00000247005' ) ) )
  }
}

test.michal.utr.bug.two = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    g   = 'ENSG00000130283'
    ppp = geneToProbeset( g )
    ttt = geneToTranscript( g )
    checkEquals( length( utrProbesets( ppp, ttt ) ), 26 )
  }
}

# see bug XMAPCORE-3
test.michal.utr.bug.three = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    pp.t = exonic( transcriptToProbeset( 'ENST00000455250' ) )
    checkTrue( length( pp.t ) > 0 )
    checkTrue( is.null( utrProbesets( pp.t, "ENST00000455250" ) ) )
  }
}

test.ANNMAP118 = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    ttcr3 = transcriptToCodingRange( 'ENST00000463968', end='3' )
    checkEquals( length( ttcr3 ), 0 )

    ttcr5 = transcriptToCodingRange( 'ENST00000463968', end='5' )
    checkEquals( length( ttcr5 ), 0 )

    ttcrb = transcriptToCodingRange( 'ENST00000463968', end='both' )
    checkEquals( length( ttcrb ), 0 )
  }


}

# Some sanity checks on the data returned from annmap

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
    annmapDisconnect()
}

test.chaining = function() {
  data = tryCatch( annmapConnect( 'hs-test' ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( paste( "Cannot find datasource 'hs-test' so skipping this test." ) )
  }
  else {
    checkEquals( is.vector( geneToProbeset( symbolToGene( "tp53" ), as.vector=TRUE ) ),
             TRUE,
           "Should return a vector when as.vector is TRUE" )
    checkEquals( is.data.frame( geneToProbeset( symbolToGene( "tp53" ) ) ),
             TRUE,
           "as.vector == false (default) with probesets should return a data.frame" )
    checkEquals( class( probesetToHit( geneToProbeset( symbolToGene( "tp53" ) ) ) )[1],
           annmapGetParam( 'defaultclass' ),
           paste( "default with hits should return a", annmapGetParam( 'defaultclass' ), "object" ) )
    checkEquals( geneToProbeset( symbolToGene( "tp53", as.vector=TRUE ) ),
             geneToProbeset( symbolToGene( "tp53" ) ),
             paste( "Should get the same output no mater whether the input is a vector or", annmapGetParam( 'defaultclass' ) ) )
    annmapDisconnect()
  }
}

.path.for.key = function( key ) {
  paste( file.path( .xmap.internals$cache.root,
            digest( paste( .xmap.internals$species,
                   .xmap.internals$version, 
                   key, sep=':' ),
                algo='md5' ) ),
       '.xmc', sep="" )
}

.cache.store = function( key, data ) {
  path = .path.for.key( key )
  if( is.null( data ) ) {
    unlink( path )
  }
  else {
    file.handle = file( path, open="wb" )
    on.exit( close( file.handle ) )
    save( data, file=file.handle )
  }
  invisible( path )
}

.cache.retrieve = function( key ) {
  path = .path.for.key( key )
  data = NULL
  if( file.exists( path ) ) {
    load( path )
  }
  data
}

.cache.exists = function( key ) {
  path = .path.for.key( key )
  file.exists( path )
}

.set.cache.root = function( path ) {
  .xmap.internals$cache.root = path 
}

annmapClearCache = function() {
  if( is.null( .xmap.internals$initialised ) ) {
    .initialise()
  }
  file.remove( dir( .xmap.internals$cache.root, full.names=TRUE ) )
  invisible()
}

annmapToggleCaching = function() {
  if( is.null( .xmap.internals$initialised ) ) {
    .initialise()
  }
  .xmap.internals$use.cache = !.xmap.internals$use.cache
  .xmap.internals$use.cache
}

# Testing for the cache functions of the package

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
  cache.location = tempdir()
  annmap:::.set.cache.root( cache.location )
  annmapClearCache()
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
  annmapClearCache()
}

test.cache = function() {
  object = letters
  key = "lettersKey"
  
  # Check something doesnt exist
  checkTrue( !annmap:::.cache.exists( key ), "Cached item seems to exist before I created it" )
  
  # Then add it in to the cache
  annmap:::.cache.store( key, object )
  
  # Then check it does exist
  checkTrue( annmap:::.cache.exists( key ), "Cached item not found after I created it" )

  # Then check its value
  checkEquals( annmap:::.cache.retrieve( key ), object, "Got a different object out of the cache from the one I put in there" )
  
  # Then clear the cache
  annmapClearCache()
  
  # Then check it doesnt exist
  checkTrue( !annmap:::.cache.exists( key ), "Cached item seems to exist...but I just cleared the cache" )
}

.get.user.string = function(v,msg) {
  if( v != "<ASK>" ) {
    r = v
  }
  else {
    cat( paste( msg, ":", sep="" ) )
    r = readLines( n=1 )
  }
  r
}

.xmc.all = function( src, params, dest=NULL ) {
  cache.id = paste( src, params$array, .xmap.internals$version, .xmap.internals$species, sep=':' )
  ret = .cache.retrieve( cache.id )
  if( is.null( ret ) ) {
    sql = .build.sql2( .xmap.queries[[ paste( src, "all", sep="." ) ]], params )
    ret = .xmc.db.call( sql, .xmap.internals$con )
    .cache.store( cache.id, ret )
  }
  ret
}

.xmc.details = function( src, params, dest=NULL ) {
  if( is.null( params ) ) {
    return( NULL )
  }
  sql = .build.sql2( .xmap.queries[[ paste( src, "details", sep="." ) ]], params )
  .xmc.db.call( sql, .xmap.internals$con )
}

.xmc.to = function( src, params, dest=NULL ) {
  if( is.null( params ) ) {
    return( NULL )
  }
  sql = .build.sql2( .xmap.queries[[ paste( src, "to", dest, sep="." ) ]], params )
  .xmc.db.call( sql, .xmap.internals$con )
}

.xmc.range = function( src, params, dest=NULL ) {
  sql = .build.sql2( .xmap.queries[[ paste( src, "range", sep="." ) ]], params )
  .xmc.db.call( sql, .xmap.internals$con )
}

.needs.array = function( action, src, dest=NULL ) {
  if( ( action == "all" || action == "details" ) && src == "array" ) {
    FALSE
  }
  else {
    sd = c( src, dest )
    any( sd == "probe" ) || any( sd == "array" ) || any( sd == "probeset" ) || any( sd == "cdnaprobeset" ) || any( sd == "exon_probeset" )
  }
}

.make.params = function( ids ) {
  if( is.null( .xmap.internals$connected ) || !.xmap.internals$connected ) {
    stop( "You need to connect to a database. -- see annmapConnect()")
  }
  if( is.null( ids ) ) {
    stop( "In .make.params, ids is NULL" )
  }
  if( is.list( ids ) ) {
    ids = unlist( ids, use.names=FALSE )
  }
  one       = max( nchar( ids ) ) + 1
  max.list  = .xmap.internals$max.query %/% one
  if( max.list == 0 ) max.list = 1
  n.lists   = length( ids )  %/% max.list
  by.mat    = ( max.list * n.lists )
  .xmap.internals$debugFn( c( "one =", one, " - max.list =", max.list, " - n.lists =", n.lists, " - by.mat =", by.mat ) )
  if( n.lists == 0 ) {
    return( paste( sapply( ids, function( b ) { dbEscapeStrings( .xmap.internals$con, b ) } ), sep=",", collapse="," ) )
  }
  else {
    .xmap.internals$debugFn( c( "Splitting into", n.lists, "queries with", max.list, "entries per query" ) )
    mat = matrix( ids[ 1:by.mat ], nrow=n.lists, byrow=TRUE )
    .xmap.internals$debugFn( c( "matrix dimensions:", dim( mat ) ) )
    r   = split( mat, row( mat ) )
    .xmap.internals$debugFn( c( "length of r is", length( r ) ) )
    if( by.mat < length( ids ) ) {
      r = c( r, list( ids[ ( by.mat + 1 ):length( ids ) ] ) )
    }
    escaped = lapply( r, function( b ) { sapply( b, function( str ) { dbEscapeStrings( .xmap.internals$con, str ) } ) } )
    return( lapply( escaped, function( row ) { paste( row, sep=',', collapse=',' ) } ) )
  }
}

.duplicate.hash = function( oldEnv ) {
  ret = new.env( hash=TRUE )
  names = ls( envir=oldEnv )
  sapply( names, function( x ) { assign( x, get( x, envir=oldEnv ), envir=ret ) } )
  ret
}

.secret.encoder = function() {
  .out = c( letters, LETTERS, 0:9, '-', '_' )
  .name = strsplit( Sys.getenv( "LOGNAME" ), split='' )[[1]]
  paste( lapply( seq_along( .name ), function( idx ) {
    .cidx = which( .out == .name[ idx ] )
    .out[ ( ( ( .cidx * 2 ) + idx ) %% length( .out ) ) + 1 ]
  } ), sep='', collapse='' )
}

.coerce = function( data, column, as.vector=TRUE ) {
  if( is.null( data ) ) {
    NULL
  }
  else if( as.vector == TRUE ) {
    ret = data[,column]
    if( 'IN1' %in% colnames( data ) ) {
      data = with(unique(data.frame(k=data$IN1,v=ret,stringsAsFactors=FALSE)),setNames(v,k))
    }
    else {
      data = unique( ret )
    }
  }
  else if( as.vector == FALSE ) {
    data = subset( data, select=!( colnames( data ) %in% .xmap.internals$field.mask ) )
    if( is.null( column ) && !is.null( data ) ) {
      data$IN1 = NULL
    }
    if( any( colnames( data ) == "strand" ) ) {
      colnames( data )[ colnames( data ) == "chromosome_name" ] = "space"
      data = as( data, "RangedData" )
    }
    else if( length( colnames( data ) ) == 2 && all( colnames( data ) == c( 'name', 'length' ) ) ) { # Chromosome
      colnames( data )[ colnames( data ) == "name" ] = "space"
      colnames( data )[ colnames( data ) == "length" ] = "end"
      data = cbind( data, start=1 )
      if( as.vector == FALSE ) {
        # Add in strand so we don't get warnings when converting to GRanges later
        data = cbind( data, strand='*' )
      }
      data = as( data, "RangedData" )
    }
    if( class( data ) == 'RangedData' && .usegranges() ) {
      data = as( data, 'GRanges' )
    }
  }
  data
}

.get.correct.column = function( type, data ) {
  if( class( data )[1] == 'GRanges' ) {
    .xmap.internals$debugFn( c( "Trying to select column", .xmap.types[[ type ]], "from id GRanges" ) )
    if( type == 'chromosome' ) {
      newIds = as.character( seqnames( data ) )
    }
    else {
      newIds = elementMetadata( data )[[ .xmap.types[[ type ]] ]]
    }
    if( !is.null( newIds ) ) {
      data = newIds
    }
  }
  else if( class( data ) == 'RangedData' || is.data.frame( data ) ) {
    .xmap.internals$debugFn( c( "Trying to select column", .xmap.types[[ type ]], "from id data.frame" ) )
    if( type == 'chromosome' && class( data ) == 'RangedData' ) {
      newIds = as.character( data[[ 'space' ]] )
    }
    else {
      newIds = data[[ .xmap.types[[ type ]] ]]
    }
    if( !is.null( newIds ) ) {
      data = newIds
    }
  }
  else if( is.list( data ) ) {
    .xmap.internals$debugFn( c( "Unlisting ids list of dim", dim( data ), "and length", length( data ) ) )
    newIds = unlist( data, use.names=FALSE )
    if( !is.null( newIds ) ) {
      data = newIds
    }
  }
  data
}

.process = function( action, src, params=NULL, dest=NULL ) {
  if( is.null( .xmap.internals$connected ) || !.xmap.internals$connected ) {
    stop( "You need to connect to a database. -- see annmapConnect()")
  }
  # Check we have an array set if we need one...
  if( .needs.array( action, src, dest ) && is.null( .xmap.internals$array ) ) {
    stop( "You need to set an array type. -- see arrayType()")
  }
  else if( .needs.array( action, src, dest ) ) {
    if( is.null( params ) ) {
      params = new.env( hash=TRUE )
    }
    params$array = .xmap.internals$array
  }

  # Ok, do the ids in .xmap.internals$batch.size chunks
  fname = paste( ".xmc", action, sep="." )
  .xmap.internals$debugFn( c( "Calling", fname, "[", src, ":", dest, "]" ) )

  f = .xmap.internals$procs[[ action ]]
    
  if( !is.null( params ) && !is.null( params$ids ) ) {
    params$ids = .get.correct.column( src, params$ids )
    p = .duplicate.hash( params )
    r = lapply( .xmap.internals$procs$params( params$ids ), 
      function( x ) {
        p$ids = x
        f( src, p, dest )
      }
    )
    if( !is.null( r[[ 1 ]] ) ) {
      r = do.call("rbind",r)
      rownames(r) = 1:(dim(r)[1])
      r
    }
    else {
      NULL
    }
  }
  else {
    f( src, params, dest )
    }
}

geneToSymbol = function( ids ) {
  if( is.vector( ids ) ) {
    ids = geneDetails( ids, as.data.frame=TRUE )
  }
  ret = .attr( ids, 'symbol' )
  names( ret ) = .attr( ids, .xmap.types$gene )
  ret
}

allSymbols = function( as.vector=FALSE ) {
  r = sort( unique( allGenes( as.vector=F )$symbol ) )
  if( as.vector == FALSE ) {
    r = data.frame( symbol=r )
  }
  r
}

strandAsInteger = function( granges ) {
  .ret = as.character( strand( granges ) )
  .ret[ .ret == '-' ] = -1
  .ret[ .ret == '+' ] =  1
  .ret[ .ret == '*' ] = NA
  as.integer( .ret )
}

annmapRangeApply = function( x, f, filter=c( chr="space", start="start", end="end", strand="strand" ),
    coerce=c( as.character, as.numeric, as.numeric, as.numeric ), ... ) {
  if( class( x ) != 'RangedData' && class( x ) != 'GRanges' ) {
    stop( paste( 'x must be a GRanges or RangedData object, not a', class( x ) ) )
  }
  if( length( coerce ) != length( filter ) ) {
    stop( paste( "Each filter column should have a corresponding coercion function: coerce:length(", length(coerce), ") filter:length(", length( filter ), ")." ) )
  }
  if( class( x ) == 'GRanges' ) {
    .str = strandAsInteger( x )
    x = as( x, 'RangedData' )
    x$strand = .str
  }
  framed.data             = as( x, "DataFrame" )
  .missing = filter[ !( filter %in% colnames( framed.data ) ) ]
  if( length( .missing ) > 0 ) {
    stop( paste( 'Missing filter fields in x.  Cannot find', paste( names( .missing ), .missing, sep='=', collapse=', ' ) ) )
  }
  framed.data             = framed.data[,filter,drop=FALSE]
  colnames( framed.data ) = names( filter )
  r = lapply( seq_len( dim( framed.data )[1] ), function( i ) {
    current.row = as.vector( framed.data[i,,drop=TRUE] )
                #Attempt to coerce the current row to the types defined for each parameter to 'f'
    current.row = lapply( seq_along( current.row ), function( a ) { do.call( coerce[[a]], list( current.row[[a]] ) ) } )
    params      = as.list( c( current.row, ... ) )
    do.call( f, params )
  } )
  # Strip nulls
  r = r[ !sapply( r, is.null ) ]
  if( length( r ) == 0 ) {
    r = NULL
  }
  else {
    clzz = unique( lapply( r, class ) )
    if( length( clzz ) == 2 && is.list( r ) ) {
      r = do.call( c, r )
      clzz = unique( lapply( r, class ) )
    }
    if( length( clzz ) == 1 ) {
      if( is.vector( r[[1]] ) ) {
        r = do.call( c, r )
      }
      else if( clzz == 'GRanges' ) {
        r = suppressWarnings( do.call( c, r ) ) # Need to supress, as we're probably looking at multipl chrs per result
      }
      else {
        r = do.call( rbind, r )
      }
    }
  }
  r
}

geneToExonProbesetExpr = function( x, ids, probes.min=4 ) {
  if( length( ids ) == 0 ) {
    return( NULL )
  }
  if( class( x ) == 'ExpressionSet' ) {
    x = exprs( x )
  }
  pse  = geneToExonProbeset( ids, probes.min=probes.min )
  ps.r = pse[ , 'probeset' ]
  ps   = intersect( ps.r, rownames( x ) )
  r    = pse[ ps.r %in% ps, , drop=FALSE ]
  x    = as.data.frame( x[ rownames( x ) %in% ps, , drop=FALSE ] )
  x    = cbind( probeset=rownames( x ), x )
  r    = merge( x, r, by='probeset' )
  idx  = c( ( 2:length( colnames( x ) ) ), 1, ( dim( x )[ 2 ] + 1 ):length( r ) )
  r    = r[ , idx, drop=FALSE ]
  r
}

geneToGeneRegionTrack = function( genes, genome, coalesce.name=NULL, ... ) {
  genes = geneDetails( genes )
  if( length( genes ) == 0 ) {
    return( list() )
  }
  if( length( unique( as.character( seqnames( genes ) ) ) ) > 1 ) {
    stop( 'Cannot generate region tracks that are on differing chromosomes' )
  }
  generate = function( name ) {
    genes                            = if( is.list( genes ) ) genes[[ name ]] else genes
    transcripts                      = geneToTranscript( genes )
    exons                            = transcriptToExon( transcripts )

    mcols( genes )                   = mcols( genes )[ , c( 'stable_id', 'biotype', 'symbol' ) ]
    colnames( mcols( genes ) )       = c( 'gene', 'feature', 'symbol' )

    mcols( transcripts )             = mcols( transcripts )[ , c( 'IN1', 'stable_id' ) ]
    colnames( mcols( transcripts ) ) = c( 'gene', 'transcript' )

    mcols( exons )                   = mcols( exons )[ , c( 'IN1', 'stable_id' ) ]
    colnames( mcols( exons ) )       = c( 'transcript', 'exon' )

    mcols( exons ) = merge( mcols( exons ), mcols( transcripts ), by.x='transcript', by.y='transcript', sort=F )
    mcols( exons ) = merge( mcols( exons ), mcols( genes ),       by.x='gene',       by.y='gene',       sort=F )

    GeneRegionTrack( exons, genome=genome, chromosome=as.character( seqnames( genes ) ), name=name, ... )
  }
  if( !is.null( coalesce.name ) ) {
    generate( coalesce.name )
  } 
  else {
    sapply( names( split( genes, genes$stable_id ) ), generate )
  } 
}

arrayType = function( name=NULL, pick.default=FALSE, silent=FALSE ) {
  # Get a list of arrays from the database
  arrs = allArrays( as.vector=FALSE )
  if( !is.null( name ) ) {
    # Check were not looking for a garbage name
    if( dim( arrs[ arrs[,1] == name, ] )[ 1 ] == 0 ) {
      stop( paste( "Array '", name, "' not found.  Call with no parameters to choose from a list", sep="" ) )
    }
    if( !silent ) {
      cat( paste( "Using array '", name, "'.\n", sep="" ) )
    }
  }
  if( is.null( name ) ) {
    if( pick.default ) {
      name = arrs[1,1]
      if( !silent ) {
        cat( paste( "Selected array '", name, "' as a default.\n", sep="" ) )
      }
    }
    else {
      choices = paste( as.character( arrs[,1] ), " ('", as.character( arrs[,2] ), "')", sep="" )
      r = menu( choices, title="Select an array type to use:" )
      if( r == 0 ) {
        if( !silent ) {
          cat( paste( "Using array '", name, "'.\n", sep="" ) )
        }
        return( invisible() )
      }
      else {
        name = as.character( arrs[r,1] )
        if( !silent ) {
          cat( paste( "Using array '", name, "'.\n", sep="" ) )
        }
      }
    }
  }
  .xmap.internals$array = name
  invisible()
}

.attr = function( o, a ) {
  if( class( o ) == 'GRanges' ) {
    o = elementMetadata( o )
  }
  o[[ a ]]
}

.usegranges = function() {
  ( is.null( annmapGetParam( 'oldstylekey' ) ) || annmapGetParam( 'oldstylekey' ) != .secret.encoder() )
}

transcriptToTranslatedprobes = function( ids ) {
  transcript.ids = .get.correct.column( 'transcript', ids )
  if( is.null( transcript.ids ) ) {
    return( NULL )
  }
  # Get all the exons for this transcript
  exons = transcriptToExon( transcript.ids )
  if( is.null( exons ) ) {
    tr.split = list()
  }
  else {
    tr.split = split( .attr( exons, 'stable_id' ), .attr( exons, 'IN1' ) )
  }
  fn = function( id ) {
    exons = tr.split[[ id ]]
    exons = exonDetails( exons )
    if( !is.null( exons ) ) {
      fwd.strand = any( ( if( .usegranges() ) strandAsInteger( exons ) else exons$strand ) > 0 )
      translated.width = sum( width( exons ) )
      probesFn = function( eidx ) {
        # Get the details for this exon
        exon = exons[ eidx, ]
        probes = probeInRange( exon )
        if( !is.null( probes ) && length( probes ) > 0 ) {
          # Remove those that hang off the ends of the exon
          probes = probes[ start( probes ) >= start( exon ), ]
          probes = probes[ end( probes ) <= end( exon ), ]
          # Check whilst we could still have both types of default class
          if( length( probes ) > 0 ) {
            if( .usegranges() ) {
              elementMetadata( probes )$IN1 = .attr( exon, 'stable_id' )
            }
            else {
              probes$IN1 = .attr( exon, 'stable_id' )
            }
          }
        }

        # Return the probes for this exon
        if( length( probes ) > 0 ) { probes } else { NULL }
      }
      probes = sapply( seq_along( .attr( exons, 'stable_id' ) ), probesFn )

      # Then, change these offsets so that they are relative to the start of the
      # transcript
      exon.offset = 0
      for( idx in seq_along( .attr( exons, 'stable_id' ) ) ) {
        # For the reverse strand, go through the list backwards
        eidx = if( fwd.strand ) idx else length( .attr( exons, 'stable_id' ) ) - idx + 1
        if( !is.null( probes[[ eidx ]] ) ) {
          ranges( probes[[ eidx ]] ) = shift( ranges( probes[[ eidx ]] ),
                                              -start( exons[ eidx, ] ) + exon.offset )
          # If on the reverse strand, change offsets to 5' from 3'
          if( !fwd.strand ) {
            ranges( probes[[ eidx ]] ) = IRanges( start=translated.width - end( probes[[ eidx ]] ),
                                                  end=translated.width - start( probes[[ eidx ]] ) )
            # Re-sort the probes by start
            probes[[ eidx ]] = probes[[ eidx ]][ order( start( probes[[ eidx ]] ) ), ]
          }
        }
        exon.offset = exon.offset + width( exons[ eidx, ] )
      }
      # Remove all NULLs and combine
      if( .usegranges() ) {
        probes = probes[ !sapply( probes, is.null ) ]
        if( length( probes ) > 0 ) {
          unlist( GRangesList( probes ) )
        }
      }
      else {
        probes = do.call( 'rbind', probes[ !sapply( probes, is.null ) ] )
      }
    }
  }
  ret = sapply( transcript.ids, fn )
  names( ret ) = transcript.ids
  ret
}

.set.conf.dir = function() {
  tryCatch( rm( conf.dir, envir=.xmap.internals ), warning=function(a){invisible()} )
  conf.dir = Sys.getenv( "ANNMAP_HOME" )
  if( conf.dir == "" ) { 
    conf.dir = file.path( Sys.getenv( "HOME" ), ".annmap" )
    }
    cat( paste( "Using", conf.dir, "as our configuration directory.\n" ) )
  if( !file.exists( conf.dir ) ) {
    cat( paste( "Folder", conf.dir, "does not exist.  Attempting to create.\n" ) )
    dir.create( conf.dir, recursive=TRUE )
    if( !file.exists( conf.dir ) ) {
      stop( paste( "Failed to create folder '", conf.dir, "', giving up.", sep="" ) )
    }
  }
  .xmap.internals$conf.dir = conf.dir
}

annmapSetParam = function( ... ) {
  .params = list( ... )
  for( .name in names( .params ) ) {
    .xmap.internals[[ .name ]] = .params[ .name ][[1]]
  }
  if( !is.null( .xmap.internals$debug ) && ( .xmap.internals$debug ) ) {
    .xmap.internals$debugFn = .debug.full
  }
  else {
    .xmap.internals$debugFn = .debug.none
  }
}

annmapGetParam = function( key ) {
  .xmap.internals[[ key ]]
}

.debug.none = function( message ) {
}

.debug.full = function( message ) {
  cat( format( Sys.time(), "%a %b %d %X %Y" ), "::", message, "\n" )
}

.initialise = function( use.cache=TRUE ) {
  .set.conf.dir()
  .xmap.internals$debug = FALSE
  .xmap.internals$debugFn = .debug.none
  .xmap.internals$max.query = 10000
  .xmap.internals$connected = FALSE
  .xmap.internals$field.mask = c( 'array_id', 'chromosome_id', 'hit_id', 'protein_id', 'gene_id', 'transcript_id', 'exon_id', 'probe_id', 'probeset_id', 'synonym_id', 'external_db_id' )
  
  # Put all our main calls in an internal hash
  # We should then be able to call annmapSetParam with a new hash
  # to override these (eg for using a webservice rather than a db)
  .procs = .make.hash()
  .procs$all = .xmc.all
  .procs$details = .xmc.details
  .procs$to = .xmc.to
  .procs$range = .xmc.range
  .procs$params = .make.params
  .procs$connect = .xmc.connect
  .procs$disconnect = .xmc.disconnect
  .xmap.internals$procs = .procs
  .xmap.internals$initialised = TRUE

  # Set the cache root
  #path = file.path( .xmap.internals$conf.dir, "cache" )
  path = tools::R_user_dir("annmap", which="cache")
  if( !file.exists( path ) ) {
    r = dir.create( path, recursive=TRUE )
    if( !r ) {
      warning( paste( "Could not create or locate cache folder '", path, "', running with caching disabled", sep="" ) )
      path = NULL
      use.cache = FALSE
    }
    else {
      use.cache = TRUE
    }
  }
  .xmap.internals$use.cache = use.cache
  .set.cache.root( path )
}

generalisedNameToNCBI = function( name, ... ) {
  if( length( grep( 'chr', name ) ) > 0 ) { name }
  else if( name == 'MT' )                 { 'chrM' }
  else                                    { paste( 'chr', name, sep='' ) }
}

generalisedNameToEnsembl = function( name, ... ) {
  if( length( grep( 'chr', name ) ) == 0 ) { name }
  else if( name == 'chrM' )                { 'MT' }
  else                                     { substring( name, 4 ) }
}

seqnameMapping = function( x, mappingFunction, ... ) {
  seqlevels( x ) = unlist( lapply( seqlevels( x ), function( a ) { mappingFunction( a, ... ) } ) )
  x
}

seqnamesToNCBI = function( x ) {
  seqnameMapping( x, generalisedNameToNCBI )
}

seqnamesToEnsembl = function( x ) {
  seqnameMapping( x, generalisedNameToEnsembl )
}

annmapEnv = function() {
  if( is.null( .xmap.internals$connected ) || !.xmap.internals$connected ) {
    stop( "You need to connect to a database. -- see annmapConnect()")
  }
  .xmc.db.call( "CALL env()", .xmap.internals$con )
}

# Testing for the utility functions of the package

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## Create a test environment
##
.test.env = new.env( hash=TRUE, parent=emptyenv() )

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
    annmapDisconnect()
}

test.needs.array = function() {
  checkTrue( !annmap:::.needs.array( 'all', 'gene' ),           "needs array for 'all' actions should be false" )
  checkTrue( !annmap:::.needs.array( 'all', 'transcript' ),     "needs array for 'all' actions should be false" )
  checkTrue( !annmap:::.needs.array( 'all', 'exon' ),           "needs array for 'all' actions should be false" )

  checkTrue( !annmap:::.needs.array( 'details', 'gene' ),       "needs array for geneDetails should be false" )
  checkTrue( !annmap:::.needs.array( 'details', 'transcript' ), "needs array for transcriptDetails should be false" )
  checkTrue( !annmap:::.needs.array( 'details', 'exon' ),       "needs array for exonDetails should be false" )

  # This should be true, as despite it being an array, the array is not needed as a silent secondary parameter
  # The array in this case is the primary parameter (ids)
  checkTrue( !annmap:::.needs.array( 'details', 'array' ),      "needs array for arrayDetails should be false" )

  checkTrue( annmap:::.needs.array( 'details', 'probeset' ),      "anything with src probeset should need an array" )
  checkTrue( annmap:::.needs.array( 'details', 'probe' ),         "anything with src probe should need an array" )

  checkTrue( annmap:::.needs.array( 'to', 'gene', 'probeset' ),            "mapping to probeset destination should require an array" )
  checkTrue( annmap:::.needs.array( 'to', 'transcript', 'cdnaprobeset' ),  "mapping to cdnaprobeset destination should require an array" )
  checkTrue( annmap:::.needs.array( 'to', 'gene', 'probe' ),               "mapping to probe destination should require an array" )
  checkTrue( annmap:::.needs.array( 'to', 'probe', 'array' ),              "mapping to array destination should require an array" )
  checkTrue( annmap:::.needs.array( 'to', 'gene', 'exon_probeset' ),       "mapping to exon_probeset destination should require an array" )
}

test.make.params = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    # Check the quote escaping is working...
    ids = c( "a", "b", "c'", "hah';" )
    checkEquals( annmap:::.make.params( ids ), "a,b,c\\',hah\\';" )

    # Check the parameter splitting is working
    oldmax = annmapGetParam( "max.query" )
    annmapSetParam( max.query=20 )

    # Check with a list of short ids
    checkEquals( length( annmap:::.make.params( letters ) ), 3 )
    checkEquals( annmap:::.make.params( letters )[[1]], "a,b,c,d,e,f,g,h,i,j" )

    # Then check with ids that are bigger than the limit that we at least get one through per line
    values = c( "This is a long id (28 chars)", "Followed by another (30 chars)" )
    split = annmap:::.make.params( values )
    checkEquals( length( split ), 2, "with max.query set to 20, we should get each id on a new row" )
    checkEquals( split[[2]], values[2], "with max.query set to 20, we should get each id on a new row" )

    annmapSetParam( max.query=oldmax )

    # Get all the genes
    genes = allGenes( as.vector=TRUE )

    # Pick 5000 of them, and check the splitting works
    split = annmap:::.make.params( sample( genes, 5000 ) )
    checkEquals( 8, length( split ), 'Should be 8 elements in the list after the split' )
    checkTrue( is.list( split ), 'Should be a list when back from .make.params with multiple items' )
    checkTrue( all( unlist( lapply( split, function( vv ) is.character( vv ) ) ) ), 'Should be a list of character strings when back from .make.params with multiple items' )

    # Try with 10 genes
    split = annmap:::.make.params( sample( genes, 10 ) )
    checkEquals( 1, length( split ), 'Should be 1 element in the list after the split' )
    checkTrue( is.character( split ), 'Should be a character string when back from .make.params with one item' )
    annmapDisconnect()
  }
}

test.set.get.params = function() {
  # check single assignment
  annmapSetParam( testing=TRUE )
  checkTrue( annmapGetParam( "testing" ), "Testing should be equal to TRUE" )
  
  # And multiple assignment
  annmapSetParam( testing=FALSE, multiple="tim" )
  checkTrue( !annmapGetParam( "testing" ), "Testing should now be equal to FALSE" )
  checkEquals( annmapGetParam( "multiple" ), "tim" )  
  
  # And list parameters
  annmapSetParam( testing=c( 1, 2, 3 ) )
  checkEquals( length( annmapGetParam( "testing" ) ), 3, "Testing should have 3 elements" )

  annmapSetParam( testing=list( a=1, b=2, c=3 ) )
  checkEquals( annmapGetParam( "testing" )$b, 2, "Element 'b' should be 2" )

  # And functional parameters
  annmapSetParam( hi=function( a ) { paste( "Hi", a ) }, bye=function( a ) { paste( "Bye", a ) } )
  checkEquals( annmapGetParam( "hi" )( "Tim" ), "Hi Tim", "Testing should be a function returning a string" )
  checkEquals( annmapGetParam( "bye" )( "Tim" ), "Bye Tim", "Testing should be a function returning a string" )

  # A vector of functional parameters as a value
  fncs = c( function() { "function 1" }, function() { "function 2" } )
  annmapSetParam( fns=fncs )
  checkEquals( annmapGetParam( "fns" )[[1]](), "function 1", "Testing should be a function returning a string" )
  checkEquals( annmapGetParam( "fns" )[[2]](), "function 2", "Testing should be a function returning a string" )

  # And then a list of them
  fncs = list( a=function() { "function 1" }, b=function() { "function 2" } )
  annmapSetParam( fns=fncs )
  checkEquals( annmapGetParam( "fns" )[[1]](), "function 1", "Testing should be a function returning a string" )
  checkEquals( annmapGetParam( "fns" )[[2]](), "function 2", "Testing should be a function returning a string" )

  checkEquals( annmapGetParam( "fns" )$a(), "function 1", "Testing should be a function returning a string" )
  checkEquals( annmapGetParam( "fns" )$b(), "function 2", "Testing should be a function returning a string" )
}

test.array.type = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    # Check that we have selected a default array type (when we know that xmap.array.type is working)
    arr = annmap:::.xmap.internals$array
    checkTrue( !is.null( arr ), "We should have a default array type selected after xmap.connect" )
    
    # Then check that calling it with a stupid name fails
    checkException( arrayType( 'InvalidId' ), "Setting an invalid array type should fail", silent=TRUE )
    
    # And check we still have the same array type set after this failure
    checkEquals( arr, annmap:::.xmap.internals$array, "Same array should be set after failed call to annmapSetArray" )
    
    annmapDisconnect()
  }
}

test.rangeapply = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    # Need to add more tests for the other range queries
    checkTrue( is.vector( annmapRangeApply( symbolToGene( c( 'tp53', 'lama3' ), as.vector=F ), exonInRange, as.vector=T ) ),
      "Should return a vector for exons in range of 2 genes" )
    checkTrue( length(    annmapRangeApply( symbolToGene( c( 'tp53', 'lama3' ), as.vector=F ), exonInRange, as.vector=T ) ) > 0,
      "Should return a some results for exons in range of 2 genes" )
    checkTrue( is(        annmapRangeApply( symbolToGene( c( 'tp53', 'lama3' ), as.vector=F ), exonInRange, as.vector=F ), annmapGetParam( 'defaultclass' ) ),
      paste( "Should return a", annmapGetParam( 'defaultclass' ), "object for exons in range of 2 genes with as.vector=F" ) )
    d = annmapRangeApply( symbolToGene( c( 'tp53', 'lama3' ), as.vector=F ), exonInRange, as.vector=F )
    len = length( if( annmap:::.usegranges() ) d else d[[1]] )
    checkTrue( len > 2, paste( "Should return some", annmapGetParam( 'defaultclass' ), "rows for exons in range of 2 genes" ) )
  }
}

test.seqnames = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    checkTrue( all( as.character( seqnames( seqnamesToNCBI( symbolToGene( c( 'tp53', 'shh' ) ) ) ) ) == c( 'chr17', 'chr7' ) ), 'expected ncbi seqnames' )
  }
}

test.ANNMAP.97 = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    data = geneToExonProbeset( "ENSG00000166710", as.vector=TRUE )
    checkTrue( length( data ) > 0, 'geneToExonProbeset with as.vector=TRUE should return data' )
  }
}

test.ANNMAP.98 = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    # Shouldn't crash
    transcriptToTranslatedprobes( geneToTranscript( symbolToGene( 'hprt1' ) ) )
  }
}

test.ANNMAP.109 = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    a = geneToSymbol( c( 'ENSG00000164690', 'ENSG00000171862' ) )
    b = geneDetails( c( 'ENSG00000164690', 'ENSG00000171862' ), as.data.frame=T )$symbol
    checkTrue( length( a ) > 0, 'geneToSymbol should return data' )
    checkTrue( length( b ) > 0, 'geneDetails$symbol should return data' )
    checkTrue( all( a == b ), 'returned symbols should be in the same order' )
  }
}

###############################################################################
## Stupid test to make sure its working...
##
test.reality <- function() {
  checkEqualsNumeric( 1, 1, "1 != 1?  PANIC!" )
}

# Extra functions that are not generated automagically from the schema

.generate.stats.bits = function( probesets=NULL ) {
  if( is.null( probesets ) ) {
    probesets = allProbesets( as.vector=FALSE )
  }
  else {
    probesets = probesetDetails( probesets )
  }
  if( is.null( probesets ) ) {
    bits = NULL
  }
  else {
    bits = data.frame( probesets[,'probe_count'],
                   ( ( probesets[,'hit_score'] == 1 ) & ( probesets[,'gene_score'] >  0 ) & ( probesets[,'exon_score'] >  0 ) ) + # exonic
                   2 * ( ( probesets[,'hit_score'] == 1 ) & ( probesets[,'gene_score'] >  0 ) & ( probesets[,'exon_score'] == 0 ) ) + # intronic
                 4 * ( ( probesets[,'hit_score'] == 1 ) & ( probesets[,'gene_score'] == 0 ) & ( probesets[,'exon_score'] == 0 ) ) + # intergenic
                 8 * ( ( probesets[,'hit_score'] > 1 ) | ( probesets[,'hit_score'] == 0 ) ),                                        # unreliable
           row.names=probesets[,'stable_id'] )
    colnames( bits ) = c( 'probe_count', 'scores' )
  }
  bits
}

.get.stats.cache = function( probeset.names=NULL ) {
  bits = NULL
  if( is.null( .xmap.internals$connected ) || !.xmap.internals$connected ) {
    stop( "You need to connect to a database. -- see annmapConnect()")
  }
  if( .xmap.internals$use.cache ) {
    .xmap.internals$debugFn( "Loading specificity cache" )
    key = paste( .xmap.internals$array, .xmap.internals$version, .xmap.internals$species, ".probeset.cache", sep=':' )
    bits = .cache.retrieve( key )
    .xmap.internals$debugFn( "Done..." )
    if( is.null( bits ) ) {
      cat( "Building probeset specificity cache..." )
      flush.console()
      bits = .generate.stats.bits()
      .cache.store( key, bits )
      cat( "...done\n" )
    }
    .xmap.internals$debugFn( c( "Filtering specificity cache down to", length( probeset.names ), "required probesets" ) )
    bits = bits[ rownames( bits ) %in% probeset.names,, drop=F ]
    .xmap.internals$debugFn( "...done" )
  }
  else {
    bits = .generate.stats.bits( probeset.names )
  }
  bits
}

.score.filter = function( probesets, column.name, score.function ) {
    # Get a vector of probeset names
  probesets = .get.correct.column( 'probeset', probesets )

  # Get the stats for these probesets (if cache is off) or all probesets
  stats = .get.stats.cache( unique( probesets ) )

    if( is.null( stats ) ) {
    ret = rep( NA, length( probesets ) )
  }
  else {
    # Generate a truth table based on the score
    .xmap.internals$debugFn( c( "Generating truth table for stats dim=", dim(stats) ) )
    ret = score.function( stats[ probesets, column.name ] )
    .xmap.internals$debugFn( "...done" )
  }

  # And set the names of the truth table values
  names( ret ) = probesets
  ret
}

isExonic = function( probesets ) {
  .score.filter( probesets, 'scores', function( a ) a == 1 )
}

isIntronic = function( probesets ) {
  .score.filter( probesets, 'scores', function( a ) a == 2 )
}

isIntergenic = function( probesets ) {
  .score.filter( probesets, 'scores', function( a ) a == 4 )
}

isUnreliable = function( probesets ) {
  .score.filter( probesets, 'scores', function( a ) a == 8 )
}

.filter.whatever = function( probesets, score.function, exclude ) {
  r = score.function( probesets )
  if( is.data.frame( probesets ) ) {
    probesets = probesets[ xor( !is.na( r ) & r, exclude ), ]
  }
  else {
    probesets = probesets[ xor( !is.na( r ) & r, exclude ) ]
  }
  if( length( probesets ) == 0 ) {
    probesets = NULL
  }
  probesets
}

exonic = function( probesets, exclude=FALSE ) {
  .filter.whatever( probesets, isExonic, exclude )
}

intronic = function( probesets, exclude=FALSE ) {
  .filter.whatever( probesets, isIntronic, exclude )
}

intergenic = function( probesets, exclude=FALSE ) {
  .filter.whatever( probesets, isIntergenic, exclude )
}

unreliable = function( probesets, exclude=FALSE ) {
  .filter.whatever( probesets, isUnreliable, exclude )
}

hasProbes = function( probesets, num.probes=4, exclude=FALSE ) {
  .filter.whatever( probesets, function( a ) .score.filter( a, 'probe_count', function( b ) b == num.probes ), exclude )
}

hasProbesAtleast = function( probesets, num.probes=4, exclude=FALSE ) {
  .filter.whatever( probesets, function( a ) .score.filter( a, 'probe_count', function( b ) b >= num.probes ), exclude )
}

hasProbesIn = function( probesets, num.probes=c( 1, 2, 3, 4 ), exclude=FALSE ) {
  .filter.whatever( probesets, function( a ) .score.filter( a, 'probe_count', function( b ) b %in% num.probes ), exclude )
}

hasProbesBetween = function( probesets, min.probes=1, max.probes=4, exclude=FALSE, inclusive=TRUE ) {
  fn = if( inclusive ) { 
    function( b ) { ( b >= min.probes ) & ( b <= max.probes ) }
  }
  else {
    function( b ) { ( b > min.probes ) & ( b < max.probes ) }
  }
  .filter.whatever( probesets, function( a ) .score.filter( a, 'probe_count', fn ), exclude )
}

# Testing for the utility functions of the package

if(FALSE) {
  library( "RUnit" )
  library( "annmap" )
}

###############################################################################
## SetUp is called before each test method
##
.setUp = function() {
}

###############################################################################
## TearDown is called after each test method
##
.tearDown = function() {
    annmapDisconnect()
}

test.filters = function() {
  data = tryCatch( annmapConnect( "hs-test" ), error=function(e) { FALSE } )
  if( length( data ) == 1 ) {
    print( "Cannot find datasource 'hs-test', so skipping these tests." )
  }
  else {
    lapply( c( FALSE, TRUE ), function( cache ) {
      cat( paste( "Setting use.cache to", cache, "\n" ) )
      annmapSetParam( use.cache=cache )

      print( 'Fetch some data for p53' )
      gene = symbolToGene( "tp53" )

      probesets.vector = geneToProbeset( gene, as.vector=TRUE )
      probesets.frame  = geneToProbeset( gene )

      print( 'Check vector filtering' )
      exonic.vector     = exonic(     probesets.vector )
      intronic.vector   = intronic(   probesets.vector )
      unreliable.vector = unreliable( probesets.vector )
      intergenic.vector = intergenic( probesets.vector )

      print( 'Check RangedData filtering' )
      exonic.frame     = exonic(     probesets.frame )
      intronic.frame   = intronic(   probesets.frame )
      unreliable.frame = unreliable( probesets.frame )
      intergenic.frame = intergenic( probesets.frame )

      checkTrue( is.data.frame( exonic.frame ), "As source is a .data.frame, result should be one too" )
      checkTrue( is.data.frame( intronic.frame ), "As source is a .data.frame, result should be one too" )
      checkTrue( is.data.frame( unreliable.frame ), "As source is a .data.frame, result should be one too" )
      checkTrue( is.data.frame( intergenic.frame ), "As source is a .data.frame, result should be one too" )

      print( 'Check inverse filters' )
      exonic.vector.ex     = exonic(     probesets.vector, exclude=TRUE )
      intronic.vector.ex   = intronic(   probesets.vector, exclude=TRUE )
      unreliable.vector.ex = unreliable( probesets.vector, exclude=TRUE )
      intergenic.vector.ex = intergenic( probesets.vector, exclude=TRUE )

      exonic.frame.ex     = exonic(     probesets.frame, exclude=TRUE )
      intronic.frame.ex   = intronic(   probesets.frame, exclude=TRUE )
      unreliable.frame.ex = unreliable( probesets.frame, exclude=TRUE )
      intergenic.frame.ex = intergenic( probesets.frame, exclude=TRUE )

      print( 'Cross comparison checks' )
      checkTrue( length( c( exonic.vector, intronic.vector, unreliable.vector, intergenic.vector ) ) == length( probesets.vector ), "Split up, there should still be the same number of probesets" )
      checkTrue( all( dim( rbind( exonic.frame,  intronic.frame,  unreliable.frame,  intergenic.frame ) ) == dim( probesets.frame ) ), "Split up, there should still be the same number of probesets" )

      checkTrue( length( c( exonic.vector,     exonic.vector.ex ) )     == length( probesets.vector ), "exonic plus non-exonic should add up to all" )
      checkTrue( length( c( intronic.vector,   intronic.vector.ex ) )   == length( probesets.vector ), "intronic plus non-intronic should add up to all" )
      checkTrue( length( c( intergenic.vector, intergenic.vector.ex ) ) == length( probesets.vector ), "intergenic plus non-intergenic should add up to all" )
      checkTrue( length( c( unreliable.vector, unreliable.vector.ex ) ) == length( probesets.vector ), "unreliable plus non-unreliable should add up to all" )

      checkTrue( dim( rbind( exonic.frame,     exonic.frame.ex     ) )[1] == dim( probesets.frame )[1], "exonic plus non-exonic should add up to all" )
      checkTrue( dim( rbind( intronic.frame,   intronic.frame.ex   ) )[1] == dim( probesets.frame )[1], "intronic plus non-intronic should add up to all" )
      checkTrue( dim( rbind( intergenic.frame, intergenic.frame.ex ) )[1] == dim( probesets.frame )[1], "intergenic plus non-intergenic should add up to all" )
      checkTrue( dim( rbind( unreliable.frame, unreliable.frame.ex ) )[1] == dim( probesets.frame )[1], "unreliable plus non-unreliable should add up to all" )

      checkEquals( exonic.vector,     setNames( exonic.frame$stable_id,     exonic.frame$IN1 ) )
      checkEquals( intronic.vector,   setNames( intronic.frame$stable_id,   intronic.frame$IN1 ) )
      checkEquals( intergenic.vector, setNames( intergenic.frame$stable_id, intergenic.frame$IN1 ) )
      checkEquals( unreliable.vector, setNames( unreliable.frame$stable_id, unreliable.frame$IN1 ) )

      print( 'Check the has.probes.x filters' )
      probesets.vector.four = hasProbes( probesets.vector, num.probes=4, exclude=FALSE )
      probesets.frame.four = hasProbes( probesets.frame, num.probes=4, exclude=FALSE )
      checkTrue( is.data.frame( probesets.frame.four ), "As source is a data.frame, result should be one too" )
      checkTrue( length( probesets.vector.four ) <= length( probesets.vector ), "At most, there should be the same number of probesets as in the original call" )
      checkTrue( length( probesets.vector.four ) == dim( probesets.frame.four )[1], "Frame and dataset should have the same number of results" )

      probesets.vector.in = hasProbesIn( probesets.vector, num.probes=c( 0, 4 ), exclude=FALSE )
      probesets.frame.in = hasProbesIn( probesets.frame, num.probes=c( 0, 4 ), exclude=FALSE )
      checkTrue( is.data.frame( probesets.frame.in ), "As source is a data.frame, result should be one too" )
      checkTrue( length( probesets.vector.four ) == length( probesets.vector.in ), "Should have the same number of probesets as the has.probes call" )
      checkTrue( length( probesets.vector.in ) == dim( probesets.frame.in )[1], "Frame and dataset for .in should have the same number of results" )

      probesets.vector.least = hasProbesAtleast( probesets.vector, num.probes=4, exclude=FALSE )
      probesets.frame.least = hasProbesAtleast( probesets.frame, num.probes=4, exclude=FALSE )
      checkTrue( is.data.frame( probesets.frame.least ), "As source is a data.frame, result should be one too" )
      checkTrue( length( probesets.vector.least ) <= length( probesets.vector ), "At most, there should be the same number of probesets as in the original call for .atleast" )
      checkTrue( length( probesets.vector.least ) == dim( probesets.frame.least )[1], "Frame and dataset should have the same number of results for .atleast" )

      probesets.vector.between = hasProbesBetween( probesets.vector, min.probes=1, max.probes=4, exclude=FALSE )
      probesets.frame.between = hasProbesBetween( probesets.frame, min.probes=1, max.probes=4, exclude=FALSE )
      checkTrue( is.data.frame( probesets.frame.between ), "As source is a data.frame, result should be one too" )
      checkTrue( length( probesets.vector.between ) <= length( probesets.vector ), "At most, there should be the same number of probesets as in the original call for .atleast" )
      checkTrue( length( probesets.vector.between ) == dim( probesets.frame.between )[1], "Frame and dataset should have the same number of results for .atleast" )

      # Add a erroneous probeset name in and a duplicate, and check we still get the same number of rows back (the erroneous one should be NA)
      probesets.broken = probesets.vector
      probesets.broken[ 2 ] = "broken"
      probesets.broken[ 3 ] = probesets.broken[ 1 ]

      is.exonic.vector = isExonic( probesets.vector )
      is.exonic.broken = isExonic( probesets.broken )

      checkTrue( length( is.exonic.vector ) == length( is.exonic.broken ), "Should still et the same number of results" )
      checkTrue( !is.na( is.exonic.vector[ 2 ] ), "Second element should be TRUE or FALSE" )
      checkTrue(  is.na( is.exonic.broken[ 2 ] ), "Second element should be NA" )
      checkTrue(  names( is.exonic.broken )[ 1 ] == names( is.exonic.broken )[ 3 ], "First and third element should have the same name" )
      checkTrue(  is.exonic.broken[ 1 ] == is.exonic.broken[ 3 ], "First and third element should have the same value" )

      print( 'Edge case validation' )
      # Check that exonic for multiple identical exonic probesets returns us something reasonable
      exonic.rep = rep( exonic.vector[1], 5 )
      checkTrue( length( exonic( exonic.rep ) ) == 5, "Five go in, five should come out (irrespective of duplicates)" )

      # Check that we can filter out garbage probesets
      exonic.rep[ 3 ] = "garbage"
      checkTrue( length( exonic( exonic.rep ) ) == 4, "4 duplicates and one garbage probeset should return 4 exonic probesets" )

      probesets.broken = probesets.frame
      probesets.broken$stable_id[ 2 ] = "broken"
      probesets.broken[ 3, ] = probesets.broken[ 1, ]

      is.exonic.frame = isExonic( probesets.frame )
      is.exonic.broken = isExonic( probesets.broken )

      checkTrue( length( is.exonic.frame ) == length( is.exonic.broken ), "Should still et the same number of results" )
      checkTrue( !is.na( is.exonic.frame[ 2 ] ), "Second element should be TRUE or FALSE" )
      checkTrue(  is.na( is.exonic.broken[ 2 ] ), "Second element should be NA" )
      checkTrue(  names( is.exonic.broken )[ 1 ] == names( is.exonic.broken )[ 3 ], "First and third element should have the same name" )
      checkTrue(  is.exonic.broken[ 1 ] == is.exonic.broken[ 3 ], "First and third element should have the same value" )

      exonic.rep = rbind(exonic.frame[1,],exonic.frame[1,],exonic.frame[1,],exonic.frame[1,],exonic.frame[1,])
      checkTrue( length( exonic( exonic.rep )[,1] ) == 5, "Five go in (in a data.frame), five should come out (irrespective of duplicates)" )

      # Check that we can filter out garbage probesets
      exonic.rep$stable_id[ 3 ] = "garbage"
      checkTrue( length( exonic( exonic.rep )[,1] ) == 4, "4 duplicates and one garbage probeset (in a data.frame) should return 4 exonic probesets" )
    } )
    annmapDisconnect()
  }
}

.fetch.genes.for.range = function( pos, drop.partial.genes=FALSE, ... ) {
  .genes = geneInRange( pos, as.vector='data.frame' )
  if( !is.null( .genes ) ) {
    .genes = .genes[with(.genes, order( start )),]
    if( drop.partial.genes ) {
      .genes = .drop.partial.genes( .genes, start( pos ), end( pos ) )
    }
  }
  .genes
}

.drop.partial.genes = function( genes, start, end ) {
  for( i in seq_along( genes[ genes$start < start, ]$stable_id ) ) {
    warning( paste( 'Dropping partial gene', genes[ genes$start < start, ][ i, ]$name, '(falls off start)' ) )
  }
  genes = genes[ genes$start >= start, ]
  for( i in seq_along( genes[ genes$end > end, ]$stable_id ) ) {
    warning( paste( 'Dropping partial gene', genes[ genes$end > end, ][ i, ]$name, '(falls off end)' ) )
  }
  genes[ genes$end <= end, ]
}

.layout.genes = function( .genes, start, end, gene.area.height=NULL, gene.layout.padding=100, ... ) {
  # Add a y column for the layout
  .genes = cbind( .genes, y=rep( 1, dim(.genes)[1] ) )

  # layout the strands separately, then join them back togther
  .strands = c( 1, -1 )
  for( .s in seq_along( .strands ) ) {
    .max.x.in.layer = c( 1 )
    for( i in seq_along( .genes[ .genes$strand==.strands[.s], ]$stable_id ) ) {
      .row = .genes[ .genes$strand==.strands[.s], ][ i, ]
      while( T ) {
        if( .row$start < .max.x.in.layer[ .row$y ] ) {
          if( .row$y + 1 > length( .max.x.in.layer ) ) .max.x.in.layer = c( .max.x.in.layer, 1 )
          .row$y = .row$y + 1
        }
        else {
          break
        }
      }
      .max.x.in.layer[ .row$y ] = max( .row$end, .row$start + ( ( end - start ) * convertWidth( unit( strwidth( .row$name, units='inches' ), 'inches' ), 'npc', valueOnly=T ) ) ) + gene.layout.padding
      .genes[ .genes$strand==.strands[.s], ][ i, ] = .row
    }
  }
  .reverse.height = if( length( .genes[ .genes$strand==-1, ]$y ) > 0 ) max( .genes[ .genes$strand==-1, ]$y ) else 0
  .forward.height = if( length( .genes[ .genes$strand== 1, ]$y ) > 0 ) max( .genes[ .genes$strand== 1, ]$y ) else 0

  # reverse genes need flipping upside down
  for( i in seq_along( .genes[ .genes$strand==-1, ]$stable_id ) ) {
    .genes[ .genes$strand==-1, ][ i, ]$y = .reverse.height - .genes[ .genes$strand==-1, ][ i, ]$y + 1
  }

  if( is.null( gene.area.height ) ) {
    .reverse.height = max( .reverse.height, .forward.height )
    .forward.height = .reverse.height
  }
  else if( is.numeric( gene.area.height ) ) {
    .reverse.height = gene.area.height
    .forward.height = gene.area.height
    for( i in seq_along( .genes$stable_id ) ) {
      if( .genes[ i, ]$y > gene.area.height ) {
        .genes[ i, ]$y = 0
        warning( paste( 'Gene', .genes[ i, ]$name, 'dropped, as it falls outside of gene.area.height' ) )
      }
    }
    .genes = .genes[ .genes$y > 0, ]
  }
  list( genes=.genes, fwd.height=.forward.height, rev.height=.reverse.height )
}

.draw.background.arrow = function( x, y, alpha ) {
  grid.polygon( x=x, y=y, id=rep( 1, length( x ) ), default.units='npc', gp=gpar( fill='black', alpha=alpha ) )
}

.draw.genes = function( .genes, .exons, start, end, alpha ) {
  for( i in seq_along( .genes$stable_id ) ) {
    .row = .genes[ i, ]
    .col = as.character( .row$col )
    .bor = as.character( .row$bor )
    .ex = .exons[[ as.character( .row$stable_id ) ]]
    if( !is.null( .ex ) ) {
      grid.text( .row$name, .row$start, 0,
                 just=c('left', 'bottom'), default.units='native',
                 gp=gpar( adj=c(0,1), col=.bor, fontsize=convertHeight( unit( 0.4, 'npc' ), 'points' ) , alpha=alpha ) )
      .ex = .ex[ end( .ex ) >= start, ]
      .ex = .ex[ start( .ex ) <= end, ]
      len = if( .usegranges() ) length( .ex ) else length( .ex[[ 1 ]] )
      if( len > 0 ) {
        grid.segments( max( start, as.numeric( unlist( start( .ex ) ) ) ), 0.6,
                       min(   end, as.numeric( unlist(   end( .ex ) ) ) ), 0.6,
                       default.units='native', gp=gpar( lty=3, alpha=alpha ) )
        grid.rect( unlist( lapply( as.integer( unlist( start( .ex ) ) ), function( v ) { max( v, start ) } ) ), 0.4,
                   unlist( lapply( as.integer( unlist(   end( .ex ) ) ), function( v ) {   min( v, end ) } ) ) - as.integer( unlist( start( .ex ) ) ), 0.4,
                   just=c('left','bottom'), default.units='native', gp=gpar( fill=.col, alpha=alpha ) )
      }
    }
  }
}

.draw.strand = function( .genes, .exons, start, end, strand, gene.area.height, alpha, ... ) {
  .draw.background.arrow( if( strand > 0 ) c( 0, 0.9, 1,   0.9, 0 ) else c( 0,   0.1, 1, 1, 0.1 ),
                          if( strand > 0 ) c( 0, 0,   0.5, 1,   1 ) else c( 0.5, 0,   0, 1, 1 ), alpha * 0.15 )
  # Then, push a new layout into this cell, and draw the genes for each
  if( !is.null( .genes ) ) {
    lheights = unit( rep( 1, gene.area.height + 2 ), rep( 'null', gene.area.height + 2 ), rep( list( NULL ), gene.area.height + 2 ) )
    lwidths  = unit( c( 1 ), c( 'null' ), NULL )
    my.layout = grid.layout( nrow=gene.area.height + 2, ncol=1, heights=lheights, widths=lwidths )
    pushViewport( viewport( layout=my.layout ) )
      lapply( seq( 2, gene.area.height + 1 ), function( y ) {
        pushViewport( viewport( layout.pos.col=1, layout.pos.row=y, xscale=c( start, end ), yscale=c( 0, 1 ) ) )
          .draw.genes( .genes[ .genes$y==y - 1, ], .exons, start, end, alpha )
        popViewport()
      } )
    popViewport()  
  }
}

# Does this data.frame have anything in it?
.has.data = function( df ) {
  ( !is.null( df ) ) && ( dim( df )[ 1 ] > 0 )
}

genomicExonDepthPlot = function( .exons, start, end, exon.depth.alpha=0.1, exon.depth.col='black', ... ) {
  .to.dataframe = function( f ) {
    data.frame( start=as.integer(unlist(start(f))), end=as.integer(unlist(end(f))) )
  }
  .exons = do.call( 'rbind', lapply( .exons, .to.dataframe ) )

  pushViewport( viewport( layout=grid.layout( 1, 1 ), xscale=c( start, end ), yscale=c( 0, 1 ) ) )
    if( !is.null( .exons ) ) {
      # Drop all exons outside of region
      .exons = .exons[ .exons$end >= start, ]
      .exons = .exons[ .exons$start <= end, ]
      starts = unlist( lapply( .exons$start, function( v ) { max( v, start ) } ) )
      ends   = unlist( lapply( .exons$end, function( v ) {   min( v, end ) } ) ) - .exons$start
      if( length( starts ) > 0 ) {
        grid.rect( starts, 0,
                   ends, 1,
                   just=c('left','bottom'),
                   default.units='native',
                   gp=gpar( col=NA, fill=exon.depth.col, alpha=exon.depth.alpha ) )
      }
    }
  popViewport()
}

genomicProbePlot = function( probes, start, end, probe.col='green', probe.alpha=0.3, ... ) {
  pushViewport( viewport( layout=grid.layout( 1, 1 ), xscale=c( start, end ), yscale=c( 0, 1 ) ) )
    if( !is.null( probes ) ) {
      probes = probes[ probes$end >= start, ]
      probes = probes[ probes$start <= end, ]
      starts = unlist( lapply( probes$start, function( v ) { max( v, start ) } ) )
      ends   = unlist( lapply( probes$end, function( v ) { min( v, end ) } ) ) - probes$start
      if( length( starts ) > 0 ) {
        grid.rect( starts, 0,
                   ends, 1,
                   just=c('left', 'bottom'),
                   default.units='native',
                   gp=gpar( fill=probe.col, col=NA, alpha=probe.alpha ) )
      }
    }
  popViewport()
}

genomicPlot = function( xrange,               # An IRanges object representing the region of interest (with a strand if reqd)
              gene.area.height=NULL,           # NULL=Both strands to max height of either of them, integer=Both strands limited to this height, NA=Both strands limited to their implied height 
              gene.layout.padding=100,         # How much space needs to be between each gene in a layer
              highlights=NULL,                 # Some highlighted regions (as a data.frame with start, end, strand and name columns)
              draw.opposite.strand=FALSE,      # Do we draw a washed out representation of the other strand. Only applies if !is.null(xrange$strand)
              exon.depth.plot=genomicExonDepthPlot, # Draw the exondepth per strand? Function if so, NULL if not
              padding.lines=1,                 # how much padding above and below the plot (in grid lines)
              .genes=NULL,                     # Pass in pre-loaded .genes and .exons if you want (then we skip loading them in here)
              .exons=NULL,
              invert.strands=FALSE,            # Forward strand on the bottom?
              draw.scale=TRUE,                 # Do we draw a scale?
              ... ) {                          # Other params passed to genomic.exon.depth.plot, .draw.strand and .draw.genes
  if( is.null( xrange ) ) {
    stop( 'Parameter \'xrange\' cannot be NULL' )
  }
  if( is.null( .genes ) ) {
    .genes = .fetch.genes.for.range( xrange, ... )
  }
  .strand = if( class( xrange ) == 'GRanges' ) strandAsInteger( xrange ) else { if( xrange$strand == 0 ) NULL else xrange$strand }
  if( !is.null( .genes ) &&
      ( ( class( xrange ) == 'GRanges' && !is.na( .strand ) ) ||
        ( class( xrange ) != 'GRanges' && !is.null( .strand ) ) ) && 
      !draw.opposite.strand ) {
    # remove the opposite strand
    .genes = .genes[ .genes$strand == .strand, ]
  }
  if( is.null( .exons ) ) {
    .all.exons = geneToExon( if( is.null( .genes ) ) NULL else .genes$stable_id )
    .exons = if( is.null( .all.exons ) ) {
      list()
    }
    else {
      sid = .attr( .all.exons, 'stable_id' )
      in1 = .attr( .all.exons, 'IN1' )
      lapply( split( sid, factor( in1 ) ), function( .name ) {
        .rows = reduce( ranges( .all.exons[ sid %in% .name, ] ) )
      } )
    }
  }
  if( !is.null( .genes ) ) {
    .genes = do.call( 'rbind', lapply( split( .genes$stable_id, factor( .genes$stable_id ) ), function( .name ) {
      .row = .genes[ .genes$stable_id==.name, ]
      data.frame( stable_id=.name, symbol=.row$symbol, start=.row$start, end=.row$end, strand=.row$strand,
                  name=paste( if( !is.null( .row$symbol ) ) .row$symbol else .row$stable_id, if( .row$strand > 0 ) '(+)' else '(-)' ),
                  col=rgb(0,0,0), bor=rgb(0,0,0) )
    } ) )
    .genes = .genes[with(.genes, order( start )),]
  }

  # If we have dummy highlight regions...
  if( .has.data( highlights ) ) {
    .required.fields = c( 'name', 'start', 'end', 'strand' )
    if( length( unique( colnames( highlights )[ colnames( highlights ) %in% .required.fields ] ) ) != length( .required.fields ) ) {
      warning( paste( c( 
        'Missing required column names in highlights data.frame',
        paste( '  REQUIRED:', paste( .required.fields, collapse=', ' ) ),
        paste( '  RECIEVED:', paste( colnames( highlights ), collapse=', ' ) ),
        'Highlights will be ignored' ), collapse='\n' ) )
    }
    else {
      # Filter out just the columns we are interested in...
      .columns = c( 'name', 'start', 'end', 'strand' )
      if( 'col' %in% colnames( highlights ) ) .columns = c( .columns, 'col' )
      if( 'bor' %in% colnames( highlights ) ) .columns = c( .columns, 'bor' )
      highlights = highlights[ , .columns ]

      # Hack in defaults...
      highlights = cbind( highlights, stable_id=paste( 'a', 1:dim( highlights )[ 1 ], sep='' ) )
      highlights = cbind( highlights, symbol=rep( '', dim( highlights )[ 1 ] ) )
      if( is.null( highlights$col ) ) {
        highlights = cbind( highlights, col=rep( rgb( 0.9, 0.7, 0.45 ), dim( highlights )[ 1 ] ) )
      }
      if( is.null( highlights$bor ) ) {
        highlights = cbind( highlights, bor=rep( rgb( 0.5, 0, 0 ), dim( highlights )[ 1 ] ) )
      }

      # Attach and re-sort
      .genes = rbind( .genes, highlights )
      .genes = .genes[with(.genes, order( start )),]

      # Then generate an exon the full width for each gene
      .new.exons = lapply( seq_along( highlights$stable_id ), function( idx ) {
        .row = highlights[ idx, ]
        IRanges( start=.row$start, end=.row$end )
      } )
      names(.new.exons) = highlights$stable_id

      .exons = c( .exons, .new.exons )
    }
  }

  if( !is.null( .genes ) ) {
    .genes = .layout.genes( .genes, start(xrange), end(xrange), gene.area.height=gene.area.height, ... )
  }

  # Build our grid viewport and push it in
  .lh = if( !is.null( .genes ) ) {
    c( top=padding.lines,
       fwd=if( is.null( .strand ) || is.na( .strand ) || ( as.numeric( .strand ) == 1 ) || draw.opposite.strand ) { if( invert.strands ) .genes$rev.height + 2 else .genes$fwd.height + 2 } else 0,
       scagap=if( draw.scale ) 1.5 else 0,
       sca=if( draw.scale ) 1 else 0,
       rev=if( is.null( .strand ) || is.na( .strand ) || ( as.numeric( .strand ) == -1 ) || draw.opposite.strand ) { if( invert.strands ) .genes$fwd.height + 2 else .genes$rev.height + 2 } else 0,
       bot=padding.lines )
  }
  else {
    c( top=padding.lines,
       fwd=if( is.null( .strand ) || is.na( .strand ) || ( as.numeric( .strand ) == 1  ) || draw.opposite.strand ) 1 else 0,
       scagap=if( draw.scale ) 1.5 else 0,
       sca=if( draw.scale ) 1 else 0,
       rev=if( is.null( .strand ) || is.na( .strand ) || ( as.numeric( .strand ) == -1 ) || draw.opposite.strand ) 1 else 0,
       bot=padding.lines )
  }
  .lt = c( top=if( padding.lines > 0 ) 'lines' else 'null',
           fwd='null',
           scagap=if( draw.scale ) 'lines' else 'null',
           sca=if( draw.scale ) 'lines' else 'null',
           rev='null',
           bot=if( padding.lines > 0 ) 'lines' else 'null' )
  .ld = list( top=NULL,
              fwd=NULL,
              scagap=NULL,
              sca=NULL,
              rev=NULL,
              bot=NULL )
  lheights = unit( .lh, .lt, .ld )
  lwidths  = unit( c( w=1 ), c( w='null' ), list( w=NULL ) )
  my.layout = grid.layout( nrow=6, ncol=1, heights=lheights, widths=lwidths )
  pushViewport( viewport( layout=my.layout ) )

    # draw the scale in the central viewport
    if( draw.scale ) {
      pushViewport( viewport( layout.pos.col=1, layout.pos.row=4, xscale=c( start(xrange), end(xrange) ), yscale=c( 0, 1 ) ) )
        grid.xaxis( main=FALSE, gp=gpar( cex=0.6 ) )
      popViewport()
    }

    # draw the forward strand if required
    if( is.null( .strand ) || is.na( .strand ) || ( as.numeric( .strand ) == 1 ) || draw.opposite.strand ) {
      alp = if( !is.null( .strand ) && !is.na( .strand ) && ( as.numeric( .strand ) == -1 ) ) 0.3 else 1.0
      pushViewport( viewport( layout.pos.col=1, layout.pos.row=if( invert.strands ) 5 else 2 ) )
        .plot.genes = .genes$genes[ .genes$genes$strand==1, ]
        if( !is.null( exon.depth.plot ) ) {
          exon.depth.plot( .exons=.exons[ names( .exons ) %in% .plot.genes$stable_id ], start=start(xrange), end=end(xrange), ... )
        }
        .draw.strand( .plot.genes, .exons, start(xrange), end(xrange), 1, .genes$fwd.height, alp )
      popViewport()
    }

    # draw the reverse strand if required
    if( is.null( .strand ) || is.na( .strand ) || ( as.numeric( .strand ) == -1 ) || draw.opposite.strand ) {
      alp = if( !is.null( .strand ) && !is.na( .strand ) && ( as.numeric( .strand ) != -1 ) ) 0.3 else 1.0
      pushViewport( viewport( layout.pos.col=1, layout.pos.row=if( invert.strands ) 2 else 5 ) )
        .plot.genes = .genes$genes[ .genes$genes$strand==-1, ]
        if( !is.null( exon.depth.plot ) ) {
          exon.depth.plot( .exons=.exons[ names( .exons ) %in% .plot.genes$stable_id ], start=start(xrange), end=end(xrange), ... )
        }
        .draw.strand( .plot.genes, .exons, start(xrange), end(xrange), -1, .genes$rev.height, alp )
      popViewport()
    }
  popViewport()
}

# -------------------------------------------------------------------------------
# Transcript coords to genome

.single.transcript.coords.to.genome = function( transcript.id, position, exons, check.bounds, truncate ) {
  strand     = as.integer( unique( exons$strand ) )
  space      = as.character( unique( exons$chromosome_name ) )

  if( dim( exons )[1] == 0 ) {
    return( data.frame( start=NA, end=NA, chromosome_name=NA, strand=NA, IN1=transcript.id, stringsAsFactors=FALSE ) )
  }
  if( position < 1 && check.bounds ) {
    warning( paste( 'Fell off the start of transcript', transcript.id, 'looking for position', position ) )
    return( data.frame( start=NA, end=NA, chromosome_name=space, strand=strand, IN1=transcript.id, stringsAsFactors=FALSE ) )
  }

  exons      = exons[ order( exons$start, decreasing=strand < 0 ), ]
  widths     = exons$end - exons$start + 1 # exons with the same start and end still contain a single base
  offset     = position - 1 # adjust for 1-start index
  exon.index = 1
  found      = FALSE

  for( exon.index in 1:length( widths ) ) {
    if( offset < widths[ exon.index ] ) {
      found  = TRUE
      break
    }
    offset   = offset - widths[ exon.index ]
  }

  if( !found && check.bounds ) {
    warning( paste( 'Fell off the end of transcript', transcript.id, 'looking for position', position ) )
    return( data.frame( start=NA, end=NA, chromosome_name=space, strand=strand, IN1=transcript.id, stringsAsFactors=FALSE ) )
  }
  else if( !found ) {
    offset = offset + widths[ exon.index ]
  }

  # ok, offset is the offset into the exon at exon.index
  if( strand > 0 ) {
    pos = exons$start[ exon.index ] + offset
    if( truncate ) {
      if( pos < exons$start[ 1 ] )     pos = exons$start[ 1 ]
      if( pos > tail( exons$end, 1 ) ) pos = tail( exons$end, 1 )
    }
  }
  else {
    pos = exons$end[ exon.index ] - offset
    if( truncate ) {
      if( pos < tail( exons$start, 1 ) ) pos = tail( exons$start, 1 )
      if( pos > exons$end[ 1 ] )         pos = exons$end[ 1 ]
    }
  }

  data.frame( start=pos, end=pos, chromosome_name=space, strand=strand, IN1=transcript.id, stringsAsFactors=FALSE )
}

transcriptCoordsToGenome = function( transcript.ids, position=1, as.vector=FALSE, check.bounds=TRUE, truncate=TRUE, cds=FALSE ) {
  transcript.ids = .get.correct.column( 'transcript', transcript.ids )

  if( is.null( transcript.ids ) ) {
    return( NULL )
  }

  exons = transcriptToExon( unique( transcript.ids ), as.vector='data.frame' )
  if( is.null( exons ) ) {
    return( NULL )
  }

  if( cds ) {
    exons = do.call( 'rbind', lapply( seq_along( transcript.ids ), function( index ) {
      tr = transcript.ids[ index ]
      ex = exons[ exons$IN1 == tr, ]
      ra = GRanges( seqnames=ex$chromosome_name, IRanges( ex$start, ex$end ), strand=ex$strand, stable_id=ex$stable_id )
      range = transcriptToCodingRange( tr )
      if( length( range ) == 0 ) {
        NULL
      }
      else {
        ret = do.call( 'rbind', lapply( split( ra, ra$stable_id ), function( e ) as.data.frame( intersect( e, range ) ) ) )
        ret$stable_id = rownames( ret )
        rownames( ret ) = NULL
        names( ret )[ names( ret ) == 'seqnames' ] = 'chromosome_name'
        ret$width = NULL
        ret$strand = strandAsInteger( ret$strand )
        ret$IN1 = tr
        ret[ with( ret, order( start ) ), ]
      }
    } ) )
  }

  if( length( position ) == 1 ) {
    position = rep( position, length( transcript.ids ) )
  }
  else if( length( position ) != length( transcript.ids ) ) {
    stop( paste( 'Must have same number of positions as transcript.ids. (currently there are',
                length( position ), 'positions, and', length( transcript.ids ), 'transcript.ids)' ) )
  }

  data = do.call( 'rbind', lapply( seq_along( transcript.ids ), function( index ) {
    .single.transcript.coords.to.genome( transcript.ids[ index ],
                                         position[ index ],
                                         exons[ exons$IN1 == transcript.ids[ index ],, drop=FALSE ],
                                         check.bounds,
                                         truncate )
  } ) )

  if( dim( data )[2] != 5 ) {
    return( NULL )
  }

  if( as.vector == 'data.frame' ) {
    return( data )
  }

  if( as.vector ) {
    n           = data$IN1
    data        = data$start
    names(data) = n

    return( data )
  }

  data = data[ !is.na( data$start ),,drop=FALSE ]
  data = data[ !is.null( data$start ),,drop=FALSE ]

  if( dim( data )[1] == 0 ) {
    return( NULL )
  }

  colnames( data )[ colnames( data ) == "chromosome_name" ] = "space"
  data = as( data, 'RangedData' )

  if( .usegranges() ) {
    data = as( data, 'GRanges' )
  }

  return( data )
}

# -------------------------------------------------------------------------------
# Genome coords to Transcript

.genome.to.single.transcript.coords = function( position, transcript.id, exons, check.bounds ) {
  strand     = as.integer( unique( exons$strand ) )
  space      = as.character( unique( exons$chromosome_name ) )

  if( dim( exons )[1] == 0 ) {
    return( data.frame( start=NA, end=NA, chromosome_name=NA, strand=NA, IN1=transcript.id, stringsAsFactors=FALSE ) )
  }

  exons      = exons[ order( exons$start, decreasing=strand < 0 ), ]
  widths     = exons$end - exons$start + 1

  if( strand > 0 ) {
    # Forward Strand
    if( position > max( exons$end ) ) {
      if( check.bounds ) {
        warning( paste( 'Fell off the end of', transcript.id, 'looking for position', position ) )
        return( data.frame( start=NA, end=NA, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
      }
      pos = max( exons$end ) - position + sum( widths )
      return( data.frame( start=pos, end=pos, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
    }
    if( position < min( exons$start ) ) {
      if( check.bounds ) {
        warning( paste( 'Fell off the start of', transcript.id, 'looking for position', position ) )
        return( data.frame( start=NA, end=NA, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
      }
      pos = position - min( exons$start ) + 1
      return( data.frame( start=pos, end=pos, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
    }

    # Otherwise, we are in the range of the transcript (need to check for intronic hit)
    exon.index = 1
    found      = FALSE
    offset     = 1

    for( exon.index in 1:length( widths ) ) {
      if( position >= exons$start[ exon.index ] && position <= exons$end[ exon.index ] ) {
        found  = TRUE
        break
      }
      offset = offset + widths[ exon.index ]
    }
    if( !found ) {
      # INTRONIC
      return( data.frame( start=NA, end=NA, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
    }
    pos = offset + ( position - exons$start[ exon.index ] )
    return( data.frame( start=pos, end=pos, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
  }
  else {
    # Reverse strand
    if( position < min( exons$start ) ) {
      if( check.bounds ) {
        warning( paste( 'Fell off the end of', transcript.id, 'looking for position', position ) )
        return( data.frame( start=NA, end=NA, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
      }
      pos = min( exons$start ) - position + sum( widths )
      return( data.frame( start=pos, end=pos, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
    }
    if( position > max( exons$end ) ) {
      if( check.bounds ) {
        warning( paste( 'Fell off the start of', transcript.id, 'looking for position', position ) )
        return( data.frame( start=NA, end=NA, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
      }
      pos = max( exons$end ) - position + 1
      return( data.frame( start=pos, end=pos, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
    }

    # Otherwise, we are in the range of the transcript (need to check for intronic hit)
    exon.index = 1
    found      = FALSE
    offset     = 1

    for( exon.index in 1:length( widths ) ) {
      if( position >= exons$start[ exon.index ] && position <= exons$end[ exon.index ] ) {
        found  = TRUE
        break
      }
      offset = offset + widths[ exon.index ]
    }
    if( !found ) {
      # INTRONIC
      return( data.frame( start=NA, end=NA, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
    }
    pos = offset + ( exons$end[ exon.index ] - position )
    return( data.frame( start=pos, end=pos, stable_id=transcript.id, coord.space='transcript', stringsAsFactors=FALSE ) )
  }
}

genomeToTranscriptCoords = function( position, transcript.ids, as.vector=FALSE, check.bounds=TRUE, end=c( 'none', 'both', '5', '3' ) ) {
  end = match.arg( end )
  transcript.ids = as.character( .get.correct.column( 'transcript', transcript.ids ) )
  if( is.null( transcript.ids ) ) {
    return( NULL )
  }
  if( end == 'none' ) {
    exons = transcriptToExon( unique( transcript.ids ), as.vector='data.frame' )
  }
  else {
    exons = transcriptToCodingExon( unique( transcript.ids ), end=end, as.vector='data.frame' )
  }
  if( is.null( exons ) ) {
    return( NULL )
  }

  if( length( position ) == 1 ) {
    position = rep( position, length( transcript.ids ) )
  }
  else if( length( position ) != length( transcript.ids ) ) {
    stop( paste( 'Must have the same number of positions as transcript.ids. (currently there are',
                length( position ), 'positions, and', length( exons ), 'transcript.ids)' ) )
  }

  data = do.call( 'rbind', lapply( seq_along( transcript.ids ), function( index ) {
    .genome.to.single.transcript.coords( position[ index ],
                                         transcript.ids[ index ],
                                         exons[ exons$IN1 == transcript.ids[ index ],, drop=FALSE ],
                                         check.bounds )
  } ) )

  # Return NULL for empty results  
  if( dim( data )[1] == 0 ) {
    return( NULL )
  }

  if( as.vector == FALSE ) { # RangedData object
    data = data[ !is.na( data$start ),,drop=FALSE ]
    data = data[ !is.null( data$start ),,drop=FALSE ]
    if( dim( data )[1] == 0 ) {
      return( NULL )
    }
    colnames( data )[ colnames( data ) == "stable_id" ] = "space"

    data = as( data, 'RangedData' )
    if( .usegranges() ) {
      data$strand = '*'
      data = as( data, 'GRanges' )
    }
  }
  else if( as.vector == TRUE ) {
    n             = data$stable_id
    data          = data$start
    names( data ) = n

    return( data )
  }
  # else, return data.frame
  data
}

# -------------------------------------------------------------------------------
# And then genome to protein

.single.protein.coords.to.genome = function( protein.id, transcript, position, as.vector, check.bounds, truncate ) {
  if( dim( transcript )[1] == 0 ) {
    warning( paste( 'No transcript located for protein', protein.id ) )
    return( data.frame( start=NA, end=NA, chromosome_name=NA, strand=NA, IN1=protein.id, position=position, stringsAsFactors=FALSE ) )
  }

  transcript.stable.id = .attr( transcript, 'stable_id' )
  local.coding.range   = transcriptToCodingRange( transcript.stable.id )
  space                = if( .usegranges() ) as.character( seqnames( local.coding.range ) ) else as.character( space( local.coding.range ) )
  strand               = if( .usegranges() ) strandAsInteger( local.coding.range ) else local.coding.range$strand

  if( check.bounds && position < 1 ) {
    warning( paste( 'Fell off the start of protein', protein.id, 'looking for position', position ) )
    return( data.frame( start=NA, end=NA, chromosome_name=space, strand=strand, IN1=protein.id, position=position, stringsAsFactors=FALSE ) )
  }

  if( strand > 0 ) {
    first.coding = genomeToTranscriptCoords( start( local.coding.range ), transcript.stable.id, as.vector=TRUE )
    start.phase  = .attr( local.coding.range, 'phase' )
    if( start.phase < 0 ) {
      start.phase = 0;
    }
    # Only causes an effect when no defined UTRs
    if( .attr( transcript, 'translation_start' ) > 1 ) {
      start.phase = 0
    }

    posl = first.coding + 3 * ( position - 1 ) - start.phase
    posr = first.coding + 3 * ( position - 1 ) - start.phase + 2
  }
  else {
    first.coding = genomeToTranscriptCoords( end( local.coding.range ), transcript.stable.id, as.vector=TRUE )
    start.phase  = .attr( local.coding.range, 'phase' )
    if( start.phase < 0 ) {
      start.phase = 0;
    }
    # Only causes an effect when no defined UTRs
    if( .attr( transcript, 'translation_start' ) > 1 ) {
      start.phase = 0
    }
    posr = first.coding + 3 * ( position - 1 ) - start.phase
    posl = first.coding + 3 * ( position - 1 ) - start.phase + 2
  }

  posl <- transcriptCoordsToGenome( transcript.stable.id, posl, as.vector=TRUE, check.bounds=FALSE, truncate )
  posr <- transcriptCoordsToGenome( transcript.stable.id, posr, as.vector=TRUE, check.bounds=FALSE, truncate )
  
  if( is.na( posl ) || is.na( posr ) ) {
    # We will have been warned about this earlier
    return( data.frame( start=NA, end=NA, chromosome_name=space, strand=strand, IN1=protein.id, position=position, stringsAsFactors=FALSE ) )
  }
  if( check.bounds && posl < ( start( local.coding.range ) - start.phase ) ) {
    warning( paste( 'Position', position, 'generates a position of', posl, 'which falls beyond the start of coding range', start( local.coding.range ), 'for', transcript.stable.id ) )
    return( data.frame( start=NA, end=NA, chromosome_name=space, strand=strand, IN1=protein.id, position=position, stringsAsFactors=FALSE ) )
  } 
  
  if( check.bounds && posr > end( local.coding.range ) + start.phase ) {
    warning( paste( 'Position', position, 'generates a position of', posr, 'which falls beyond the end of coding range', end( local.coding.range ), 'for', transcript.stable.id ) )
    return( data.frame( start=NA, end=NA, chromosome_name=space, strand=strand, IN1=protein.id, position=position, stringsAsFactors=FALSE ) )
  }
  data.frame( start=posl, end=posr, chromosome_name=space, strand=strand, IN1=protein.id, position=position, stringsAsFactors=FALSE )
}

proteinCoordsToGenome = function( protein.ids, position=1, as.vector=FALSE, check.bounds=TRUE, truncate=TRUE ) {
  protein.ids = as.character( .get.correct.column( 'protein', protein.ids ) )

  if( is.null( protein.ids ) ) {
    return( NULL )
  }

  transcripts = proteinToTranscript( unique(protein.ids), as.vector='data.frame')

  if( is.null( transcripts ) ) {
    return( NULL )
  }
  
  if( length( position ) == 1 ) {
    position = rep( position, length( protein.ids ) )
  }
  else if( length( position ) != length( protein.ids ) ) {
    stop( paste( 'Must have same number of positions as protein.ids. (currently there are',
                length( position ), 'positions, and', length( protein.ids ), 'protein.ids.\n' ) )
  }

  data = do.call( 'rbind', lapply( seq_along( protein.ids ), function( index ) {

    .single.protein.coords.to.genome( protein.ids[ index ],
                                      transcripts[ transcripts$IN1 == protein.ids[ index ], ],
                                      position[ index ],
                                      as.vector,
                                      check.bounds,
                                      truncate )
  } ) )

  if( dim( data )[2] != 6 || dim( data )[1] == 0 ) {
    return( NULL )
  }
  
  if( as.vector == 'data.frame' ) {
    return( data )
  }
  
  if( as.vector ) {
    n             = data$IN1
    data          = apply( data, 1, function( row ) {
                      as.integer( if( as.integer( row[ 'strand' ] ) > 0 ) row[ 'start' ] else row[ 'end' ] )
                    } )
    names( data ) = n

    return( data )
  }

  data = data[ !is.na( data$start ), ]

  if( dim( data )[1] == 0 ) {
    return( NULL )
  }
  
  colnames( data )[ colnames( data ) == "chromosome_name" ] = "space"

  data = as( data, 'RangedData' )

  if( .usegranges() ) {
    data = as( data, 'GRanges' )
  }

  data
}

.single.genome.to.protein.coords = function( protein.id, transcript, position, as.vector, check.bounds ) {
  local.coding.range = transcriptToCodingRange( transcript )
  utrl               = genomeToTranscriptCoords( start( local.coding.range ), transcript, as.vector=TRUE, check.bounds=check.bounds )
  utrr               = genomeToTranscriptCoords( end( local.coding.range ),   transcript, as.vector=TRUE, check.bounds=check.bounds )
  pos                = genomeToTranscriptCoords( position, transcript, as.vector=TRUE, check.bounds=check.bounds )
  space              = if( .usegranges() ) as.character( seqnames( local.coding.range ) ) else as.character( space( local.coding.range ) )
  strand             = if( .usegranges() ) strandAsInteger( local.coding.range ) else local.coding.range$strand

  if( is.na( pos ) ) {
    # Already been warned
    return( data.frame( codon=NA, frame=NA, stable_id=protein.id, coord.space='protein', stringsAsFactors=FALSE ) )
  }

  if(strand > 0) {
    start.phase = .attr( local.coding.range, 'phase' )
    if( start.phase < 0 ) {
      start.phase = 0
    }
    # Only causes an effect when no defined UTRs
    if( .attr( transcript, 'translation_start' ) > 1 ) {
      start.phase = 0
    }
    r = pos - utrl + start.phase
    if( check.bounds ) {
      if( pos > utrr ) {
        warning( paste( 'Fell off the end of', protein.id, 'looking for position', position ) )
        r = NA
      }
      else if( r < 0 ) {
        warning( paste( 'Fell off the start of', protein.id, 'looking for position', position ) )
        r = NA
      }
    }
  }
  else {
    start.phase = .attr( local.coding.range, 'phase' )
    if( start.phase < 0 ) {
      start.phase = 0;
    }
    # Only causes an effect when no defined UTRs
    if( .attr( transcript, 'translation_start' ) > 1 ) {
      start.phase = 0
    }
    r = pos - utrr + start.phase
    if( check.bounds ) {
      if( pos > utrl ) {
        warning( paste( 'Fell off the end of', protein.id, 'looking for position', position ) )
        r = NA
      }
      else if( r < 0 ) {
        warning( paste( 'Fell off the start of', protein.id, 'looking for position', position ) )
        r = NA
      }
    }
  }


  codon = floor( r / 3 ) + 1
  frame = r %% 3

  data.frame( codon=codon, frame=frame, stable_id=protein.id, coord.space='protein', stringsAsFactors=FALSE )
}

genomeToProteinCoords = function( position, protein.ids, as.vector=FALSE, check.bounds=TRUE ) {
  protein.ids = as.character( .get.correct.column( 'protein', protein.ids ) )
  if( is.null( protein.ids ) ) {
    return( NULL )
  }
  
  if( length( position ) == 1 ) {
    position = rep( position, length( protein.ids ) )
  }

  else if( length( position ) != length( protein.ids ) ) {
    stop( paste( 'Must have same number of positions as protein.ids. (currently there are',
                length( position ), 'positions, and', length( protein.ids ), 'protein.ids).\n' ) )
  }

  transcripts   = proteinToTranscript(protein.ids, as.vector='data.frame')
  if( is.null( transcripts ) ) {
    return( NULL )
  }

  data = do.call( 'rbind', lapply( seq_along( protein.ids ), function( index ) {
    .single.genome.to.protein.coords( protein.ids[ index ],
                                      transcripts[ transcripts$IN1 == protein.ids[ index ], ],
                                      position[ index ],
                                      as.vector,
                                      check.bounds )
  } ) )

  #NB - can return from the function from here
  if( dim( data )[1] == 0 ) {
    return( NULL )
  }

  if( as.vector == FALSE ) { # RangedData object
    data = data[ !is.na( data$codon ),,drop=FALSE ]
    if( dim( data )[1] == 0 ) {
      return( NULL )
    }
    colnames( data )[ colnames( data ) == "stable_id" ] = "space"
    colnames( data )[ colnames( data ) == "codon"     ] = "start"
    data = cbind( data, end=data$start )
    data = as( data, 'RangedData' )
    if( .usegranges() ) {
      data$strand = '*'
      data = as( data, 'GRanges' )
    }
  }
  else if( as.vector == TRUE ) {
    n             = data$stable_id
    data          = data$codon
    names( data ) = n
  }
  # else, return data.frame
  data
}

spliceGroupIndex = function( x, group.column, members ) {
  # extract the meta-data from the eSet object
  pd  = pData( x )
  # Find the column of interest
  grp = pd[, colnames( pd ) == group.column ]
  # Return the indices of interest
  seq_along( grp )[ is.element( grp, members ) ]
}

spliceIndex = function( x, ids, group, gps, group.index.fn=spliceGroupIndex, median.gene=FALSE, median.probeset=FALSE, unlogged=TRUE ) {
  tr1 = if( missing( group ) ) { gps[[1]] } else { group.index.fn(x, group, gps[1]) }
  tr2 = if( missing( group ) ) { gps[[2]] } else { group.index.fn(x, group, gps[2]) }
  r = geneToExonProbesetExpr( x, ids )
  if( dim( r )[ 1 ] == 0 ) {
    # No results
    return( r )
  }
  # Split based on gene id
  gene.list = split( r, r$IN1 )
  lapply( gene.list, function( a ) {
    a   = a[ !duplicated( a$probeset ), , drop = FALSE ]
    idx = c( tr1, tr2 )
    tmp = as.matrix( a[, idx, drop = FALSE ] )
    tr1 = seq_along( tr1 )
    tr2 = length( tr1 ) + seq_along( tr2 )
    idx = c( tr1, tr2 )
    # Get our gene and probeset average function dependant on params
    avfun.g = if( median.gene     ) { median } else { mean }
    avfun.p = if( median.probeset ) { median } else { mean }
    # Generate the SI depending on whether the expression data was logged or not
    tmp = if( unlogged ) { 2^tmp } else { tmp }
    avs = apply( tmp, 2, avfun.g )
    tmp = sweep( tmp, 2, avs, if( unlogged ) { '/' } else { '-' } )
    s1  = apply( tmp[, tr1, drop = FALSE], 1, avfun.p )
    s2  = apply( tmp[, tr2, drop = FALSE], 1, avfun.p )
    si  = if( unlogged ) { log2( s1 / s2 ) } else { s1 - s2 }
    fac = as.factor( idx %in% tr2 )
    r   = rowttests( tmp, fac )
    val.and.stats = r[, c( 'p.value', 'statistic' ),drop = FALSE]
    repeated.avg  = rep( avfun.g( log2( avs[ tr1 ] ) - log2( avs[ tr2 ] ) ), length( si ) )
    r             = cbind( si, val.and.stats, repeated.avg )
    # Set the row an column names for the returned object
    rownames( r ) = a$probeset
    colnames( r ) = c( 'si', 'p.score', 't.statistic', 'gene.av' )
    r
  } )
}

.make.hash = function() {
  new.env( hash=TRUE, parent=emptyenv() )
}

.xmcws.connect = function( name ) {
  wshost = annmapGetParam( "wshost" )
  if( is.null( wshost ) ) {
    wshost = 'http://annmap.cruk.manchester.ac.uk'
  }
  if ( wshost == 'http://annmap.cruk.manchester.ac.uk' ) {
    stop( 'http://annmap.cruk.manchester.ac.uk is no longer available' )
  } else {
    data = suppressWarnings( fromJSON( file=paste( wshost, '/data/init.js', sep='' ) ) )
    a = do.call( 'rbind', unlist( lapply( names( data$items ), function( s ) {
      lapply( data$items[[ s ]]$versions, function( v ) {
        list( name=paste( s, v, sep='.' ), dbname=s, display=data$items[[ s ]]$display, version=v )
      } )
    } ), recursive=F ) )
    if( missing( name ) ) {
      r = menu( apply( a, 1, function( row ) {
        paste( row$name, ' -- ', row$display, ' v', row$version, ' (', wshost, '/?s=', row$dbname, ')', sep='' )
      } ), title="Select a database to connect to:" )
      if( r == 0 ) {
        return( invisible() )
      }
      else {
        name = a[ r, 'name' ]
      }
    }
    dbs = a[ ( as.character( a[, 'name'] ) == name ), , drop=FALSE ]

    if( dim( dbs )[1] == 0 ) {
      stop( paste( "Invalid db name:", name ) )
    }
    annmapDisconnect()
    species = as.character( dbs[,"dbname"] )
    version = as.character( dbs[,"version"] )
    annmapSetParam( species=species, version=version, host=wshost, db.name=name, connected=TRUE )

    cat( paste( 'Connected to ', name, ' (', wshost, ')\n', sep='' ) )

    arrayType( NULL, pick.default=TRUE )

    invisible( list( host=wshost, species=species, version=version ) )
  }
}

.pretty.size = function( x ) {
    ifelse( x >= 1024^3, paste( round( x/1024^3, 1L ), "Gb"    ),
    ifelse( x >= 1024^2, paste( round( x/1024^2, 1L ), "Mb"    ),
    ifelse( x >= 1024  , paste( round( x/1024,   1L ), "Kb"    ),
                         paste( x,                     "bytes" )
    )))
}

.load.and.parse = function( elements ) {
  wshost = annmapGetParam( "wshost" )
  if( is.null( wshost ) ) {
    wshost = 'http://annmap.cruk.manchester.ac.uk'
  }
  if ( wshost == 'http://annmap.cruk.manchester.ac.uk' ) {
    stop( 'http://annmap.cruk.manchester.ac.uk is no longer available' )
  } else {
    url = paste( wshost, '/data/annmapws/', paste( elements, collapse='/' ), '.js', sep='' )

    .xmap.internals$debugFn( paste( 'calling', url ) )

    if( annmapGetParam( 'quiet.webservice' ) == FALSE ) {
      cat( "Fetching data from webservice...\n" )
    }
    json = suppressWarnings( readLines( url ) )
    if( annmapGetParam( 'quiet.webservice' ) == FALSE ) {
      cat( paste( "Retrieved data of size ", .pretty.size( nchar( json ) ), ". Parsing...\n", sep='' ) )
    }
    data = fromJSON( json )

    if( !is.null( data$error ) ) {
      stop( data$error )
    }

    if( annmapGetParam( 'quiet.webservice' ) == FALSE ) {
      cat( paste( "Generating data.frame\n" ) )
    }
    if( length( data$items ) == 0 ) {
      return( NULL )
    }
    else if( is.null( names( data$items ) ) ) { # list from .all query
      parse = function( idx ) {
        ret = data$items[[ idx ]]
        ret = ret[ !( names( ret ) %in% c( '__type', '__id', 'synonyms' ) ) ]
        ret[ sapply( ret, is.null ) ] = NA
        unlist( ret )
      }
      rslt = data.frame(
        do.call( 'rbind',
          lapply( seq_along( data$items ), parse )
        ),
        stringsAsFactors=F )
    }
    else { # Map from other query
      innerMapping = function( idx, IN1 ) {
        ret = data$items[[ IN1 ]][[ idx ]]
        ret$IN1 = IN1
        ret = ret[ !( names( ret ) %in% c( '__type', '__id', 'synonyms' ) ) ]
        ret[ sapply( ret, is.null ) ] = NA
        unlist( ret )
      }
      outerMapping = function( IN1 ) {
        do.call( 'rbind', lapply( seq_along( data$items[[ IN1 ]] ), innerMapping, IN1=IN1 ) )
      }
      rslt = data.frame(
        do.call( 'rbind', lapply( names( data$items ), outerMapping ) ),
        stringsAsFactors=F )
    }
    # type convert values which need it (start, end, strand)
    if( !is.null( rslt$start ) )  rslt$start   = as.integer( rslt$start )
    if( !is.null( rslt$end ) )    rslt$end     = as.integer( rslt$end )
    if( !is.null( rslt$strand ) ) rslt$strand  = as.integer( rslt$strand )
    if( !is.null( rslt$length ) ) rslt$length  = as.integer( rslt$length )
    rslt
  }
}

.xmcws.disconnect = function() {
  # Do nowt
}

.xmcws.all = function( src, params, dest=NULL ) {
  cache.id = paste( .xmap.internals$version, .xmap.internals$species, src, 'all', params$array, sep=':' )
  ret = .cache.retrieve( cache.id )
  if( is.null( ret ) ) {
    elements = c( .xmap.internals$species, .xmap.internals$version, src, 'all' )
    if( !is.null( params$array ) ) {
      elements = c( elements, params$array )
    }
    ret = .load.and.parse( elements )
    if( annmapGetParam( 'quiet.webservice' ) == FALSE ) {
      cat( "Saving to cache.\n" )
    }
    .cache.store( cache.id, ret )
  }
  else if( annmapGetParam( 'quiet.webservice' ) == FALSE ) {
    cat( "Loaded data from cache.\n" )
  }
  ret
}

.xmcws.details = function( src, params, dest=NULL ) {
  if( is.null( params ) ) {
    return( NULL )
  }
  elements = c( annmapGetParam( 'species' ), annmapGetParam( 'version' ), src, 'details' )
  if( !is.null( params$array ) ) {
    elements = c( elements, params$array )
  }
  elements = c( elements, params$ids )
  .load.and.parse( elements )
}

.xmcws.to = function( src, params, dest=NULL ) {
  if( is.null( params ) ) {
    return( NULL )
  }
  elements = c( annmapGetParam( 'species' ), annmapGetParam( 'version' ), 'to', src, dest, if( !is.null( params$array ) ) params$array else 'null', params$ids )
  .load.and.parse( elements )
}

.xmcws.range = function( src, params, dest=NULL ) {
  if( is.null( params ) ) {
    return( NULL )
  }
  elements = c( annmapGetParam( 'species' ), annmapGetParam( 'version' ), src, 'range' )
  if( !is.null( params$array ) ) {
    elements = c( elements, params$array )
  }
  elements = c( elements, params$chr, format( params$qstart, scientific=F ), format( params$qstop, scientific=F ), params$qstrand )
  .load.and.parse( elements )
}

.ws.make.params = function( ids ) {
    if( is.null( ids ) ) {
        stop( "In .ws.make.params, ids is NULL" )
    }
    if( is.list( ids ) ) {
        ids = unlist( ids, use.names=FALSE )
    }
    mq        = 2000
    one       = max( nchar( ids ) ) + 1
    max.list  = mq %/% one
    n.lists   = length( ids ) %/% max.list
    by.mat    = ( max.list * n.lists )
    if( n.lists == 0 ) {
        return( paste( ids, sep=",", collapse="," ) )
    }
    else {
        mat = matrix( ids[ 1:by.mat ], nrow=n.lists, byrow=TRUE )
        r   = split( mat, row( mat ) )
        if( by.mat < length( ids ) ) {
            r = c( r, list( ids[ ( by.mat + 1 ):length( ids ) ] ) )
        }
        lapply( r, paste, sep=",", collapse="," )
    }
}

% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
%\VignetteIndexEntry{annmap cookbook}
%\VignetteKeywords{}
%\VignetteDepends{}
%\VignettePackage{annmap}
\documentclass[10pt, a4paper]{article}
\RequirePackage{colortbl}
\RequirePackage{xcolor}
\usepackage{amsmath,pstricks}
\usepackage{hyperref}
\usepackage[hmargin=3cm,vmargin=3.5cm]{geometry}
\usepackage[authoryear,round]{natbib}
\usepackage{fmtcount} % displaying latex counters
\usepackage[T1]{fontenc}
\usepackage[scaled]{helvet}
\usepackage{color}
\usepackage{multirow}
\usepackage{listings}
\usepackage{wrapfig}
\SweaveOpts{keep.source=TRUE}
\definecolor{darkred}{rgb}{0.545,0,0} 
\definecolor{midnightblue}{rgb}{0.098,0.098,0.439} 
\definecolor{palered}{rgb}{1.0,0.5,0.5} 
\definecolor{palegreen}{rgb}{0.5,1.0,0.5} 
\definecolor{silver}{rgb}{0.95,0.95,0.95}
\renewcommand*\familydefault{\sfdefault}
\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}
\newcommand{\code}[1]{{\ttfamily\texttt{#1}}}
\author{Tim Yates, Chris Wirth \& Crispin Miller}
\begin{document}
\lstset{language=R,breaklines=true,basicstyle=\ttfamily\color{midnightblue}} 
\title{ The \code{annmap} Cookbook;  Examples and Patterns for \code{annmap} }

\maketitle

\tableofcontents

\pagebreak

\section{Introduction}

\code{annmap} is a Bioconductor package that provides annotation data and
cross-mappings between, amongst other things, genes, transcripts, exons, proteins,
domains and Affymetrix probesets.  This document provides examples of its usage,
and recipes to help you get started. 

\section{Initial Steps}

\code{annmap} makes use of a MySQL database, \code{annmap}, to provide its
annotation data (downloadable from the Annmap
website\footnote{\url{http://annmap.cruk.manchester.ac.uk/download}}). A variety
of different species are supported - each with their own separate database. 

{\bf This document assumes that you have downloaded and installed one of the
available MySQL databases (as described in the \href{file:INSTALL.pdf}{INSTALL}
vignette that came with this package).}

It was formerly possible to connect to the annmap webservice instead of installing your
own database, but this service is no longer available.

\subsection{Preamble}

This cookbook is designed to walk you through the annmap functions from first
principles to you being able to generate plots such as Figure \ref{bridgeintro} 
for your Next-Generation Sequencing data.

<<eval=TRUE,echo=FALSE,results=hide>>=
library( annmap )
annmapConnect( 'hs-test' ) 

makeStrandRle = function( range, nReadings, max ) {
  s = Rle( sample( 0:max, nReadings, replace=T ) )
  r = runLength( s )
  r[ 1 ] = start( range )
  for( i in 2:length( r ) ) {
    r[ i ] = r[ i ] * ( width( range ) / nReadings )
  }
  runLength( s ) = r
  s
}

makeRandomRle = function( range, nReadings, max ) {
  .strand = strandAsInteger( range )
  ret = list()
  if( is.na( .strand ) ) {
    return( list( '+'=makeStrandRle( range, nReadings, max ), '-'=makeStrandRle( range, nReadings, max ) ) )
  }
  else if( .strand > 0 )
    return( makeStrandRle( range, nReadings, max ) )
  else
    return( makeStrandRle( range, nReadings, max ) )
}

makeRandomInput = function( range, max, nReadings, nTracks ) {
  colours  = rainbow( nTracks, v=0.5, s=0.5 )
  ret = lapply( 1:nTracks, function( x ) {
    list( name=paste( "Track", x ),
          rle=makeRandomRle( range, nReadings, max ),
          col=colours[ x ] )
  } )
  ret
}
gene = symbolToGene( 'SHH' )
strand( gene ) = '*'
bamfileData = makeRandomInput( gene, 10, 50, 3 )
@

<<eval=FALSE,echo=TRUE>>=
gene = symbolToGene( 'SHH' )
strand( gene ) = '*'
ngsBridgePlot( gene, bamfileData )
@
<<label=bridge1,fig=FALSE,results=tex,echo=FALSE>>=
wid = 4
hei = 4
png("bridge1.png", res=144, units='in', width = wid, height = hei)
ngsBridgePlot( gene, bamfileData )
dummy = dev.off()
cat( "\\begin{figure}[h]")
cat( "\\centering" )
cat( "\\includegraphics[width = ", wid, "in, height = ", hei, "in]{bridge1}" )
cat( "\\caption{Dummy (in this example) NGS data shown alongside SHH.  Grey boxes represent individual values. Coloured regions represent smoothed data. }" )
cat( "\\label{bridgeintro}" )
cat( "\\end{figure}")
@

<<eval=TRUE,echo=FALSE,results=hide>>=
annmapDisconnect()
detach( "package:annmap", unload=TRUE )
@

\pagebreak
\subsection{Loading the \code{annmap} package and connecting to the database}

Assuming everything is installed correctly, you should be able to load the package as normal:

<<eval=TRUE,echo=TRUE>>=
library( annmap )
@

If this is your first time running the package, you might need to create a
datasource. These are stored by default in a folder called \code{.annmap} in
your home directory, but this location can be customised by setting an
environment variable \code{ANNMAP\_HOME} to point to a folder of your choosing.
To add a datasource, we will use the \lstinline{annmapAddConnection} method.

Assuming you have installed the \code{annmap\_homo\_sapiens\_66} database into
a MySQL instance running on your local machine accessed by the username
\code{'test'} and with a blank password, you can run:

<<eval=FALSE,echo=TRUE>>=
annmapAddConnection( 'human66', 'homo_sapiens', '66', username='test' )
@

You then need to tell \code{annmap} to connect to this annotation database:

\begin{Schunk}
\begin{Sinput}
annmapConnect( 'human66' )
\end{Sinput}
\begin{Soutput}
Connected to annmap_homo_sapiens_66 (localhost)
Selected array 'HuEx-1_0' as a default.
\end{Soutput}
\end{Schunk}

A typical installation will support a variety of species, each with their own
version of the \code{annmap} database.  You can specify which database to use in
the function call. Here, for example, \code{human66} is the name we gave to our
new connection. If you enter \lstinline{annmapConnect()} without any parameters,
it will show you a list of possible databases to choose
from\footnote{unless you only have one database defined, in which case it will
simply connect you to that}.

\subsection{Using the annmap webservice\label{wsc}}

*** NOTE: This service is not currently available ***

It's also possible to connect to the annmap webservice to get your data.

This is slower than using a locally installed database, less reliable as it
relies on the annmap website which is occasionally taken down for updating.

Also, the annmap website operates a 'one in one out' rule, so when a new species
version is added, the oldest one is removed to save disk space.

Those caveats aside, it's a great way of testing things out without the need to
install MySQL and the database.

To connect to the webservice, simply call:

<<eval=FALSE,echo=TRUE>>=
annmapConnect( use.webservice=TRUE )
@

and you will be presented with a list of available connections to use.

As with the non-webservice connection, you can also do:

<<eval=FALSE,echo=TRUE>>=
annmapConnect( 'homo_sapiens.72', use.webservice=TRUE )
@

To connect to a known named webservice connection (so long as it exists).

\subsection{Disconnecting from the database}

To disconnect from the database, use:

\begin{Schunk}
\begin{Sinput}
annmapDisconnect()
\end{Sinput}
\begin{Soutput}
Disconnecting from annmap_homo_sapiens_66 (localhost)
\end{Soutput}
\end{Schunk}

Note that you do not have to disconnect before connecting to another database; 
\code{annmap} will do this automatically for you when \lstinline{annmapConnect} is called.

\subsection{Overview}

The majority of the calls in \code{annmap} fall into one of four categories: 
\code{'all'} queries that fetch all known instances of an object type,
\code{'details'} queries that provide more detailed annotation for a list of IDs,
\code{'to'} queries that provide mappings between things (e.g. from genes to exons),
and \code{'range'} queries that find the things that lie between a pair of coordinates.
These are summarised in table \ref{tab:summary}.

\begin{table} 
    \begin{tabular}{ll|l|l|l|l|l|l|l|l|l|l|l|l|l|l|l|l|l|}
        \cline{3-16}
        ~ & ~                 & \multicolumn{ 14 }{|c|}{ TO } & ~ & ~ & ~ \\
        \cline{3-16}
        ~ & ~                 & \rotatebox{90}{Gene} & \rotatebox{90}{Transcript} & \rotatebox{90}{Exon} & \rotatebox{90}{EST Gene} & \rotatebox{90}{EST Transcript} & \rotatebox{90}{EST Exon} & \rotatebox{90}{Prediction Transcript} & \rotatebox{90}{Prediction Exon} & \rotatebox{90}{Probeset} & \rotatebox{90}{Probe} & \rotatebox{90}{Hit} & \rotatebox{90}{Protein} & \rotatebox{90}{Domain} & \rotatebox{90}{Symbol} & ~ & \rotatebox{90}{InRange} & \rotatebox{90}{Details} \\ 
        \hline
        \multicolumn{1}{|c|}{\multirow{14}{*}{ \rotatebox{90}{ From } }} & Gene                  & \cellcolor{palered}N    & \cellcolor{palegreen}Y          & \cellcolor{palegreen}Y    & \cellcolor{palered}N        & \cellcolor{palered}N              & \cellcolor{palered}N        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palegreen}Y        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y      & \cellcolor{palegreen}Y      & ~ & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & Transcript            & \cellcolor{palegreen}Y    & \cellcolor{palered}N          & \cellcolor{palegreen}Y    & \cellcolor{palered}N        & \cellcolor{palered}N              & \cellcolor{palered}N        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palegreen}Y        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y      & \cellcolor{palered}N      & ~ & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & Exon                  & \cellcolor{palegreen}Y    & \cellcolor{palegreen}Y          & \cellcolor{palered}N    & \cellcolor{palered}N        & \cellcolor{palered}N              & \cellcolor{palered}N        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palegreen}Y        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palered}N       & \cellcolor{palered}N      & \cellcolor{palered}N      & ~ & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & EST Gene              & \cellcolor{palered}N    & \cellcolor{palered}N          & \cellcolor{palered}N    & \cellcolor{palered}N        & \cellcolor{palegreen}Y              & \cellcolor{palegreen}Y        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palegreen}Y        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palered}N       & \cellcolor{palered}N      & \cellcolor{palered}N      & ~ & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & EST Transcript        & \cellcolor{palered}N    & \cellcolor{palered}N          & \cellcolor{palered}N    & \cellcolor{palegreen}Y        & \cellcolor{palered}N              & \cellcolor{palegreen}Y        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palegreen}Y        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palered}N       & \cellcolor{palered}N      & \cellcolor{palered}N      & ~ & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & EST Exon              & \cellcolor{palered}N    & \cellcolor{palered}N          & \cellcolor{palered}N    & \cellcolor{palegreen}Y        & \cellcolor{palegreen}Y              & \cellcolor{palered}N        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palegreen}Y        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palered}N       & \cellcolor{palered}N      & \cellcolor{palered}N      & ~ & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & Prediction Transcript & \cellcolor{palered}N    & \cellcolor{palered}N          & \cellcolor{palered}N    & \cellcolor{palered}N        & \cellcolor{palered}N              & \cellcolor{palered}N        & \cellcolor{palered}N                     & \cellcolor{palegreen}Y               & \cellcolor{palegreen}Y        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palered}N       & \cellcolor{palered}N      & \cellcolor{palered}N      & ~ & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & Prediction Exon       & \cellcolor{palered}N    & \cellcolor{palered}N          & \cellcolor{palered}N    & \cellcolor{palered}N        & \cellcolor{palered}N              & \cellcolor{palered}N        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palered}N        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palered}N       & \cellcolor{palered}N      & \cellcolor{palered}N      & ~ & \cellcolor{palered}N       & \cellcolor{palered}N       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & Probeset              & \cellcolor{palegreen}Y    & \cellcolor{palegreen}Y          & \cellcolor{palegreen}Y    & \cellcolor{palegreen}Y        & \cellcolor{palegreen}Y              & \cellcolor{palegreen}Y        & \cellcolor{palegreen}Y                     & \cellcolor{palered}N               & \cellcolor{palered}N        & \cellcolor{palegreen}Y     & \cellcolor{palegreen}Y   & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y      & \cellcolor{palered}N      & ~ & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & Probe                 & \cellcolor{palered}N    & \cellcolor{palered}N          & \cellcolor{palered}N    & \cellcolor{palered}N        & \cellcolor{palered}N              & \cellcolor{palered}N        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palegreen}Y        & \cellcolor{palered}N     & \cellcolor{palegreen}Y   & \cellcolor{palered}N       & \cellcolor{palered}N      & \cellcolor{palered}N      & ~ & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & Hit                   & \cellcolor{palered}N    & \cellcolor{palered}N          & \cellcolor{palered}N    & \cellcolor{palered}N        & \cellcolor{palered}N              & \cellcolor{palered}N        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palered}N        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palered}N       & \cellcolor{palered}N      & \cellcolor{palered}N      & ~ & \cellcolor{palered}N       & \cellcolor{palered}N       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & Protein               & \cellcolor{palegreen}Y    & \cellcolor{palegreen}Y          & \cellcolor{palered}N    & \cellcolor{palered}N        & \cellcolor{palered}N              & \cellcolor{palered}N        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palegreen}Y        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palered}N       & \cellcolor{palegreen}Y      & \cellcolor{palered}N      & ~ & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & Domain                & \cellcolor{palegreen}Y    & \cellcolor{palegreen}Y          & \cellcolor{palered}N    & \cellcolor{palered}N        & \cellcolor{palered}N              & \cellcolor{palered}N        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palegreen}Y        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palegreen}Y       & \cellcolor{palered}N      & \cellcolor{palered}N      & ~ & \cellcolor{palegreen}Y       & \cellcolor{palegreen}Y       \\ 
        \cline{2-19}
        \multicolumn{1}{|c|}{}                        & Symbol                & \cellcolor{palegreen}Y    & \cellcolor{palegreen}Y          & \cellcolor{palered}N    & \cellcolor{palegreen}Y        & \cellcolor{palegreen}Y              & \cellcolor{palered}N        & \cellcolor{palered}N                     & \cellcolor{palered}N               & \cellcolor{palered}N        & \cellcolor{palered}N     & \cellcolor{palered}N   & \cellcolor{palered}N       & \cellcolor{palered}N      & \cellcolor{palered}N      & ~ & \cellcolor{palered}N       & \cellcolor{palered}N       \\
        \hline
    \end{tabular}
    \caption{ \label{tab:summary} The mappings and functions available in annmap database. Mapping queries are of the form \code{XXXToYYY()}, searches using genome coordinates, \code{XXXInRange()}, and detailed annotation \code{XXXDetails()} }
\end{table}

\pagebreak

\section{ Fetching Data }

\subsection{Retrieving all instances of a given type.}

It is often useful to get a list of, for example, all genes or transcripts in the database.
For this we would use functions such as \lstinline{allGenes} or \lstinline{allTranscripts}.
All the functions of this type are defined in the documentation object \lstinline{?annmap.all}.

For example, to get a list of all the chromosomes in the human database, we can simply type:

<<eval=TRUE,echo=FALSE,results=hide>>=
# Connect to the development db used to build this vignette
annmapConnect( 'hs-test' )
@

\begin{Schunk}
\begin{Sinput}
annmapConnect( 'human66' )
\end{Sinput}
\begin{Soutput}
Connected to annmap_homo_sapiens_66 (localhost)
Selected array 'HuEx-1_0' as a default.
\end{Soutput}
\end{Schunk}

<<eval=TRUE,echo=TRUE>>=
allChromosomes()
@

By default these functions all return a \lstinline{GRanges} object (if the concept of
genomic coordinates is appropriate), or a \code{data.frame} (if a genomic region doesn't
exist for the object).  It is also possible to just get the names of the chromosomes
by passing \lstinline{as.vector=TRUE} as a parameter:

<<eval=TRUE,echo=TRUE>>=
allChromosomes( as.vector=TRUE )
@

\subsubsection{ Possible values for \lstinline{as.vector} and \lstinline{as.data.frame} }

Almost all of the functions in \code{annmap} accept an \lstinline{as.vector} parameter,
and will return a vector of identifiers rather than the full table of available
information.  Setting \lstinline{as.vector='data.frame'} will return a \code{data.frame},
rather than a \code{GRanges} object:

\begin{center}
\begin{tabular}{ l l l r }
  parameter & & return type & \\
\hline
  & & & \\
  as.vector=TRUE & => & a character vector of ids & \\
  as.vector=FALSE & => & A GRanges object & (default)\\
  as.vector='data.frame' & => & A data.frame & \\
\end{tabular}
\end{center}

All of the \code{XXXDetails()} functions and functions that map to Hits or coding regions take a parameter \lstinline{as.data.frame} instead (where a vector
would not be possible):

\begin{center}
\begin{tabular}{ l l l r }
  parameter & & return type & \\
\hline
  & & & \\
  as.data.frame=FALSE & => & A GRanges object & (default) \\
  as.data.frame=TRUE & => & A data.frame & \\
\end{tabular}
\end{center}

\subsection{Getting detailed annotation based on database identifiers.}

Sometimes, you will have a list of IDs for which you require more detailed annotation.
You can use the \lstinline{?annmapDetails} methods for this.

For example, given a list of chromosome names, we can find their length:

<<eval=TRUE,echo=TRUE>>=
chr.list = c( '1', '2', '3' )
chromosomeDetails( chr.list )
@

Or we can look for the details of a few microarray probes by their sequence:

<<eval=TRUE,echo=TRUE>>=
some.probes = probesetToProbe( '3855295' )
probeDetails( some.probes )
@

Note that Probe sequences inside the \code{annmap} database are not the exact physical
sequences to be found on the  corresponding array. Instead, we always return the sequence
of the genomic target.

\subsubsection{The order of things}
\begin{wrapfigure}[6]{l}{7em}\centering
    \includegraphics[width=2cm,height=2cm,keepaspectratio]{yellow-exclamation.png}
\end{wrapfigure}
When calling the following transformation queries (\code{XXXToYYY}, and \code{XXXDetails}), you should not rely on the order of the output being the same as the input order.

If you need to look things up based on the input id you gave them, you should either subset based on the identifier column (ie: \lstinline{d[ d$stable_id == 'PTEN', ]}), or you can split the results based on a column (see section \ref{in1})

\subsection{One thing to another}

In this section, we look at the available functions for mapping between annotation items.
The majority of mappings are available, and all take the form \code{XXXToYYY}\footnote{A
full list of functions can be found by entering \lstinline{?annmapTo} in an \code{R} console.}
(Table \ref{tab:summary})

\subsubsection{Finding a gene by its symbol}

For example, we can fetch a gene by its symbol:

<<eval=TRUE,echo=TRUE>>=
symbolToGene( 'PTEN' )
@

Or by vector of symbols:

<<eval=TRUE,echo=TRUE>>=
symbolToGene( c( 'PTEN', 'SHH' ) )
@

Again, \lstinline{as.vector} works as before:

<<eval=TRUE,echo=TRUE>>=
symbolToGene( c( 'PTEN', 'SHH' ), as.vector=TRUE )
@

\subsubsection{Mapping from a gene to its transcripts}

<<eval=TRUE,echo=TRUE>>=
gene = symbolToGene( c( 'PTEN', 'SHH' ) )
geneToTranscript( gene )
@

And with \lstinline{as.vector}:

<<eval=TRUE,echo=TRUE>>=
transcripts = geneToTranscript( gene, as.vector=TRUE )
transcripts
@

We have tried to keep all of the methods in \code{annmap} "type agnostic" - so this will work passing a \lstinline{character} vector as the parameter in place of a \lstinline{GRanges} object:

<<eval=TRUE,echo=TRUE>>=
gene = symbolToGene( 'PTEN', as.vector=TRUE )
class( gene )
geneToTranscript( gene )
@

\subsubsection{The \lstinline{IN1} field in \lstinline{'to'} results\label{in1}}

The \lstinline{GRanges} and \lstinline{data.frame} returned by \lstinline{'to'} queries, contain a column \lstinline{IN1}.  This corresponds to the initial query that led to the row being generated.  If we extract the \lstinline{IN1} column, we get the original 2 genes that we sent to the query:

<<eval=TRUE,echo=TRUE>>=
geneToTranscript( symbolToGene( c( 'PTEN', 'SHH' ) ) )$IN1
@

This can be very useful when we wish to use, for example, \lstinline{merge}, to combine a table of expression data with the annotation data supplied by \code{annmap}.

It can also be used with the \lstinline{split} method to get the returned data into a \lstinline{list}, for example, to generate a list, one element per gene, each containing the exons found in that gene:

<<eval=TRUE,echo=TRUE>>=
exons = geneToExon( symbolToGene( c( 'PTEN', 'SHH' ) ) )
split( exons$stable_id, exons$IN1 )
@

\subsubsection{Microarray probeset mappings}

\code{annmap} also provides probe mappings for Affymetrix microarrays. When
you connect to a database, \code{annmap} will pick an array by default (if
a mapping exists for that species).

To select your array of choice, you can use the \lstinline{arrayType()} method:

<<eval=TRUE,echo=TRUE>>=
arrayType( 'HuEx-1_0' )
@

As with \lstinline{annmapConnect()} calling this function with no parameters
will give you a menu of available arrays to choose from.

Probesets are treated like any other feature, so:
<<eval=TRUE,echo=TRUE>>=
exonToProbeset(geneToExon(symbolToGene('MPI')),as.vector=TRUE)
@

will find all probesets that map to exons in the gene MPI (as a vector). 

Ommitting the \lstinline{as.vector=TRUE} parameter in the call will give us the
results in a \lstinline{data.frame}. Here's the details of the first probeset
from our last query:

<<eval=TRUE,echo=TRUE>>=
exonToProbeset(geneToExon(symbolToGene('MPI')) )[1,]
@

As you can see, a probeset's details, comprises a set of scores.  These scores
are always 0, 1 or 2;

\begin{enumerate}
\setcounter{enumi}{-1}
  \item One or more of the probes miss the item of interest
  \item All of the probes hit the item of interest once (and only once)
  \item One or more of the probes hit more than one item of interest
\end{enumerate}

So a \lstinline{hit_score} of 1 means that each and every probe in the probeset
hit the genome once and only once, but a score of 2 for \lstinline{gene_score}
means that one or more of the probes hits more than one gene. Since if it also
has a hit score of 1, this means that the match is at a region where 2 genes
are overlapping.

\subsubsection{Some subtleties with probeset mappings}
Probeset mappings in \code{annmap} are done in two ways:
\begin{enumerate}
  \item Probes are mapped to the entire genome, and their match locations recorded, and
  \item they are also mapped directly to cDNA sequences in order to pick up probes and probesets that fall on exon junctions.
\end{enumerate}

\lstinline{probesetToCdnatranscript} and \lstinline{transcriptToCdnaprobeset}
provide the mappings needed to retrieve these probesets.

\pagebreak

\section{Searching by genome coordinates}

\subsection{Finding things by their location}

It is also possible to provide a set of genomic regions and find the features
they contain.

For example:

<<eval=TRUE,echo=TRUE>>=
geneInRange( '7', 1000000, 1060000, 1 )
@

will find all of the genes on the forward strand of chromosome '7' that lie
between positions 1000000 and 1060000. \code{XXXInRange} queries also accept
\code{data.frame}, \code{RangedData} and \code{GRanges} objects (see
\lstinline{?annmapRange}):

<<eval=TRUE,echo=TRUE>>=
# Use a data.frame as the initial parameter
.df = data.frame( chromosome_name='7', start=1000000, end=1060000, strand=1 )
geneInRange( .df, as.vector=TRUE )

# Use a RangedData object as the initial parameter
.rd = RangedData( space='7', ranges=IRanges( start=1000000, end=1060000 ), strand=1 )
geneInRange( .rd, as.vector=TRUE )

# Use a GRanges object as the initial parameter
.rd = RangedData( space='7', ranges=IRanges( start=1000000, end=1060000 ), strand=1L )
.rd = as( .rd, 'GRanges' )
.rd
geneInRange( .rd, as.vector=TRUE )
@

This means that it is possible to chain \code{InRange} queries as you would most of the other queries, ie;

<<eval=TRUE,echo=TRUE>>=
geneToSymbol(                      # Return the gene symbols
  exonToGene(                      # get the gene for each exon
    exonInRange(                   # get all exons contained in the GRanges
      symbolToGene( 'PTEN' ) ) ) ) # get a GRanges object for PTEN
@

For example, to find all probes that target within 1Kb of the \code{3\'} end of
each gene in \code{genes}, we can first alter the range of these objects so
they are just covering our region of interest:

<<eval=TRUE,echo=TRUE>>=
genes = geneInRange( '7', 1000000, 1060000, 1 )
start(genes) = end( genes ) - 1000
@

Before calling \lstinline{probeInRange} on the modified \lstinline{GRanges}
object:

<<eval=TRUE,echo=TRUE>>=
probeInRange( genes )
@

As with other queries, the \lstinline{as.vector} parameter can be used to
return more concise results:

<<eval=TRUE,echo=TRUE>>=
probeInRange( genes, as.vector=TRUE )
@

For example, it is possible to find estGenes which overlap known genes as follows:

<<eval=TRUE,echo=TRUE>>=
estGeneInRange( symbolToGene( c( 'lama3', 'tp53', 'shh' ) ), as.vector=TRUE )
@

\subsection{Adventures with annmapRangeApply}

A common task is to iterate down a \lstinline{GRanges} object and perform a function per row.  This functionality is provided by the method \lstinline{annmapRangeApply()}.

To take a contrived example, lets write a function that takes a \lstinline{GRanges} object, and returns a character vector of the form \code{chr:location} (to provide labels for a graph, say):

<<eval=TRUE,echo=TRUE>>=
contrived.function = function( chromosome, location ) {
  paste( chromosome, ':', location, sep='' )
}
@

In a moment, we're going to use \lstinline{annmapRangeApply} to map this down a set of transcripts, which we'll retrieve now:
 
<<eval=TRUE,echo=TRUE>>=
transcripts = geneToTranscript( symbolToGene( c( 'shh', 'tp53' ) ) )
@

Before we can do this, though, we need to tell the function which columns in the \lstinline{GRanges} object to map onto 'chromosome' and 'location', and also to tell it what datatype each of these parameters should be.

This is done using two additional parameters in \lstinline{annmapRangeApply}: \code{filter} and \code{coerce}. The first defines the column names in the \lstinline{GRanges} object we are interested in, the second, the functions we need to coerce these to the expected types\footnote{The coerce is needed because we can't always rely on R to correctly guess the data type we're expecting ('space' in a \lstinline{GRanges} object will often be converted to a factor, not a character vector as required by \lstinline{paste} in our \lstinline{contrived.function})}:

<<eval=TRUE,echo=TRUE>>=
contrived.filter = c( chromosome='space', location='start' )
contrived.coerce = c( as.character, as.numeric )
@

Once these are defined, we can then fire off our apply statement, as follows:

<<eval=TRUE,echo=TRUE>>=
annmapRangeApply( transcripts,
                  contrived.function,
                  contrived.filter,
                  contrived.coerce )
@

\pagebreak

\section{Affymetrix\texttrademark Array Annotation}

As well as providing Ensembl annotation, annmap also provides mappings for Affymetrix\texttrademark arrays, as described in \emph{An annotation infrastructure for the analysis and interpretation of Affymetrix exon array data} \href{http://genomebiology.com/2007/8/5/R79}{Genome Biology 2007, 8:R79, doi:10.1186/gb-2007-8-5-r79}.

\subsection{\code{Exonic}, \code{intronic}, \code{intergenic} and \code{unreliable}}

Probesets in \code{annmap} are defined as being either \lstinline{exonic}, \lstinline{intronic}, \lstinline{intergenic} or \lstinline{unreliable}.  These terms are best described by:

\begin{itemize}
\item \code{Exonic}:  Probesets are classed as exonic if all of their probes map to the genome only once, and every one of these mappings falls within an exon boundary.
\item \code{Intronic}:  Probesets are classed as intronic if all of their probes map to the genome only once, but at least one probe misses an exon region, but still falls within the boundary of a gene.
\item \code{Intergenic}:  Probesets are classed as intergenic if all of their probes map to the genome only once, but at least one probe misses all the known genes.
\item \code{Unreliable}:  Probesets with one or more multi-targetting probes, or with one or more probes that do not map to the genome, are classed as unreliable.
\end{itemize}

These categories are a very broad filter.  An unreliable probeset may have 3 probes which all hit in a single location and all hit an exon, but the single probe which misses mapping to the genome will result in the entire probeset being classed as to unreliable.
 
\subsection{The filtering methods}

To filter a collection of probesets by their relevant category, the obvious
methods exist.  For example, we can look at the probesets that are hitting
around the gene for TP53:

<<eval=TRUE,echo=FALSE>>=
annmapClearCache()
@
<<eval=TRUE,echo=TRUE>>=
g     = symbolToGene('TP53')
ps    = geneToProbeset( g, as.vector=TRUE )
length(ps)
@

We can then see numbers of probesets that match each category:

\label{specificitycache}
<<eval=TRUE,echo=TRUE>>=
length( exonic( ps ) )
length( intronic( ps ) )
length( intergenic( ps ) )
length( unreliable( ps ) )
@

So as you can see, hitting \code{TP53}, we have \Sexpr{length( exonic( ps ) )} exonic, \Sexpr{length( intronic( ps ) )} intronic, \Sexpr{length( intergenic( ps ) )} intergenic\footnote{This may seem odd, but note that as only a single probe in a probeset needs to be intergenic for the entire probeset to be categorised as such. So it is possible for a probeset that mostly maps to a gene to be flagged as intergenic.} and \Sexpr{length( unreliable( ps ) )} unreliable probesets.

All of these functions, will take an \code{exclude} parameter that results in an inverted list.  So to get the number of all of the probesets that are not unreliable, we can do:

<<eval=TRUE,echo=TRUE>>=
length( unreliable( ps, exclude=T ) )
@

Since anything that is not unreliable must hit the genome somewhere, the following should evaluate to \lstinline{TRUE}:

<<eval=TRUE,echo=TRUE>>=
u.ps = sort( unreliable( ps, exclude=T ) )
c.ps = sort( c( intronic( ps ), exonic( ps ), intergenic( ps ) ) )
all( u.ps == c.ps )
@

\subsection{UTR filtering}

The function \lstinline{utrProbesets} can be used to find those probesets that hit UTRs:

<<eval=TRUE,echo=TRUE>>=
gene = symbolToGene( 'TP53' )
probesets = geneToProbeset( gene )
utrProbesets( probesets )
@
In this form, the function will attempt to match probesets to all possible transcripts and then filter by UTR, so any UTR targeting probeset will be found. 

You can also pass a vector of transcripts in, in which case the search is limited to these:

<<eval=TRUE,echo=TRUE>>=
transcripts = geneToTranscript( gene, as.vector=TRUE )[1:6]
transcripts
utrProbesets( probesets, transcripts )
@

So these probesets have at least one probe in the UTR regions of the first six transcripts of TP53.

It is also possible to limit the search to only the 3' or 5' UTR:

<<eval=TRUE,echo=TRUE>>=
utrProbesets( probesets, transcripts, end='3' )
utrProbesets( probesets, transcripts, end='5' )
@

It is also possible to omit the list of probesets and the utr.probeset function will generate one for you:

<<eval=TRUE,echo=TRUE>>=
utrProbesets( NULL, transcripts )
@

Or you can get a list of probesets which fall inside the coding region of a transcript by using the complementary \lstinline{codingProbesets} function:

<<eval=TRUE,echo=TRUE>>=
codingProbesets( NULL, transcripts )
@

\subsection{Coding regions and UTRs}

It is possible to manipulate a list of transcripts so that you find the genomic location of their coding region or UTR.  This is done using the two complementary methods \lstinline{transcriptToUtrRange} and \lstinline{transcriptToCodingRange}.  Here for example is the normal details for a given transcript \code{ENST00000297261} which falls on the reverse strand of Chromosome 7 in human:

<<eval=TRUE,echo=TRUE>>=
transcriptDetails( 'ENST00000297261' )
@

We can also get the genomic coordinates of its coding region:

<<eval=TRUE,echo=TRUE>>=
transcriptToCodingRange( 'ENST00000297261' )
@

Or, we can get the regions covered by the UTR of this same transcript:

<<eval=TRUE,echo=TRUE>>=
transcriptToUtrRange( 'ENST00000297261' )
@

Again, these two methods take an optional \lstinline{'end'} parameter to specify which end of the transcript you want to work with\footnote{if you pass an \lstinline{'end'} to
\lstinline{transcriptToCodingRange}, you are choosing which UTR to omit from the range, i.e. passing \lstinline{end='3'} returns you the range that covers both the coding range
and the 5' end, but not the 3' end.}:

<<eval=TRUE,echo=TRUE>>=
transcriptToCodingRange( 'ENST00000297261', end='3' )
transcriptToUtrRange( 'ENST00000297261', end='3' )
@

It is also possible to get just those exons (or parts thereof) that are coding or for the UTR:
<<eval=TRUE,echo=TRUE>>=
transcriptToCodingExon( 'ENST00000297261' )
transcriptToUtrExon( 'ENST00000297261' )
@

\subsection{Gene and Transcript coding length}

It is possible to get the 'coding length' of a gene by calling:

<<eval=TRUE,echo=TRUE>>=
nonIntronicGeneLength( symbolToGene( c( 'SHH', 'PTEN' ) ) )
@

This merges all the exons in each gene (overlapping them where applicable) and returns you a sum of all their widths.

For transcripts, you also have the method:

<<eval=TRUE,echo=TRUE>>=
nonIntronicTranscriptLength( geneToTranscript( symbolToGene( 'SHH' ) ) )
@

In which you may also specify if you wish to only look at coding regions by specifying an 'end':

<<eval=TRUE,echo=TRUE>>=
nonIntronicTranscriptLength( geneToTranscript( symbolToGene( 'SHH' ) ), end='both' )
@

\pagebreak

\section{\code{annmap}'s local cache}

You may have noticed that the first time we called \lstinline{exonic} on page
\pageref{specificitycache}, \code{annmap} told us that it was \code{'Building
probeset specificity cache......'}.  This cache allows us to filter large
numbers of probesets much quicker than doing each in turn.  However, for
smaller queries of less than about 1000 probesets (on our system) it is quicker
not to suffer the $\approx$ 1s load time for the cache to be loaded into memory
from disk.

If you are running lots of these filtering queries on small numbers of
probesets (in a loop or apply, for example), it might be worth turning the
cache off whilst you run them:

<<eval=TRUE,echo=TRUE>>=
annmapToggleCaching()
@

Now, the cache (on by default) has been turned off. (This can be seen by the return value of \lstinline{FALSE}).  Calling toggle again will turn it back on:

<<eval=TRUE,echo=TRUE>>=
annmapToggleCaching()
@

Currently we cache the probeset specificity data used for the filters, described above, and the calls to \code{allXXX}.  The cache is stored in \code{.annmap/cache}.

\section{The path to the answer matters}

\subsection{The probeset boundary to commutativity }

In general, \code{annmap} is commutative. For example, if you go from a list of genes to transcripts and back again, you will end up where you started:

<<eval=TRUE,echo=TRUE>>=
genes = symbolToGene( c( 'PTEN', 'SHH' ), as.vector=TRUE )
genes
transcripts = geneToTranscript( genes, as.vector=TRUE )
transcripts
genes = transcriptToGene( transcripts, as.vector=TRUE )
genes
geneToSymbol( genes )
@

However, with probesets, this commutativity is broken.  This is because they (even exonic probesets) can hit genes, transcripts or exons other than those in the list that you passed in -- for example:

<<eval=TRUE,echo=TRUE>>=
genes = symbolToGene( c( 'pten', 'shh' ), as.vector=TRUE )
genes
probesets = exonic( geneToProbeset( genes, as.vector=TRUE ) )
probesets
genes = probesetToGene( probesets, as.vector=TRUE )
genes
geneToSymbol( genes )
@

Indeed, any mapping involving hits, probes or probesets, are not commutative.

\pagebreak

\section{Utility methods}

\subsection{Splicing Index}

For this test, we have an eSet object stored locally which contains expression data
for an MCF7/MCF10A dataset around the gene 'tp53'.

<<eval=TRUE,echo=TRUE,keep.source=TRUE>>=
load( file.path( path.package('annmap'), 'rdata', 'HuEx-1_0.tp53.expr.RData' ) )
x.rma
@

So, we can call our \lstinline{spliceIndex} method, passing this data, the gene id for 'tp53' and
the fact that the first 3 columns are one sample type (mcf7) and the second 3 are the
other sample.

<<eval=TRUE,echo=TRUE,keep.source=TRUE>>=
spliceIndex( x.rma, symbolToGene( 'TP53' ), gps=list(1:3,4:6) )
@

As can be seen, this call returns a list, with one \lstinline{data.frame} per gene.  In
this example, we only have passed a single gene for brevity.

\subsection{Mapping probes into transcript coordinates}

To find the location of probes relative to the mature, spliced mRNA sequence (rather than in genome coordinate space), the function \lstinline{transcriptToTranslatedprobes} joins the exons in a transcript (from the \lstinline{5'} end to the \lstinline{3'} end), and then converts the probe locations so that they are an offset from the \lstinline{5'} end of the transcript.

<<eval=TRUE,echo=TRUE>>=
transcriptToTranslatedprobes( c( 'ENST00000462694', 'ENST00000329958' ) )
@

Please note, that this function does not return probes that span the exon-junctions of the combined transcript sequence.

\subsection{Converting between Genomic, Transcript and Protein coordinates}

In \code{annmap}, there are two functions that convert between genomic coordinates and the related transcript/protein coordinates.

<<eval=TRUE,echo=TRUE>>=
# Given the tp53 gene
gene        = symbolToGene( 'tp53' )
# And the transcripts for this gene
transcripts = geneToTranscript( gene )
# And the proteins for this transcript
proteins    = transcriptToProtein( transcripts )
# get the transcript coords for the transcripts of this gene, at the start of this gene
genomeToTranscriptCoords( start( gene ), transcripts )
# With as.vector=TRUE
genomeToTranscriptCoords( start( gene ), transcripts, as.vector=TRUE )

# Get the coding range for the transcripts
coding = transcriptToCodingRange( transcripts )

# And then to protein coordinates
genomeToProteinCoords( start( coding ), proteins )
# With as.vector=TRUE
genomeToProteinCoords( start( coding ), proteins, as.vector=TRUE )
@

There are also functions for performing translation in the opposite direction; \lstinline{proteinCoordsToGenome} and \lstinline{transcriptCoordsToGenome}.

<<eval=TRUE,echo=TRUE>>=
pos.one = transcriptCoordsToGenome( transcripts, 1, as.vector=TRUE )
pos.one
@

And as we are on the reverse strand, all these locations should match the end of the transcripts:

<<eval=TRUE,echo=TRUE>>=
pos.one == end( transcripts )
@

We can also pass \code{cds=TRUE} to this method to take the UTRs into account when calculating genomic location:

<<eval=TRUE,echo=TRUE>>=
pos.one = transcriptCoordsToGenome( transcripts, 1, as.vector=TRUE, cds=TRUE )
pos.one
@

\subsection{Plotting data with \lstinline{genomicPlot}}

\lstinline{genomicPlot} will plot the genes and exons found at a given locus.

For example, to plot the genomic region around the gene \code{MPI} (Figure \ref{tp53onestrand}):

<<eval=FALSE,echo=TRUE>>=
range = symbolToGene( 'MPI' )
ranges( range ) = ranges( range ) + 5000
genomicPlot( range )
@

\begin{figure}[ht]
\begin{minipage}[b]{0.5\linewidth}
\centering
\includegraphics[scale=1]{fig7}
\caption{A genomic plot 5000bp either side of MPI.}
\label{tp53onestrand}
\end{minipage}
\hspace{0.5cm}
\begin{minipage}[b]{0.5\linewidth}
\centering
\includegraphics[scale=1]{fig8}
\caption{A genomic plot 5000bp either side of MPI with the opposite strand drawn 'washed out'.}
\label{tp53bothstrand}
\end{minipage}
\end{figure}

<<label=fig7,fig=FALSE,results=tex,echo=FALSE>>=
wid = 3.6
hei = 2
pdf("fig7.pdf", width = wid, height = hei)
range = symbolToGene( 'MPI' )
ranges( range ) = ranges( range ) + 5000
genomicPlot( range )
dummy = dev.off()
@

We can also show the opposite strand, in one of two ways.  First, passing \lstinline{draw.opposite.strand=TRUE}, results in a \emph{'washed out'} view of the opposite strand (Figure \ref{tp53bothstrand}).

<<eval=FALSE,echo=TRUE>>=
genomicPlot( range, draw.opposite.strand=TRUE )
@
<<label=fig8,fig=FALSE,results=tex,echo=FALSE>>=
wid = 3.6
hei = 3.6
pdf("fig8.pdf", width = wid, height = hei)
genomicPlot( range, draw.opposite.strand=TRUE )
dummy = dev.off()
@

Alternatively setting the \lstinline{strand} column from the range parameter we are passing in (Figure \ref{tp53nostrand}) to \code{'*'} results in both strands being shown.

<<eval=FALSE,echo=TRUE>>=
strand( range ) = '*'
genomicPlot( range )
@

\begin{figure}[ht]
\begin{minipage}[b]{0.5\linewidth}
\centering
\includegraphics[scale=1]{fig9}
\caption{Both strands 5000bp either side of MPI.}
\label{tp53nostrand}
\end{minipage}
\hspace{0.5cm}
\begin{minipage}[b]{0.5\linewidth}
\centering
\includegraphics[scale=1]{fig10}
\caption{Both strands 5000bp either side of MPI with highlights.}
\label{tp53highlights}
\end{minipage}
\end{figure}

<<label=fig9,fig=FALSE,results=tex,echo=FALSE>>=
wid = 3.6
hei = 3.6
pdf("fig9.pdf", width = wid, height = hei)
strand( range ) = '*'
genomicPlot( range )
dummy = dev.off()
@

It is also possible to highlight regions of the genome with your own annotation.  To do this, you simply need to pass in a \lstinline{data.frame} containing columns \code{start}, \code{end}, \code{strand} and \code{name}.

For example, we could add regions to the start and end locations of \code{MPI} but on the opposite strand and call them \code{annmap1} and \code{annmap2} (Figure \ref{tp53highlights});

<<eval=TRUE,echo=TRUE>>=
a1          = symbolToGene( 'MPI' )
end( a1 )   = start( a1 ) + 1000
a2          = symbolToGene( 'MPI' )
start( a2 ) = end( a2 ) - 1000
hig         = data.frame( start =c( as.integer( start( a1 ) ), as.integer( start( a2 ) ) ),
                          end   =c( as.integer(   end( a1 ) ), as.integer(   end( a2 ) ) ),
                          strand=c(   strandAsInteger( a1 ),     strandAsInteger( a2 )   ) * -1,
                          name  =c(   'annmap1',   'annmap2' ) )
@
<<eval=FALSE,echo=TRUE>>=
genomicPlot( range, highlights=hig )
@
<<label=fig10,fig=FALSE,results=tex,echo=FALSE>>=
wid = 3.6
hei = 3.6
pdf("fig10.pdf", width = wid, height = hei)
genomicPlot( range, highlights=hig )
dummy = dev.off()
@

\subsection{Plotting NGS data with \lstinline{ngsBridgePlot}}

The \lstinline{ngsBridgePlot} method allows NGS read data to be plotted
alongside a \lstinline{genomicPlot}.  This was how Figure \ref{bridgeintro} was
generated.  There are many options for this plot function; here we will cover
the most important ones.

\begin{figure}[ht]
\begin{minipage}[b]{0.5\linewidth}
\centering
\includegraphics[scale=1]{bridge2}
\caption{Dummy (in this example) NGS data shown alongside SHH.}
\label{fig:bridge2}
\end{minipage}
\hspace{0.5cm}
\begin{minipage}[b]{0.5\linewidth}
\centering
\includegraphics[scale=1]{bridge3}
\caption{Dummy (in this example) NGS data shown alongside SHH with probes shown.}
\label{fig:bridge3}
\end{minipage}
\end{figure}

\begin{figure}[ht]
\begin{minipage}[b]{0.5\linewidth}
\centering
\includegraphics[scale=1]{bridge4}
\caption{Dummy (in this example) NGS data shown alongside SHH (both strands) with probes shown.}
\label{fig:bridge4}
\end{minipage}
\hspace{0.5cm}
\begin{minipage}[b]{0.5\linewidth}
\centering
\includegraphics[scale=1]{bridge5}
\caption{Dummy (in this example) NGS data shown alongside SHH. Both strands of NGS reads are shown. Exon depth plot hidden.}
\label{fig:bridge5}
\end{minipage}
\end{figure}

To plot Bamfile data alongside a region (and strand) denoted by a given gene,
you can do (Figure \ref{fig:bridge2}):

<<eval=FALSE,echo=TRUE>>=
gene = symbolToGene( 'SHH' )
ngsBridgePlot( gene, bamfileData )
@
<<label=bridge2,fig=FALSE,results=tex,echo=FALSE>>=
wid = 3.6
hei = 4
png("bridge2.png", res=200, units='in', width = wid, height = hei)
gene = symbolToGene( 'SHH' )
ngsBridgePlot( gene, bamfileData )
dummy = dev.off()
@

If you want to show where the probes for a given array hit this region, you can set the \code{probe.plot} parameter to the \lstinline{genomicProbePlot} function (Figure \ref{fig:bridge3})

<<eval=FALSE,echo=TRUE>>=
gene = symbolToGene( 'SHH' )
ngsBridgePlot( gene, bamfileData, probe.plot=genomicProbePlot )
@
<<label=bridge3,fig=FALSE,results=tex,echo=FALSE>>=
wid = 3.6
hei = 4
png("bridge3.png", res=200, units='in', width = wid, height = hei)
gene = symbolToGene( 'SHH' )
ngsBridgePlot( gene, bamfileData, probe.plot=genomicProbePlot )
dummy = dev.off()
@

And as we saw in the preamble to this document, we can set the strand of the given range to \code{'*'} and both strands of the region will be shown (Figure \ref{fig:bridge4}).

<<eval=FALSE,echo=TRUE>>=
gene = symbolToGene( 'SHH' )
strand( gene ) = '*'
ngsBridgePlot( gene, bamfileData )
@
<<label=bridge4,fig=FALSE,results=tex,echo=FALSE>>=
wid = 3.6
hei = 4
png("bridge4.png", res=200, units='in', width = wid, height = hei)
gene = symbolToGene( 'SHH' )
strand( gene ) = '*'
ngsBridgePlot( gene, bamfileData )
dummy = dev.off()
@

Or, we can plot the genomicPlot for a single strand, but show the NGS data for both strands side-by-side using the \lstinline{trace.match.strand} parameter and, for clarity, turn off the \lstinline{exon.depth.plot} (Figure \ref{fig:bridge5}).

<<eval=FALSE,echo=TRUE>>=
gene = symbolToGene( 'SHH' )
# trace.match.strand=FALSE would have the same effect
ngsBridgePlot( gene, bamfileData, exon.depth.plot=NULL, trace.match.strand='*' )
@
<<label=bridge5,fig=FALSE,results=tex,echo=FALSE>>=
wid = 3.6
hei = 4
png("bridge5.png", res=200, units='in', width = wid, height = hei)
gene = symbolToGene( 'SHH' )
ngsBridgePlot( gene, bamfileData, exon.depth.plot=NULL, trace.match.strand='*' )
dummy = dev.off()
@

In all these examples, the bamfileData is a synthetic object we have created for the purposes of this vignette.  Its structure is:

<<eval=TRUE,echo=TRUE>>=
str( bamfileData )
@

As you can see, it is a list containing a list for each track.  Each of these track lists contain the \code{name} of the track, \code{col} (its colour), and an \code{rle} element which contains a list of \code{Rle} elements (one for \code{'+'}, the forward strand and one for the reverse; \code{'-'})

To generate this object from actual BAM file data there is a helper function \lstinline{generateBridgeData}.  Given 3 BAM files you wish to display on the plot -- \code{data1.bam}, \code{data2.bam} and \code{data3.bam}:

<<eval=FALSE,echo=TRUE>>=
bamfiles = c( 'data1.bam', 'data2.bam', 'data3.bam' )
data = generateBridgeData( symbolToGene( 'SHH' ), bamfiles )
@

Will generate the required format with sensible defaults for \code{name} and \code{col}.  These defaults can be overridden by setting the \code{names} and \code{colours} parameters on the \lstinline{generateBridgeData} function.

\subsection{Gviz integration}

It is also possible to convert a list of genes to a list of \code{GeneRegionTrack} for rendering in Gviz (Figure \ref{fig:gviz1}).

<<eval=FALSE,echo=TRUE>>=
library( Gviz )

gene   = symbolToGene( 'SHH' )
genome = 'hg19'

gtrack = GenomeAxisTrack()
atrack = geneToGeneRegionTrack( gene, genome, showId=TRUE )

plotTracks( c( gtrack, atrack ), extend.left=1000, extend.right=1000 )
@
<<label=gviz1,fig=FALSE,results=tex,echo=FALSE>>=
library( Gviz )
wid = 4
hei = 2
png("gviz1.png", res=200, units='in', width = wid, height = hei)
gene   = symbolToGene( 'SHH' )
genome = 'hg19'
gtrack = GenomeAxisTrack()
displayPars( gtrack ) = list( cex=0.5 )
atrack = geneToGeneRegionTrack( gene, genome, showId=TRUE )
plotTracks( c( gtrack, atrack ), extend.left=1000, extend.right=1000 )
dummy = dev.off()
@

\begin{figure}[h]
\centering
\includegraphics[scale=1]{gviz1}
\caption{Gviz plot of the gene SSH.}
\label{fig:gviz1}
\end{figure}

\end{document}

\name{ngsPlot}
\alias{convertBamToRle}
\alias{generateBridgeData}
\alias{ngsTraceScale}
\alias{ngsTraceLabel}
\alias{ngsTracePlotter}
\alias{ngsBridgePlot}
\title{
  Plotting BAM file data alongside the features of a chromosome
}
\description{
  These functions aid plotting a-la xmapbridge but in a format that is more publication friendly
}
\usage{
  # Utility Methods
  convertBamToRle( bam.file.name, chr, start, end, chr.name.mapping=function( name ){ name } )
  generateBridgeData( xrange, bamFiles, colours=NULL, names=NULL )
  ngsTraceScale( vector.of.xbams.and.ybams )
  ngsTraceLabel( rle.data )
  ngsTracePlotter( rle.data, start, end, ylim, trace.label.properties=list(), smoothing.function=function( rle, ... ) { IRanges::runmean( rle, k=1001, endrule='constant' ) },
                     trace.clip='inherit', trace.draw.scale=FALSE, trace.bor='transparent', trace.pad=c(0,0), ... )

  # Plotting Methods
  ngsBridgePlot( xrange, data=list(), main=NULL, sub=NULL, highlights=NULL, trace.plotter=ngsTracePlotter, genome.layout.weight=4,
               trace.scale=ngsTraceScale, trace.draw.scale=NULL, trace.match.strand=TRUE, probe.plot=NULL, exon.depth.plot=genomicExonDepthPlot,
               .genes=NULL, .exons=NULL, ... )
}
\arguments{
  \item{bam.file.name}{ The name of the BAM file to read in }
  \item{chr}{ The chromosome of interest. }
  \item{start}{ The start of the region of interest  }
  \item{end}{ The end of the region of interest }
  \item{chr.name.mapping}{ The function to convert between the Annmap chr name to the chr name in the BAM file.  By default, this just uses chr supplied as the parameter, however it can be set to any function you like.  One example of this is \code{generalisedNameToNCBI} }
  \item{xrange}{ The genomic range for the x-axis. Should be a GRanges object. }
  \item{bamFiles}{ A vector containing the filenames of your BAM files. }
  \item{colours}{ A vector of colours for each file (sensible defaults will be chosen if NULL). }
  \item{names}{ A vector of names to show on the traces drawn by \code{ngsTracePlotter} }
  \item{vector.of.xbams.and.ybams}{ The \code{trace.scale} function is passes a vector of the elements of \code{xbams} and \code{ybams} concatenated together. }
  \item{rle.data}{ A list containing fields \code{rle} (the \code{\link[IRanges]{Rle}} data to be plotted), \code{name} (the name of the Trace) and \code{col} (the colour for the trace). }
  \item{ylim}{ A vector of min and max values for this plot (usually retrieved from \code{ngs.trace.scale}) }
  \item{trace.label.properties}{ Properties to be sent to the \code{\link{grid.text}} call for plotting the label on the trace.  To hide the label, this should be \code{NA}. }
  \item{smoothing.function}{ A function that generates a smoothed RLE object. }
  \item{trace.clip}{ Is the trace clipped to it's bounding box?  One of \code{'inherit'}, \code{'on'} or \code{'off'}.  See \code{\link{viewport}}. }
  \item{trace.draw.scale}{ If \code{TRUE}, \code{x} and \code{y} scales are drawn with \code{main=TRUE} (see \code{\link{grid.xaxis}} and \code{\link{grid.yaxis}}), if \code{FALSE}, then neither axis is drawn.  You can control individual axis drawing by passing a vector such as \code{trace.draw.scale='x'} to just draw the \code{x} axis.  You can also pass a list such as \code{trace.draw.scale=list(x=TRUE,y=FALSE)}, and this will draw both the \code{x} and \code{y} axis, but pass \code{main=TRUE} to the \code{grid.xaxis} call, and \code{main=FALSE} to \code{grid.yaxis} }
  \item{trace.bor}{ The colour for a box that is drawn round this trace.plot. }
  \item{trace.pad}{ A 2 element vector consisting of the number of 'lines' of padding to allow at the top and bottom of the plot respecively }
  \item{data}{ A list containing an element per trace.  Each element of this list is, in turn, passed to the \code{trace.plotter} and \code{trace.scale} functions where the plotting happens -- see \code{details}. ) }
  \item{main}{ The main title for the plot. }
  \item{sub}{ A sub-title for the plot. }
  \item{highlights}{ Highlight regions for the plot.  See \code{genomicPlot}. }
  \item{trace.plotter}{ The function to call to draw the traces (see \code{ngsTracePlotter}) }
  \item{genome.layout.weight}{ The weight for the genomic plot in the layout of this grid }
  \item{trace.scale}{ Either a function to calculate the global max for the NGS traces (see \code{ngsTraceScale}) OR a 2 element vector cntaining the min and max extent of the trace. }
  \item{trace.match.strand}{ If \code{TRUE}, we will only draw the rle data from the strand defined in xrange.  If false, we will draw all of the rle data. Can also be set to \code{'+'} or \code{'-'} to only draw the trace from the given strand (ignoring the strand of xrange). }
  \item{probe.plot}{ The function to plot the probes (see \code{\link{genomicProbePlot}}), \code{NULL} if not drawn. }
  \item{exon.depth.plot}{ The function to draw the exon depth (see \code{\link{genomicExonDepthPlot}}), \code{NULL} if not drawn. }
  \item{.genes}{ Optionally pass a list of genes to limit the plot to. }
  \item{.exons}{ An optional list of exons to limit the plot to. }
  \item{...}{ Parameters passed on to functions called by this function }
}
\details{
  \code{convertBamToRle} will take a BAM file name, and a region of interest and return a \code{list()} containing two elements, \code{'+'} and \code{'-'}. Each element will be an \code{\link[IRanges]{Rle}} object, one for each strand.

  The \code{data} parameter to \code{ngsBridgePlot} is a list of elements as defined in the \code{rle.data} parameter, one element per NGS trace, ie:

  \preformatted{
    library(grid)
    library(annmap)

    # Connect to datasource with annmapConnect()

    # Ensure we have a clean plot
    grid.newpage()

    bamFiles = c( 'data1.bam', 'data2.bam', 'data3.bam' )
    colours  = rainbow( 3, v=0.5, s=0.5 )
    data = lapply( seq_along( bamFiles ), function( idx ) {
      list( rle=convertBamToRle( bamFiles[ idx ], 'I', 40000, 100000 ),
            col=colours[ idx ],
            name=paste( 'Trace', bamFiles[ idx ] ) )
    } )
    ngsBridgePlot( RangedData( space='I', ranges=IRanges( 40000, 100000 ) ), data=data, main='Example Plot' )
  }
}
\seealso{
  \code{\link{genomicProbePlot}}, \code{\link{genomicPlot}}, \code{\link{genomicExonDepthPlot}}
}
\author{
  Tim Yates
}

\name{annmapAll}
\alias{annmapAll}
\alias{allArrays}
\alias{allChromosomes}
\alias{allDomains}
\alias{allEstExons}
\alias{allEstGenes}
\alias{allEstTranscripts}
\alias{allExons}
\alias{allGenes}
\alias{allPredictionTranscripts}
\alias{allProbes}
\alias{allProbesets}
\alias{allProteins}
\alias{allSymbols}
\alias{allSynonyms}
\alias{allTranscripts}
\title{
  annmap 'all' functions
}
\description{
  Get all annotations for a given feature. For example, \code{allGenes} will return data for all the genes in the genome.
}
\usage{
  allArrays( as.vector=FALSE )
  allChromosomes( as.vector=FALSE )
  allDomains( as.vector=FALSE )
  allEstExons( as.vector=FALSE )
  allEstGenes( as.vector=FALSE )
  allEstTranscripts( as.vector=FALSE )
  allExons( as.vector=FALSE )
  allGenes( as.vector=FALSE )
  allPredictionTranscripts( as.vector=FALSE )
  allProbes( as.vector=FALSE )
  allProbesets( as.vector=FALSE )
  allProteins( as.vector=FALSE )
  allSymbols( as.vector=FALSE )
  allSynonyms( as.vector=FALSE )
  allTranscripts( as.vector=FALSE )
}
\arguments{
  \item{as.vector}{ If \code{TRUE} returns a vector of database identifiers. If \code{FALSE} returns a \code{\link{GRanges}} object containing detailed annotation. }
}
\value{
  Returns a \code{vector} or \code{\link{GRanges}} object, as defined by \code{as.vector}.
}
\seealso{
  \code{\link{annmapTo}}\cr
  \code{\link{annmapDetails}}\cr
  \code{\link{annmapRange}}\cr
  \code{\link{annmapUtils}}\cr
  \code{\link{annmapFilters}}\cr
  \code{\link{GRanges}}
}
\author{
  Tim Yates
}
\examples{
  if(interactive()) {
    annmapConnect()	
    allChromosomes()
    allChromosomes(as.vector=TRUE)
  }
}

\name{annmapFilters}
\alias{annmapFilters}
\alias{exonic}
\alias{hasProbes}
\alias{hasProbesAtleast}
\alias{hasProbesIn}
\alias{hasProbesBetween}
\alias{intergenic}
\alias{intronic}
\alias{isExonic}
\alias{isIntergenic}
\alias{isIntronic}
\alias{isUnreliable}
\alias{unreliable}

\title{
  annmap 'filter' functions
}
\description{
  Functions to filter exon array probeset names by the genome features they correspond to.
}
\usage{
  exonic( probesets, exclude=FALSE )
  hasProbes( probesets, num.probes=4, exclude=FALSE )
  hasProbesAtleast( probesets, num.probes=4, exclude=FALSE )
  hasProbesIn( probesets, num.probes=c( 1, 2, 3, 4 ), exclude=FALSE )
  hasProbesBetween( probesets, min.probes=1, max.probes=4, exclude=FALSE, inclusive=TRUE )
  intergenic( probesets, exclude=FALSE )
  intronic( probesets, exclude=FALSE )
  isExonic( probesets )
  isIntergenic( probesets )
  isIntronic( probesets )
  isUnreliable( probesets )
  unreliable( probesets, exclude=FALSE )
}
\arguments{
  \item{probesets}{ A \code{vector} of probesets to filter }
  \item{num.probes}{ The required number of probes to have in the probeset }
  \item{exclude}{ If \code{FALSE}, then return a list containing only those probesets matching the filter. If \code{TRUE} then return only those that don\'t match the filter  }
  \item{min.probes}{ Minimum number of probes within a probeset}
  \item{max.probes}{ Maximum number of probes within a probeset}
  \item{inclusive}{ Whether to include the extremes of the range in the search or not}
}
\details{
 Probesets are classified according to whether they map to known genes. The function \code{exonic} filters for probesets for which all probes match once (and only once) to the genome, and every probe hits an exon. Note that this means that a probeset that hits more than one exon, will be flagged as exonic. All probes in \code{intronic} probesets hit the genome once (and once only), and all probes hit a gene - however one or more probes hit an intron. \code{intergenic} probesets hit the genome once (and once only) but one or more probes miss a gene compeletely. \code{unreliable} probesets comprise those that have at least one probe that does not align to the genome, or one or more probes that align at multiple loci (multiply targeted). 

The functions \code{is.exonic}, \code{is.intronic} and \code{is.intergenic}, return a logical vector classifying the supplied probesets. 

The functions \code{has.probes}, \code{has.probes.in} and \code{has.probes.between} can be used to filter a set of probesets according to the numbers of probes they contain.
}
\seealso{
  \code{\link{annmapTo}}\cr
  \code{\link{annmapDetails}}\cr
  \code{\link{annmapAll}}\cr
  \code{\link{annmapRange}}\cr
  \code{\link{annmapFilters}}\cr
}
\author{
  Tim Yates
  Crispin J. Miller
}
\examples{
  if(interactive()){
    annmapConnect()
    ps <- geneToProbeset(symbolToGene("TP53"))
    exonic(ps)
    intronic(ps)
    intergenic(ps)
    unreliable(ps)
    isExonic(ps)
    isIntronic(ps)
    isIntergenic(ps)
    isUnreliable(ps)
    hasProbes(ps)
    hasProbesIn(ps,1:3)
    hasProbesBetween(ps,2,3)
    hasProbesAtleast(ps,4)
  }
}

\name{annmapSeqname}
\alias{annmapSeqname}
\alias{generalisedNameToNCBI}
\alias{generalisedNameToEnsembl}
\alias{seqnameMapping}
\alias{seqnamesToNCBI}
\alias{seqnamesToEnsembl}
\title{
  Seqnames manipulation functions
}
\description{
  These functions allow easier manipulation of the seqnames column of a GRanges object
}
\usage{
  generalisedNameToNCBI( name, ... )
  generalisedNameToEnsembl( name, ... )
  seqnameMapping( x, mappingFunction, ... )
  seqnamesToNCBI( x )
  seqnamesToEnsembl( x )
}
\arguments{
  \item{name}{ The name to convert. }
  \item{x}{ A GRanges object to convert the seqnames of. }
  \item{mappingFunction}{ The function to do the mapping of names. }
  \item{...}{ Other arguments you may wish to send to a custom mapping function. }
}
\details{
  These functions allow simple mapping between seqnames of a GRanges object.

  The two standard derivations are \code{seqnamesToNCBI} and \code{seqnamesToEnsembl}.  The rules for mapping are:

  \preformatted{
      Ensembl      NCBI
      1       <=>  chr1
      ...
      22      <=>  chr22
      X       <=>  chrX
      Y       <=>  chrY
      MT      <=>  chrM
  }

  You can define your own mapping function and pass it as the \code{mappingFunction} parameter to
  \code{seqnameMapping} function to do your own custom mapping.

  The function \code{seqnamesToNCBI} calls \code{seqnameMapping} with \code{generalisedNameToNCBI} as the
  \code{mappingFunction}.  The function \code{seqnamesToEnsembl} uses \code{generalisedNameToEnsembl}.
}
\author{
  Tim Yates
}
\examples{
  if(interactive()) {
    annmapConnect()
    seqnamesToNCBI( symbolToGene( c( 'tp53', 'shh' ) ) )
 }
}

\name{genomicPlotting}
\alias{genomicPlot}
\alias{genomicExonDepthPlot}
\alias{genomicProbePlot}
\title{
  Plotting a section of a chromosome.
}
\description{
  These functions are used when we need to plot one or both strands of a section of chromosome.
}
\usage{
  genomicPlot( xrange, gene.area.height=NULL, gene.layout.padding=100, highlights=NULL, draw.opposite.strand=FALSE, exon.depth.plot=genomicExonDepthPlot,
                padding.lines=1, .genes=NULL, .exons=NULL, invert.strands=FALSE, draw.scale=TRUE, ... )
  genomicExonDepthPlot( .exons, start, end, exon.depth.alpha=0.1, exon.depth.col='black', ... )
  genomicProbePlot( probes, start, end, probe.col='green', probe.alpha=0.3, ... )
}
\arguments{
  \item{xrange}{ An IRanges object representing the region of interest (with a strand if reqd) }
  \item{gene.area.height}{ If \code{NULL} then both strands to max height of either of them, else if \code{NA} then both strands limited to their implied height otherwise, if an \code{integer} then both strands limited to the specified height }
  \item{gene.layout.padding}{ How much space (in bases) needs to be between each gene in a layer.  Needed to stop gene names overlapping }
  \item{highlights}{ You can pass this a \code{data.frame} of values to render as dummy genes in the view. Columns MUST include \code{start}, \code{end}, \code{strand} and \code{name}. It may also optionally include the columns \code{col} to specify a per-gene background colour, or \code{bor} to specify the colour to be used for the gene border and the label text. If these two are not passed, sensible defaults are chosen automatically. }
  \item{draw.opposite.strand}{ Do we draw a washed out representation of the other strand. Only applies if \code{strand( xrange ) != '*'} }
  \item{exon.depth.plot}{ Should we draw the exondepth? set to \code{NULL} if not }
  \item{padding.lines}{ How much padding above and below the plot (in grid lines) }
  \item{.genes}{ Optionally pass in the pre-loaded genes and exons (then we skip loading them in this function) }
  \item{.exons}{ The exons that are to be used }
  \item{invert.strands}{ Should the forward strand be on the bottom of the plot? }
  \item{draw.scale}{ Draw a scale between the two strands? }
  \item{...}{ Parameters passed on to functions called by this function }
  \item{exon.depth.alpha}{ The transparency for the exon.depth rectangles }
  \item{exon.depth.col}{ The color for the exon.depth rectangles }
  \item{start}{ The start of the region of interest  }
  \item{end}{ The end of the region of interest }
  \item{probe.alpha}{ How transparent should probes be rendered? }
  \item{probe.col}{ The colour to use for probes. }
  \item{probes}{ The probes for the region of interest (as a \code{data.frame}). }
}
\author{
  Tim Yates
}

\name{annmapTo}
\alias{annmapTo}
\alias{arrayToProbeset}
\alias{domainToGene}
\alias{domainToProbeset}
\alias{domainToProtein}
\alias{domainToTranscript}
\alias{estExonToEstGene}
\alias{estExonToEstTranscript}
\alias{estExonToProbeset}
\alias{estGeneToEstExon}
\alias{estGeneToEstTranscript}
\alias{estGeneToProbeset}
\alias{estTranscriptToEstExon}
\alias{estTranscriptToEstGene}
\alias{estTranscriptToProbeset}
\alias{exonToGene}
\alias{exonToProbeset}
\alias{exonToTranscript}
\alias{geneToDomain}
\alias{geneToExon}
\alias{geneToExonProbeset}
\alias{geneToExonProbesetExpr}
\alias{geneToProbeset}
\alias{geneToProtein}
\alias{geneToSymbol}
\alias{geneToSynonym}
\alias{geneToTranscript}
\alias{predictionTranscriptToPredictionExon}
\alias{predictionTranscriptToProbeset}
\alias{probeToHit}
\alias{probeToProbeset}
\alias{probesetToCdnatranscript}
\alias{probesetToDomain}
\alias{probesetToEstExon}
\alias{probesetToEstGene}
\alias{probesetToEstTranscript}
\alias{probesetToExon}
\alias{probesetToGene}
\alias{probesetToHit}
\alias{probesetToPredictionTranscript}
\alias{probesetToProbe}
\alias{probesetToProtein}
\alias{probesetToTranscript}
\alias{proteinToDomain}
\alias{proteinToGene}
\alias{proteinToProbeset}
\alias{proteinToTranscript}
\alias{symbolToEstGene}
\alias{symbolToEstTranscript}
\alias{symbolToGene}
\alias{symbolToTranscript}
\alias{synonymToEstGene}
\alias{synonymToEstTranscript}
\alias{synonymToGene}
\alias{synonymToTranscript}
\alias{transcriptToCdnaprobeset}
\alias{transcriptToDomain}
\alias{transcriptToExon}
\alias{transcriptToExonProbeset}
\alias{transcriptToGene}
\alias{transcriptToProbeset}
\alias{transcriptToProtein}
\alias{transcriptToSynonym}
\alias{transcriptToTranslatedprobes}
\title{
  annmap 'to' functions
}
\description{
  Map between the different levels of annotation in Annmap. For example, given a vector of gene identifiers, \code{geneToExon} 
  will return the exons in those genes.
}
\usage{
  arrayToProbeset( ids, as.vector=FALSE )
  domainToGene( ids, as.vector=FALSE )
  domainToProbeset( ids, as.vector=FALSE )
  domainToProtein( ids, as.vector=FALSE )
  domainToTranscript( ids, as.vector=FALSE )
  estExonToEstGene( ids, as.vector=FALSE )
  estExonToEstTranscript( ids, as.vector=FALSE )
  estExonToProbeset( ids, as.vector=FALSE )
  estGeneToEstExon( ids, as.vector=FALSE )
  estGeneToEstTranscript( ids, as.vector=FALSE )
  estGeneToProbeset( ids, as.vector=FALSE )
  estTranscriptToEstExon( ids, as.vector=FALSE )
  estTranscriptToEstGene( ids, as.vector=FALSE )
  estTranscriptToProbeset( ids, as.vector=FALSE )
  exonToGene( ids, as.vector=FALSE )
  exonToProbeset( ids, as.vector=FALSE )
  exonToTranscript( ids, as.vector=FALSE )
  geneToDomain( ids, as.vector=FALSE )
  geneToExon( ids, as.vector=FALSE )
  geneToExonProbeset( ids, as.vector=FALSE, probes.min=4 )
  geneToExonProbesetExpr( x, ids, probes.min=4 )
  geneToProbeset( ids, as.vector=FALSE )
  geneToProtein( ids, as.vector=FALSE )
  geneToSymbol( ids )
  geneToSynonym( ids, as.vector=FALSE )
  geneToTranscript( ids, as.vector=FALSE )
  predictionTranscriptToPredictionExon( ids )
  predictionTranscriptToProbeset( ids, as.vector=FALSE )
  probeToHit( ids, as.data.frame=FALSE )
  probeToProbeset( ids, as.vector=FALSE )
  probesetToCdnatranscript( ids, as.vector=FALSE, rm.unreliable=TRUE )
  probesetToDomain( ids, as.vector=FALSE, rm.unreliable=TRUE )
  probesetToEstExon( ids, as.vector=FALSE, rm.unreliable=TRUE )
  probesetToEstGene( ids, as.vector=FALSE, rm.unreliable=TRUE )
  probesetToEstTranscript( ids, as.vector=FALSE, rm.unreliable=TRUE )
  probesetToExon( ids, as.vector=FALSE, rm.unreliable=TRUE )
  probesetToGene( ids, as.vector=FALSE, rm.unreliable=TRUE )
  probesetToHit( ids, as.data.frame=FALSE, rm.unreliable=TRUE )
  probesetToPredictionTranscript( ids, as.vector=FALSE, rm.unreliable=TRUE )
  probesetToProbe( ids, as.vector=FALSE )
  probesetToProtein( ids, as.vector=FALSE, rm.unreliable=TRUE )
  probesetToTranscript( ids, as.vector=FALSE, rm.unreliable=TRUE )
  proteinToDomain( ids, as.vector=FALSE )
  proteinToGene( ids, as.vector=FALSE )
  proteinToProbeset( ids, as.vector=FALSE )
  proteinToTranscript( ids, as.vector=FALSE )
  symbolToEstGene( ids, as.vector=FALSE )
  symbolToEstTranscript( ids, as.vector=FALSE )
  symbolToGene( ids, as.vector=FALSE )
  symbolToTranscript( ids, as.vector=FALSE )
  synonymToEstGene( ids, as.vector=FALSE )
  synonymToEstTranscript( ids, as.vector=FALSE )
  synonymToGene( ids, as.vector=FALSE )
  synonymToTranscript( ids, as.vector=FALSE )
  transcriptToCdnaprobeset( ids, as.vector=FALSE )
  transcriptToDomain( ids, as.vector=FALSE )
  transcriptToExon( ids, as.vector=FALSE )
  transcriptToExonProbeset( ids, as.vector=FALSE, probes.min=4 )
  transcriptToGene( ids, as.vector=FALSE )
  transcriptToProbeset( ids, as.vector=FALSE )
  transcriptToProtein( ids, as.vector=FALSE )
  transcriptToSynonym( ids, as.vector=FALSE )
  transcriptToTranslatedprobes( ids )
}
\arguments{
  \item{as.vector}{ If \code{TRUE} returns a vector of database identifiers. If \code{FALSE}
                    returns a \code{link{RangedData}} object containing detailed annotation. }
  \item{as.data.frame}{ Where a vector is inappropriate for the data type, the option to return the data as a plain \code{data.frame} in place of a \code{GRanges} object is given. }
  \item{ids}{ Database identifiers to map from. Can be either a vector of database
              identifiers, or a \code{\link{GRanges}} object.}
  \item{probes.min}{ How many probes need to match before the probeset is returned. }
  \item{rm.unreliable}{ If \code{TRUE}, the input probeset list is filtered, and all
                        unreliable probesets are removed. }
  \item{x}{ An \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}} object or a
            \code{matrix} containing expression data. If the latter, then the rownames
            must specify the exon array probeset names. } 
}
\details{
  In most cases, these functions should be self-explantory. However, by default, the mappings involving probes and probesets 
  do some filtering of the data. This means that probesets which have one or more probes that don't match to the genome, or which 
  match to multiple loci, are removed (see \code{\link{unreliable}} for more details).

  The function \code{transcriptToTranslatedprobes} returns a list of \code{GRanges} objects (one for each transcript) containing each probe that hits that translated transcripts and the relative start and end locations.
}
\value{
  Results in an \code{\link{GRanges}} object, one row per feature, containing detailed annotations, or a \code{vector}, as defined by \code{as.vector}.

}
\seealso{
  \code{\link{annmapDetails}}\cr
  \code{\link{annmapAll}}\cr
  \code{\link{annmapRange}}\cr
  \code{\link{annmapUtils}}\cr
  \code{\link{annmapFilters}}\cr
  \code{link{GRanges}}
}
\author{
  Tim Yates
}
\examples{
  if(interactive()) {
    annmapConnect()
    geneToExon(symbolToGene("TP53"))
  } 
}

\name{annmapRange}
\alias{annmapRange}

\alias{domainInRange}
\alias{domainInRange,RangedData-method}
\alias{domainInRange,GRanges-method}
\alias{domainInRange,character-method}
\alias{domainInRange,data.frame-method}
\alias{domainInRange,NULL-method}
\alias{domainInRange,factor-method}

\alias{estExonInRange}
\alias{estExonInRange,RangedData-method}
\alias{estExonInRange,GRanges-method}
\alias{estExonInRange,character-method}
\alias{estExonInRange,data.frame-method}
\alias{estExonInRange,NULL-method}
\alias{estExonInRange,factor-method}

\alias{estGeneInRange}
\alias{estGeneInRange,RangedData-method}
\alias{estGeneInRange,GRanges-method}
\alias{estGeneInRange,character-method}
\alias{estGeneInRange,data.frame-method}
\alias{estGeneInRange,NULL-method}
\alias{estGeneInRange,factor-method}

\alias{estTranscriptInRange}
\alias{estTranscriptInRange,RangedData-method}
\alias{estTranscriptInRange,GRanges-method}
\alias{estTranscriptInRange,character-method}
\alias{estTranscriptInRange,data.frame-method}
\alias{estTranscriptInRange,NULL-method}
\alias{estTranscriptInRange,factor-method}

\alias{exonInRange}
\alias{exonInRange,RangedData-method}
\alias{exonInRange,GRanges-method}
\alias{exonInRange,character-method}
\alias{exonInRange,data.frame-method}
\alias{exonInRange,NULL-method}
\alias{exonInRange,factor-method}

\alias{geneInRange}
\alias{geneInRange,RangedData-method}
\alias{geneInRange,GRanges-method}
\alias{geneInRange,character-method}
\alias{geneInRange,data.frame-method}
\alias{geneInRange,NULL-method}
\alias{geneInRange,factor-method}

\alias{predictionTranscriptInRange}
\alias{predictionTranscriptInRange,RangedData-method}
\alias{predictionTranscriptInRange,GRanges-method}
\alias{predictionTranscriptInRange,character-method}
\alias{predictionTranscriptInRange,data.frame-method}
\alias{predictionTranscriptInRange,NULL-method}
\alias{predictionTranscriptInRange,factor-method}

\alias{probesetInRange}
\alias{probesetInRange,RangedData-method}
\alias{probesetInRange,GRanges-method}
\alias{probesetInRange,character-method}
\alias{probesetInRange,data.frame-method}
\alias{probesetInRange,NULL-method}
\alias{probesetInRange,factor-method}

\alias{probeInRange}
\alias{probeInRange,RangedData-method}
\alias{probeInRange,GRanges-method}
\alias{probeInRange,character-method}
\alias{probeInRange,data.frame-method}
\alias{probeInRange,NULL-method}
\alias{probeInRange,factor-method}

\alias{proteinInRange}
\alias{proteinInRange,RangedData-method}
\alias{proteinInRange,GRanges-method}
\alias{proteinInRange,character-method}
\alias{proteinInRange,data.frame-method}
\alias{proteinInRange,NULL-method}
\alias{proteinInRange,factor-method}

\alias{transcriptInRange}
\alias{transcriptInRange,RangedData-method}
\alias{transcriptInRange,GRanges-method}
\alias{transcriptInRange,character-method}
\alias{transcriptInRange,data.frame-method}
\alias{transcriptInRange,NULL-method}
\alias{transcriptInRange,factor-method}

\title{
  annmap 'range' functions
}
\description{
  Get the features within the specified genome coordinates.
}
\usage{
  domainInRange( x, ..., as.vector = FALSE )
  \S4method{domainInRange}{GRanges}( x, as.vector=FALSE )
  \S4method{domainInRange}{RangedData}( x, as.vector=FALSE )
  \S4method{domainInRange}{character}( x, start, end, strand, ..., as.vector=FALSE )
  \S4method{domainInRange}{data.frame}( x, as.vector=FALSE )
  \S4method{domainInRange}{NULL}( x, as.vector=FALSE )
  \S4method{domainInRange}{factor}( x, start, end, strand, ..., as.vector=FALSE )

  estExonInRange( x, ..., as.vector = FALSE )
  \S4method{estExonInRange}{GRanges}( x, as.vector=FALSE )
  \S4method{estExonInRange}{RangedData}( x, as.vector=FALSE )
  \S4method{estExonInRange}{character}( x, start, end, strand, ..., as.vector=FALSE )
  \S4method{estExonInRange}{data.frame}( x, as.vector=FALSE )
  \S4method{estExonInRange}{NULL}( x, as.vector=FALSE )
  \S4method{estExonInRange}{factor}( x, start, end, strand, ..., as.vector=FALSE )

  estGeneInRange( x, ..., as.vector = FALSE )
  \S4method{estGeneInRange}{GRanges}( x, as.vector=FALSE )
  \S4method{estGeneInRange}{RangedData}( x, as.vector=FALSE )
  \S4method{estGeneInRange}{character}( x, start, end, strand, ..., as.vector=FALSE )
  \S4method{estGeneInRange}{data.frame}( x, as.vector=FALSE )
  \S4method{estGeneInRange}{NULL}( x, as.vector=FALSE )
  \S4method{estGeneInRange}{factor}( x, start, end, strand, ..., as.vector=FALSE )

  estTranscriptInRange( x, ..., as.vector = FALSE )
  \S4method{estTranscriptInRange}{GRanges}( x, as.vector=FALSE )
  \S4method{estTranscriptInRange}{RangedData}( x, as.vector=FALSE )
  \S4method{estTranscriptInRange}{character}( x, start, end, strand, ..., as.vector=FALSE )
  \S4method{estTranscriptInRange}{data.frame}( x, as.vector=FALSE )
  \S4method{estTranscriptInRange}{NULL}( x, as.vector=FALSE )
  \S4method{estTranscriptInRange}{factor}( x, start, end, strand, ..., as.vector=FALSE )

  exonInRange( x, ..., as.vector = FALSE )
  \S4method{exonInRange}{GRanges}( x, as.vector=FALSE )
  \S4method{exonInRange}{RangedData}( x, as.vector=FALSE )
  \S4method{exonInRange}{character}( x, start, end, strand, ..., as.vector=FALSE )
  \S4method{exonInRange}{data.frame}( x, as.vector=FALSE )
  \S4method{exonInRange}{NULL}( x, as.vector=FALSE )
  \S4method{exonInRange}{factor}( x, start, end, strand, ..., as.vector=FALSE )

  geneInRange( x, ..., as.vector = FALSE )
  \S4method{geneInRange}{GRanges}( x, as.vector=FALSE )
  \S4method{geneInRange}{RangedData}( x, as.vector=FALSE )
  \S4method{geneInRange}{character}( x, start, end, strand, ..., as.vector=FALSE )
  \S4method{geneInRange}{data.frame}( x, as.vector=FALSE )
  \S4method{geneInRange}{NULL}( x, as.vector=FALSE )
  \S4method{geneInRange}{factor}( x, start, end, strand, ..., as.vector=FALSE )

  predictionTranscriptInRange( x, ..., as.vector = FALSE )
  \S4method{predictionTranscriptInRange}{GRanges}( x, as.vector=FALSE )
  \S4method{predictionTranscriptInRange}{RangedData}( x, as.vector=FALSE )
  \S4method{predictionTranscriptInRange}{character}( x, start, end, strand, ..., as.vector=FALSE )
  \S4method{predictionTranscriptInRange}{data.frame}( x, as.vector=FALSE )
  \S4method{predictionTranscriptInRange}{NULL}( x, as.vector=FALSE )
  \S4method{predictionTranscriptInRange}{factor}( x, start, end, strand, ..., as.vector=FALSE )

  probesetInRange( x, ..., as.vector = FALSE )
  \S4method{probesetInRange}{GRanges}( x, as.vector=FALSE )
  \S4method{probesetInRange}{RangedData}( x, as.vector=FALSE )
  \S4method{probesetInRange}{character}( x, start, end, strand, ..., as.vector=FALSE )
  \S4method{probesetInRange}{data.frame}( x, as.vector=FALSE )
  \S4method{probesetInRange}{NULL}( x, as.vector=FALSE )
  \S4method{probesetInRange}{factor}( x, start, end, strand, ..., as.vector=FALSE )

  probeInRange( x, ..., as.vector = FALSE )
  \S4method{probeInRange}{GRanges}( x, as.vector=FALSE )
  \S4method{probeInRange}{RangedData}( x, as.vector=FALSE )
  \S4method{probeInRange}{character}( x, start, end, strand, ..., as.vector=FALSE )
  \S4method{probeInRange}{data.frame}( x, as.vector=FALSE )
  \S4method{probeInRange}{NULL}( x, as.vector=FALSE )
  \S4method{probeInRange}{factor}( x, start, end, strand, ..., as.vector=FALSE )

  proteinInRange( x, ..., as.vector = FALSE )
  \S4method{proteinInRange}{GRanges}( x, as.vector=FALSE )
  \S4method{proteinInRange}{RangedData}( x, as.vector=FALSE )
  \S4method{proteinInRange}{character}( x, start, end, strand, ..., as.vector=FALSE )
  \S4method{proteinInRange}{data.frame}( x, as.vector=FALSE )
  \S4method{proteinInRange}{NULL}( x, as.vector=FALSE )
  \S4method{proteinInRange}{factor}( x, start, end, strand, ..., as.vector=FALSE )

  transcriptInRange( x, ..., as.vector = FALSE )
  \S4method{transcriptInRange}{GRanges}( x, as.vector=FALSE )
  \S4method{transcriptInRange}{RangedData}( x, as.vector=FALSE )
  \S4method{transcriptInRange}{character}( x, start, end, strand, ..., as.vector=FALSE )
  \S4method{transcriptInRange}{data.frame}( x, as.vector=FALSE )
  \S4method{transcriptInRange}{NULL}( x, as.vector=FALSE )
  \S4method{transcriptInRange}{factor}( x, start, end, strand, ..., as.vector=FALSE )
}
\arguments{
  \item{as.vector}{ If \code{TRUE} returns a vector of database identifiers. If \code{FALSE} returns a \code{\link{GRanges}} object containing detailed annotation. }
  \item{x}{ The name of the chromosome of interest -- in the case of the \code{factor} or \code{character} variants), or a \code{GRanges} object  or \code{data.frame} containing location information. In the case of a \code{data.frame}, columns must be named \code{chr} or \code{chromosome_name}, followed by \code{start}, \code{end} and \code{strand}.  RangedData objects must contain a strand in their meta-data. And strand must be \code{1} or \code{-1} in all cases arart from \code{GRanges} where it obviously has to be \code{+} or \code{-}.
  All of the \code{NULL} variants simply return \code{NULL}, in-keeping with the fluent style of the rest of the package. }
  \item{start}{ Start of the region }
  \item{end}{ End of the region }
  \item{strand}{ 1 == top stand, -1 == bottom strand }
  \item{...}{ The ellipsis is to allow this multi-method style of programming. }
}
\details{
  Find all the specified features within a given region of the genome. For all functions except \code{probeInRange}, features that fall on the boundaries of the region (i.e. are partially overlapping) are returned too. For \code{probeInRange} probes that span the start of the range are NOT returned (but those spanning the end of the range are).

  The function \code{annmapRangeApply} makes it possible to map any of these functions down the rows of a \code{\link{RangedData}} or \code{\link{GRanges}} object. The defaults are set up so that it will handle the output of one of the \code{InRange} methods here. This makes it easy to nest functions, for example, to find all genes in a given region of the the genome, and then find the exon array probes that map to those genes (see below). 
}
\value{
 Returns a \code{\link{GRanges}} object, one \'row\' per feature, containing detailed annotations, or a \code{vector} of identifiers, depending on the value of \code{as.vector}.
}
\seealso{
  \code{\link{annmapTo}}\cr
  \code{\link{annmapDetails}}\cr
  \code{\link{annmapAll}}\cr
  \code{\link{annmapUtils}}\cr
  \code{\link{annmapFilters}}\cr
  \code{\link{RangedData}}
  \code{\link{GRanges}}
}
\author{
  Tim Yates
}
\examples{
  if(interactive()) {
    annmapConnect()

    r = geneInRange( '17', 7510000, 7550000, 1 )

    # Can take equal length vectors as parameters
    geneInRange( c( '17', 'X' ), c( 7510000, 1000000 ), c( 7550000, 1500000 ), c( -1, -1 ) )

    # Or a data.frame
    df = data.frame( chr=c( '17', 'X' ), start=c( 7510000, 1000000 ), end=c( 7550000, 1500000 ), strand=c( -1, -1 ) )
    geneInRange( df )

    # Or RangedData objects
    transcriptInRange( geneDetails( symbolToGene( c( 'tp53', 'ssh' ) ) ) )
  }
}

\name{annmap-package}
\alias{annmap-package}
\alias{annmap}
\docType{package}
\title{
  Provide access to the Annmap annotation database
}
\description{
  Annmap \url{http://annmap.cruk.manchester.ac.uk} Is a genome annotation
  database and genome browser, based on the Google Maps API. The
  underlying annotation is derived from ENSEMBL
  (\url{http://www.ensembl.org}). Annmap also provides probe to genome
  mappings for Affymetrix Exon, Gene and Plus2 arrays.

  The annmap package makes the data in annmap available for use within
  R and BioConductor.
}
\details{
  \tabular{ll}{
    Package: \tab annmap\cr
    Type: \tab Package\cr
    Version: \tab 1.0.0\cr
    Date: \tab 2011-09-14\cr
    License: \tab GPL-2\cr
  }
}
\author{
  Tim Yates\cr
  Maintainer: Tim Yates <tyates@picr.man.ac.uk>
}
\references{
  Yates T, Okoniewski MJ, Miller CJ. X:Map: annotation and visualization of genome structure for Affymetrix exon array analysis. Nucleic Acids Res. 2008 Jan;36(Database issue):D780-6. Epub 2007 Oct 11.\cr
  \url{http://nar.oxfordjournals.org/cgi/content/full/gkm779v1}
}
\keyword{ package }
\seealso{
 \code{\link{GenomicRanges}}
}

\name{annmapEnv}
\alias{annmapEnv}
\alias{annmapGetParam}
\alias{annmapSetParam}
\title{
  annmap 'env' functions
}
\description{
  Functions to access internal parameters
}
\usage{
  annmapEnv()
  annmapGetParam( key )
  annmapSetParam( ... )
}
\arguments{
  \item{ ... }{ A list of key-value parameters you wish to set. }
  \item{key}{ The key for the value you want to return. }
}
\details{
  These functions allow some access to \code{annmap}\'s configuration data. They are included to help debug database connection issues, and are not normally needed.

  On connection, a default arraytype (Affymetrix Exon arrays, where available) is specfied for the probe
  mappings. \code{arrayType} allows a different type of array to
  be specfied. This included for future compatibility.

}
\seealso{
  \code{\link{annmapTo}}\cr
  \code{\link{annmapDetails}}\cr
  \code{\link{annmapAll}}\cr
  \code{\link{annmapRange}}\cr
  \code{\link{annmapFilters}}\cr
}
\author{
  Tim Yates
  Crispin J. Miller
}
\examples{
  if(interactive()) {
    annmapEnv()
    annmapGetParam( "debug" )
    annmapConnect()
    annmapSetParam( debug=TRUE)
    annmapConnect()
    annmapSetParam( debug=FALSE)
    annmapDisconnect()
  }
}

\name{annmapDetails}
\alias{annmapDetails}
\alias{arrayDetails}
\alias{chromosomeDetails}
\alias{domainDetails}
\alias{estExonDetails}
\alias{estGeneDetails}
\alias{estTranscriptDetails}
\alias{exonDetails}
\alias{geneDetails}
\alias{predictionTranscriptDetails}
\alias{probeDetails}
\alias{probesetDetails}
\alias{proteinDetails}
\alias{synonymDetails}
\alias{transcriptDetails}
\title{
  annmap 'details' functions
}
\description{
  Get detailed annotations for the specified features.
}
\usage{
  arrayDetails( ids, as.data.frame=FALSE )
  chromosomeDetails( ids, as.data.frame=FALSE )
  domainDetails( ids, as.data.frame=FALSE )
  estExonDetails( ids, as.data.frame=FALSE )
  estGeneDetails( ids, as.data.frame=FALSE )
  estTranscriptDetails( ids, as.data.frame=FALSE )
  exonDetails( ids, as.data.frame=FALSE )
  geneDetails( ids, as.data.frame=FALSE )
  predictionTranscriptDetails( ids, as.data.frame=FALSE )
  probeDetails( ids, as.data.frame=FALSE )
  probesetDetails( ids, as.data.frame=FALSE )
  proteinDetails( ids, as.data.frame=FALSE )
  synonymDetails( ids, as.data.frame=FALSE )
  transcriptDetails( ids, as.data.frame=FALSE )
}
\arguments{
  \item{ids}{ Database identifiers for the features of interest }
  \item{as.data.frame}{ If \code{FALSE}, data will be converted to a \code{GRanges} object if possible, otherwise a \code{data.frame} }
}
\value{
  Results in an \code{\link{GRanges}} object (or a \code{data.frame} if \code{TRUE} is passed for the second parameter), one \'row\' per feature, containing detailed annotations.
}
\seealso{
  \code{\link{annmapTo}}\cr
  \code{\link{annmapAll}}\cr
  \code{\link{annmapRange}}\cr
  \code{\link{annmapUtils}}\cr
  \code{\link{annmapFilters}}\cr
  \code{\link{GRanges}}\cr
}
\author{
  Tim Yates
}
\examples{ 
  if(interactive()) {
    annmapConnect()
    geneDetails(symbolToGene("TP53"))
  }
}

\name{annmapUtr}
\alias{transcriptToUtrRange}
\alias{transcriptToUtrExon}
\alias{transcriptToCodingRange}
\alias{transcriptToCodingExon}
\alias{utrProbesets}
\alias{codingProbesets}
\alias{nonIntronicTranscriptLength}
\alias{nonIntronicGeneLength}
\title{
  annmap coding functions
}
\description{
  Functions to deal with coding regions and UTRs
}
\usage{
  transcriptToUtrRange( ids, end=c( "both", "5", "3" ), as.data.frame=FALSE, on.translation.error=stop )
  transcriptToUtrExon( ids, end=c( 'both', '5', '3' ), as.vector=FALSE, on.translation.error=stop )
  transcriptToCodingRange( ids, end=c( "both", "5", "3" ), as.data.frame=FALSE, on.translation.error=stop )
  transcriptToCodingExon( ids, end=c( 'both', '5', '3' ), as.vector=FALSE, on.translation.error=stop )
  utrProbesets( probesets, transcripts, end=c( "both", "5", "3" ), on.translation.error=stop )
  codingProbesets( probesets, transcripts, end=c( "both", "5", "3" ), on.translation.error=stop )
  nonIntronicTranscriptLength( ids, end=c( 'none', 'both', '5', '3' ), on.translation.error=stop )
  nonIntronicGeneLength( ids )
}
\arguments{
  \item{ids}{ A vector of Transcript Names, or a RangedData object of Transcripts returned from another annmap call. }
  \item{as.data.frame}{ If \code{FALSE}, data will be converted to a \code{RangedData} object if possible, otherwise a \code{data.frame} }
  \item{as.vector}{ If \code{TRUE} returns a vector of database identifiers. If \code{FALSE} returns a \code{link{GRanges}} object containing detailed annotation. }
  \item{probesets}{ An optional vector of Probeset Names, or a RangedData object of Probesets returned from another annmap call. }
  \item{transcripts}{ An optional vector of Transcript Names, or a RangedData object of Transcripts returned from another annmap call. }
  \item{end}{ Which end (\code{"both"}, \code{"3"} or \code{"5"}) of the Transcript(s) you are interested in (defaults to \code{both}). }
  \item{on.translation.error}{ A function to call with a character vector explaining the problem if one is encountered with the translation locations in the database. }
}
\details{
  The first two functions given here, \code{transcriptToUtrRange} and \code{transcriptToCodingRange} return the transcripts
  of interest, with their ranges adjusted depending on the UTR of each.

  With \code{transcriptToUtrRange}, a RangedData object is returned with the name of the transcript, the end in question, and
  the genomic location of that UTR.  If \code{both} is passed as the \code{end} parameter, then each transcript will generate up to
  two rows in the returned object.  It may return less than two rows if the \code{end} parameter is used, or if there is no UTR for the
  end specified. (A Transcript with no UTR will return zero results)

  The \code{transcriptToCodingRange} function returns the same as calling \code{transcriptDetails}, but with the start and end locations
  modified by the range of the UTR.  If \code{end} is passed, then only the UTR at this end will be taken into consideration and used to modify
  the returned location.

  The \code{transcriptToCodingExon} and \code{transcriptToUtrExon} functions return the exons for each transcript limited to only those exons (or partions thereof) which are coding or part of the UTR.

  \code{utrProbesets} and \code{codingProbesets} are functions to find or filter probesets which have probes targeting the type of region
  specified by the function name.

  A call to \code{utrProbesets} with a list of Probesets will return those probesets that have at least one probe hitting the UTR of any transcript.

  A call to \code{utrProbesets} with a list of Probesets and a list of Transcripts will return those probesets the have at least one probe
  hitting the UTR of any of the specified Transcripts.

  A call to \code{utrProbesets} with only the \code{probesets} parameter omitted, will return all probesets which have at least one probe in the UTR
  region of the specified Transcripts.

  You cannot omit both the Probesets and Transcripts parameters simultaneously.

  The \code{codingProbesets} method does the inverse of the \code{utrProbesets} function: it returns probesets having at least one probe
  in the coding region of a Transcipt (or the specified Transcripts).

  Note that the UTR of a Transcript includes the intronic UTR regions, and the coding region of a Transcript includes the
  intronic coding regions.

  This means that \code{utrProbesets} and \code{codingProbesets} can sometimes return \code{intronic} and/or \code{intergenic} probesets.
  These can be removed with a call to the appropriate filter function (see examples).
  
  All \code{unreliable} probesets are automatically removed by these functions before mapping.

  Calling \code{nonIntronicTranscriptLength} will return the length of the exons (coding can be specified via the \code{end} parameter) in a given list of transcripts.

  And \code{nonIntronicGeneLength} will give the length of all exons in a given gene when overlaps are taken into account (so two exactly overlapping exons will count once for the length)
}
\seealso{
  \code{\link{annmapTo}}\cr
  \code{\link{annmapDetails}}\cr
  \code{\link{annmapAll}}\cr
  \code{\link{annmapRange}}\cr
  \code{\link{annmapFilters}}\cr
}
\author{
  Tim Yates
}
\examples{
  if(interactive()) {
    # Only return exonic probesets hitting the UTRs of ENST00000414566
    exonic( utrProbesets( NULL, "ENST00000414566" ) )
  }
}

\name{annmapCoords}
\alias{genomeToProteinCoords}
\alias{genomeToTranscriptCoords}
\alias{proteinCoordsToGenome}
\alias{transcriptCoordsToGenome}
\title{
  annmap co-ordinate mapping functions
}
\description{
  Functions to go between Genomic, Proteomic and Transcriptual co-ordinate systems.
}
\usage{
  transcriptCoordsToGenome( transcript.ids, position=1, as.vector=FALSE, check.bounds=TRUE, truncate=TRUE, cds=FALSE )
  genomeToTranscriptCoords( position, transcript.ids, as.vector=FALSE, check.bounds=TRUE, end=c( 'none', 'both', '5', '3' ) )
  proteinCoordsToGenome( protein.ids, position=1, as.vector=FALSE, check.bounds=TRUE, truncate=TRUE )
  genomeToProteinCoords( position, protein.ids, as.vector=FALSE, check.bounds=TRUE )
}
\arguments{
  \item{transcript.ids}{ A vector of transcript.ids (or a RangedData object of transcripts returned from another annmap function)}
  \item{position}{ The position of interest (either a genomic position for both of the \code{genomeToXXXX} methods,
  or a protein or transcript sequence position for the other two methods )}
  \item{as.vector}{ Should the returned data be in the form of a vector (if \code{TRUE}) or a RangedData object (if \code{FALSE}) }
  \item{check.bounds}{ If \code{TRUE}, any postion outside the range of the protein/transcript will cause a warning to be issued and \code{NA} returned. }
  \item{end}{ Should the UTR be taken in to account when calculating the location, one of (\code{"none"}, \code{"both"}, \code{"3"} or \code{"5"}). Defaults to \code{none}. }
  \item{truncate}{ If \code{truncate=TRUE}, any lengths beyond the end of the transcript or protein will be set to the last residue}
  \item{cds}{ If \code{cds=TRUE} then only the coding exons (or sub-regions of exons that are coding) are taken in to account. }
  \item{protein.ids}{ A vector of protein.ids (or a RangedData object of proteins returned from another annmap function) }
}
\details{
  The mapping functions need to deal with mappings that fall outside a
  transcript or protein (or within an intron). When \code{as.vector=FALSE} these are
  identified as \code{NA} in the results. Since \code{RangedData} objects cannot
  represent \code{NA} or missing values, when \code{as.vector=FALSE}, all locations
  which cannot be mapped are dropped from the result.
}
\seealso{
  \code{\link{annmapTo}}\cr
  \code{\link{annmapDetails}}\cr
  \code{\link{annmapAll}}\cr
  \code{\link{annmapRange}}\cr
  \code{\link{annmapFilters}}\cr
}
\author{
  Tim Yates
}
\examples{
  if(interactive()) {
    # Get the gene for 'tp53'
    gene        = symbolToGene( 'tp53' )
    # And the transcripts for this gene
    transcripts = geneToTranscript( symbolToGene( 'tp53' ) )
    # And the proteins for this transcript
    proteins    = transcriptToProtein( transcripts )

    # get the transcript coords for the transcripts of this gene, at the start of this gene
    genomeToTranscriptCoords( start( gene ), transcripts, as.vector=TRUE )
    #Returns a vector:
    # ENST00000413465 ENST00000359597 ENST00000504290 ENST00000510385 ENST00000504937
    #            1018              NA              NA              NA              NA     
    # ENST00000269305 ENST00000455263 ENST00000420246 ENST00000445888 ENST00000396473
    #              NA              NA              NA              NA              NA     
    # ENST00000545858 ENST00000419024 ENST00000509690 ENST00000514944 ENST00000505014
    #              NA              NA              NA              NA              NA
    # ENST00000414315 ENST00000508793 ENST00000503591 
    #              NA              NA              NA

    # With as.vector=FALSE
    genomeToTranscriptCoords( start( gene ), transcripts )
    # RangedData with 1 row and 1 value column across 1 space
    #             space       ranges | coord.space
    #       <character>    <IRanges> | <character>
    # 1 ENST00000413465 [1018, 1018] |  transcript

    genomeToProteinCoords( start( gene ), proteins, as.vector=TRUE )
    # ENSP00000410739 ENSP00000352610 ENSP00000269305 ENSP00000398846 ENSP00000391127
    #             340              NA              NA              NA              NA
    # ENSP00000391478 ENSP00000379735 ENSP00000437792 ENSP00000402130 ENSP00000425104
    #              NA              NA              NA              NA              NA
    # ENSP00000423862 ENSP00000394195 ENSP00000424104 ENSP00000426252 
    #              NA              NA              NA              NA 

    # With as.vector=FALSE
    genomeToProteinCoords( start( gene ), proteins )
    # RangedData with 1 row and 2 value columns across 1 space
    #             space     ranges |     frame coord.space
    #       <character>  <IRanges> | <numeric> <character>
    # 1 ENSP00000410739 [340, 340] |         0     protein
  }
}

\name{spliceIndex}
\alias{spliceIndex}
\alias{spliceGroupIndex}
\title{
  Splice indexing
}
\description{
  Calculates the splicing index for the probesets in one or more genes, as defined in the Affymetrix white paper "Alternative Transcript Analysis Methods for Exon Arrays".
}
\usage{
  spliceGroupIndex( x, group.column, members )
  spliceIndex( x, ids, group, gps, group.index.fn=spliceGroupIndex, median.gene=FALSE, median.probeset=FALSE, unlogged=TRUE )
}
\arguments{
  \item{x}{ eSet containing expression data }
  \item{group.column}{ a column name for the group data }
  \item{members}{ a set of arrays }
  \item{ids}{ Character vector of Ensembl gene names }
  \item{group}{ If defined, the column name in the ExpressionSet's pData object in which to look for gps }
  \item{gps}{ The two sets of arrays to compare }
  \item{group.index.fn}{ a method which, when passed an ExpressionSet (from the Biobase package), a column name for the group data and a set of arrays, will return the indices of interest }
  \item{median.gene}{ Use the median instead of the mean when calculating averages across genes }
  \item{median.probeset}{ Use the median instead of the mean when calculating averages across probesets in each replicate group }
  \item{unlogged}{ Unlog the expression data before calculating the splicing index (and then re-log afterwards) }
}
\details{
    The splicing index gives a measure of the difference in expression level for each probeset
    in a gene between two sets of arrays, relative to the gene-level average in each set. This
    is calculated only for those probesets that are defined as exonic (See \code{\link{exonic}}).

    The two sets of arrays can be specified in two ways: First, by using numeric indices defining
    the appropriate columns in the expression data. This is done by supplying these as a list to
    gps (e.g. gps=list(1:3,4:6) will calculate the splicing index between arrays 1,2,3 and 4,5,6.
    Alternatively, the annotation in the phenoData object from x can be used
    (e.g. group="treatment",gps=c("a","b") will compare between the arrays labelled
    'a', and 'b' in the 'treatment' column of pData(x)).

    The implementation also calculates a p.value and t.statistic for each probeset; these are
    returned alongside the splicing index.

    By default, the splicing index is calculated using the mean across genes and samples. Specifying
    median.gene=TRUE or median.probeset=TRUE will use the median instead (for the gene or probeset
    level averages, respectively). It is calculated using the unlogged data, unless unlogged=FALSE.
    This only affects the internal calculations; values in x are always assumed to be logged, and
    the splicing index is always returned on the log2 scale.
}
\seealso{
  \code{\link{exonic}}
}
\author{
  Tim Yates
  Crispin J. Miller
}
\examples{
  if(interactive()) {
    # Loads the Expression Set into x.rma
    load( '../unitTests/HuEx-1_0.tp53.expr.RData' )
    spliceIndex( x.rma, symbolToGene( 'tp53' ), gps=list(1:3,4:6) )
  }
}

\name{annmapUtils}
\alias{annmapUtils}
\alias{annmapClearCache}
\alias{annmapConnect}
\alias{annmapDisconnect}
\alias{annmapAddConnection}
\alias{arrayType}
\alias{annmapToggleCaching}
\alias{annmapGenePlot}
\alias{annmapRangeApply}
\alias{strandAsInteger}
\alias{geneToGeneRegionTrack}
\title{
  annmap 'utils' functions
}
\description{
  Functions to connect to the database and manage the database connections. 
}
\usage{
  annmapConnect( name, use.webservice=FALSE, quiet.webservice=FALSE )
  annmapDisconnect()
  annmapAddConnection( dsname, species, version,
                       host='localhost',
                       username=as.character( Sys.info()[ 'user' ] ),
                       password='',
                       port='',
                       overwrite=FALSE,
                       testConnect=TRUE )
  arrayType( name=NULL, pick.default=FALSE, silent=FALSE )
  annmapToggleCaching()
  annmapClearCache()
  annmapRangeApply( x, f, filter=c( chr="space", start="start", end="end", strand="strand" ), coerce=c( as.character, as.numeric, as.numeric, as.numeric ), ... )
  strandAsInteger( granges )
  geneToGeneRegionTrack( genes, genome, coalesce.name=NULL, ... )
}
\arguments{
  \item{name}{ The name of the database to connect to, or the array to select. }
  \item{use.webservice}{ If \code{TRUE}, we will use the annmap webservices rather than a local MySQL installation.}
  \item{quiet.webservice}{ If \code{FALSE}, there will be output as the webservice calls are processed. Set \code{TRUE} to silence these. }
  \item{dsname}{ The name of the datasource to add or modify.}
  \item{species}{ The species of interest.}
  \item{version}{ The version of the database to connect to.}
  \item{host}{ The location of the MySQL installation.}
  \item{username}{ The username to connect to MySQL.}
  \item{password}{ The password required to connect to MySQL.}
  \item{port}{The port MySQL is running on. (Use NA for default)}
  \item{overwrite}{If another connection with this dsname already exists, should it be overwritten?}
  \item{testConnect}{If \code{TRUE}, the connection will be attempted before adding it to the databases.txt file.}
  \item{pick.default}{ If \code{TRUE}, \code{arrayType} will choose the first available arraytype for this species. }
  \item{silent}{ If \code{TRUE}, it will skip telling you which array you have selected. }
  \item{x}{A \code{\link{RangedData}} object}
  \item{f}{A function to apply to each \'row\' of the \code{\link{RangedData}} object}
  \item{filter}{Which \'columns\' of the \code{\link{RangedData}} object does the function need, and what parameters in the function do they map on to?. For example, by default, the field \'space\' gets mapped to the parameter \'chr\'.}
  \item{coerce}{What is the type of each parameter in \'f\'?}
  \item{...}{additional parameters}
  \item{granges}{A GRanges object}
  \item{genes}{ The genes you wish to load into a \code{GeneRegionTrack} they must all be on the same chromosome. }
  \item{genome}{ A valid Gviz genome, ie: \code{'hg19'}. }
  \item{coalesce.name}{ If this is a character vector, all genes will be joined into a single track with this name. Otherwise each gene will have its own track. }
}
\details{
  \code{annmapConnect} is used to establish a connection to an
  instance of the Annmap database, and  \code{annmapDisconnect} closes the connection.

  \code{arrayType} is used to specify the array you wish to use for queries based on Affymetrix probesets.

  Many of the functions in \code{annmap} cache results locally. The
  function \code{annmapToggleCaching} turns this functionality on and
  off, and  \code{annmapClearCache} can be used to clear the cache
  (this is not normally something a user needs to do).

  Note that details of how to set up the default databases, connection details, etc. Can be found in the package vignette.

  The function \code{strandAsInteger} takes a \code{GRanges} object and returns an integer vector of strands in the
  Ensembl style.  "+" becomes 1, "-" becomes -1, and "*" becomes \code{NA}.

  The function \code{geneToGeneRegionTrack} takes a list of genes (character vector, GRanges object, etc), and returns
  a list of GeneRegionTracks which can be plotted in Gviz. There is an example in the cookbook.
}
\seealso{
  \code{\link{annmapTo}}\cr
  \code{\link{annmapDetails}}\cr
  \code{\link{annmapAll}}\cr
  \code{\link{annmapRange}}\cr
  \code{\link{annmapFilters}}\cr
}
\author{
  Tim Yates
  Crispin J. Miller
}
\examples{
  if(interactive()) {
    annmapConnect()
    annmapToggleCaching()
    annmapToggleCaching()

    annmapRangeApply(symbolToGene("TP53",as.vector=FALSE),probeInRange)

    #NOTE: since the next function empties out the local cache, don't
    #run it unless you want to do this!
    #annmapClearCache()
 }
}
